import "GaranStuff.MoorMap.ColorPicker"
-- need to create the options window
OptionsWindow = class(Turbine.UI.Lotro.Window);
function OptionsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetText(Resource[language][3]);
	self:SetVisible(false);
	self:SetSize(540,470);
	self:SetPosition((Turbine.UI.Display:GetWidth() - self:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - self:GetHeight()) / 2);

	self.HadErrors=false;
	self.OptionsPanel=Turbine.UI.Control();
	self.OptionsPanel:SetParent(self);
	self.OptionsPanel:SetSize(self:GetWidth()-30,self:GetHeight()-80);
	self.OptionsPanel:SetPosition(15,40);
	self.OptionsPanel:SetBackColor(backColor);

	self.OptionsCaption=Turbine.UI.Label();
	self.OptionsCaption:SetParent(self.OptionsPanel);
	self.OptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.OptionsCaption:SetForeColor(headingsColor);
	self.OptionsCaption:SetSize(self.OptionsPanel:GetWidth(),20);
	self.OptionsCaption:SetPosition(0,0);
	self.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.OptionsCaption:SetText(Resource[language][4]..":");

	self.LanguageCaption=Turbine.UI.Label();
	self.LanguageCaption:SetParent(self.OptionsPanel);
	self.LanguageCaption:SetPosition(10,self.OptionsCaption:GetTop()+self.OptionsCaption:GetHeight()+9);
	self.LanguageCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.LanguageCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.LanguageCaption:SetForeColor(fontColor);
	self.LanguageCaption:SetText(Resource[language][5]..":");

	self.LanguageList=GaranStuff.MoorMap.DropDownList();
	self.LanguageList:SetParent(self.OptionsPanel);
	self.LanguageList:SetPosition(self.LanguageCaption:GetLeft()+self.LanguageCaption:GetWidth()+2,self.LanguageCaption.GetTop()-3);
	self.LanguageList:SetSize(self.OptionsPanel:GetWidth()-(self.LanguageCaption:GetWidth()+self.LanguageCaption:GetLeft())-65,20);
	self.LanguageList:SetBorderColor(trimColor);
	self.LanguageList:SetBackColor(backColor);
	self.LanguageList:SetCurrentBackColor(backColor);
	self.LanguageList:SetDropRows(5);

	local tmpLanguage;
	for tmpLanguage in pairs(Resource) do
		self.LanguageList:AddItem(Resource[tmpLanguage][1],tmpLanguage);
	end

	self.LanguageList.SelectedIndexChanged = function ()
		self:SetLanguage(self.LanguageList:GetValue());
	end

	self.WorldCaption=Turbine.UI.Label();
	self.WorldCaption:SetParent(self.OptionsPanel);
	self.WorldCaption:SetPosition(10,self.LanguageCaption:GetTop()+self.LanguageCaption:GetHeight()+9);
	self.WorldCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.WorldCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.WorldCaption:SetForeColor(fontColor);
	self.WorldCaption:SetText(Resource[language][149]..":");

	self.WorldList=GaranStuff.MoorMap.DropDownList();
	self.WorldList:SetParent(self.OptionsPanel);
	self.WorldList:SetPosition(self.WorldCaption:GetLeft()+self.WorldCaption:GetWidth()+2,self.WorldCaption.GetTop()-3);
	self.WorldList:SetSize(self.OptionsPanel:GetWidth()-(self.WorldCaption:GetWidth()+self.WorldCaption:GetLeft())-65,20);
	self.WorldList:SetBorderColor(trimColor);
	self.WorldList:SetBackColor(backColor);
	self.WorldList:SetCurrentBackColor(backColor);
	self.WorldList:SetDropRows(5);

	self.WorldList:AddItem("Arkenstone","Arkenstone");
	self.WorldList:AddItem("Brandywine","Brandywine");
	self.WorldList:AddItem("Crickhollow","Crickhollow");
	self.WorldList:AddItem("Dwarrowdelf","Dwarrowdelf");
	self.WorldList:AddItem("Elendilmir","Elendilmir");
	self.WorldList:AddItem("Firefoot","Firefoot");
	self.WorldList:AddItem("Gladden","Gladden");
	self.WorldList:AddItem("Imladris","Imladris");
	self.WorldList:AddItem("Landroval","Landroval");
	self.WorldList:AddItem("Meneldor","Meneldor");
	self.WorldList:AddItem("Nimrodel","Nimrodel");
	self.WorldList:AddItem("Riddermark","Riddermark");
	self.WorldList:AddItem("Silverlode","Silverlode");
	self.WorldList:AddItem("Vilya","Vilya");
	self.WorldList:AddItem("Windfola","Windfola");
	self.WorldList:AddItem("[DE] Anduin","_DE_Anduin");
	self.WorldList:AddItem("[DE] Gwaihir","_DE_Gwaihir");
	self.WorldList:AddItem("[DE] Maiar","_DE_Maiar");
	self.WorldList:AddItem("[DE] Morthond","_DE_Morthond");
	self.WorldList:AddItem("[DE] Vanyar","_DE_Vanyar");
	self.WorldList:AddItem("[DE-RP] Belegaer","_DE_RP_Belegaer");
	self.WorldList:AddItem("[EN] Eldar","_EN_Eldar");
	self.WorldList:AddItem("[EN] Evernight","_EN_Evernight");
	self.WorldList:AddItem("[EN] Gilrain","_EN_Gilrain");
	self.WorldList:AddItem("[EN] Snowbourn","_EN_Snowbourn");
	self.WorldList:AddItem("[EN] Withywindle","_EN_Withywindle");
	self.WorldList:AddItem("[EN-RP] Laurelin","_EN_RP_Laurelin");
	self.WorldList:AddItem("[FR] Sirannon","_FR_Sirannon");
	self.WorldList:AddItem("[FR-RP] Estel","_FR_RP_Estel");


-- trim color
	self.TrimCaption=Turbine.UI.Label();
	self.TrimCaption:SetParent(self.OptionsPanel);
	self.TrimCaption:SetPosition(10,self.WorldCaption:GetTop()+self.WorldCaption:GetHeight()+9);
	self.TrimCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.TrimCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.TrimCaption:SetForeColor(fontColor);
	self.TrimCaption:SetText(Resource[language][6]..":");
	self.TrimColor=GaranStuff.MoorMap.ColorPicker();
	self.TrimColor:SetParent(self.OptionsPanel);
	self.TrimColor:SetPosition(self.TrimCaption:GetLeft()+self.TrimCaption:GetWidth()+5,self.TrimCaption:GetTop()-1);
	self.TrimColor:SetTrimColor(trimColor);
	self.TrimColor:SetColor(trimColor);
	self.TrimColor.ColorChanged=function()
		self:SetTrimColor(self.TrimColor:GetColor());
	end

	self.BackCaption=Turbine.UI.Label();
	self.BackCaption:SetParent(self.OptionsPanel);
	self.BackCaption:SetPosition(10,self.TrimColor:GetTop()+self.TrimColor:GetHeight()+9);
	self.BackCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.BackCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.BackCaption:SetForeColor(fontColor);
	self.BackCaption:SetText(Resource[language][7]..":");
	self.BackColor=GaranStuff.MoorMap.ColorPicker();
	self.BackColor:SetParent(self.OptionsPanel);
	self.BackColor:SetPosition(self.BackCaption:GetLeft()+self.BackCaption:GetWidth()+5,self.BackCaption:GetTop()-1);
	self.BackColor:SetTrimColor(trimColor);
	self.BackColor:SetColor(backColor);
	self.BackColor.ColorChanged=function()
		self:SetBackColor(self.BackColor:GetColor());
	end

	self.FontCaption=Turbine.UI.Label();
	self.FontCaption:SetParent(self.OptionsPanel);
	self.FontCaption:SetPosition(10,self.BackColor:GetTop()+self.BackColor:GetHeight()+9);
	self.FontCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.FontCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FontCaption:SetForeColor(fontColor);
	self.FontCaption:SetText(Resource[language][8]..":"); --"Font Color:");
	self.FontColor=GaranStuff.MoorMap.ColorPicker();
	self.FontColor:SetParent(self.OptionsPanel);
	self.FontColor:SetPosition(self.FontCaption:GetLeft()+self.FontCaption:GetWidth()+5,self.FontCaption:GetTop()-1);
	self.FontColor:SetTrimColor(trimColor);
	self.FontColor:SetColor(fontColor);
	self.FontColor.ColorChanged=function()
		self:SetFontColor(self.FontColor:GetColor());
	end

	self.HeadingsCaption=Turbine.UI.Label();
	self.HeadingsCaption:SetParent(self.OptionsPanel);
	self.HeadingsCaption:SetPosition(10,self.FontColor:GetTop()+self.FontColor:GetHeight()+9);
	self.HeadingsCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.HeadingsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.HeadingsCaption:SetForeColor(fontColor);
	self.HeadingsCaption:SetText(Resource[language][15]..":");
	self.HeadingsColor=GaranStuff.MoorMap.ColorPicker();
	self.HeadingsColor:SetParent(self.OptionsPanel);
	self.HeadingsColor:SetPosition(self.HeadingsCaption:GetLeft()+self.HeadingsCaption:GetWidth()+5,self.HeadingsCaption:GetTop()-1);
	self.HeadingsColor:SetTrimColor(trimColor);
	self.HeadingsColor:SetColor(headingsColor);
	self.HeadingsColor.ColorChanged=function()
		self:SetHeadingsColor(self.HeadingsColor:GetColor());
	end

	self.ListTextCaption=Turbine.UI.Label();
	self.ListTextCaption:SetParent(self.OptionsPanel);
	self.ListTextCaption:SetPosition(10,self.HeadingsColor:GetTop()+self.HeadingsColor:GetHeight()+9);
	self.ListTextCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.ListTextCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ListTextCaption:SetForeColor(fontColor);
	self.ListTextCaption:SetText(Resource[language][16]..":");
	self.ListTextColor=GaranStuff.MoorMap.ColorPicker();
	self.ListTextColor:SetParent(self.OptionsPanel);
	self.ListTextColor:SetPosition(self.ListTextCaption:GetLeft()+self.ListTextCaption:GetWidth()+5,self.ListTextCaption:GetTop()-1);
	self.ListTextColor:SetTrimColor(trimColor);
	self.ListTextColor:SetColor(listTextColor);
	self.ListTextColor.ColorChanged=function()
		self:SetListTextColor(self.ListTextColor:GetColor());
	end

	self.ResetColors=Turbine.UI.Lotro.Button();
	self.ResetColors:SetParent(self.OptionsPanel);
	self.ResetColors:SetSize(160,20);
	self.ResetColors:SetPosition((self.OptionsPanel:GetWidth()-self.ResetColors:GetWidth())/2,self.ListTextColor:GetTop()+self.ListTextColor:GetHeight()+9);
	self.ResetColors:SetText(Resource[language][9]);
	self.ResetColors.Click=function()
		trimColor=Turbine.UI.Color(.2,.5,.9);
		fontColor=Turbine.UI.Color(1,.9,.5);
		backColor=Turbine.UI.Color(.05,.05,.05);
		headingsColor=Turbine.UI.Color(1,1,1);
		listTextColor=Turbine.UI.Color(1,1,1);
		self.TrimColor:SetColor(trimColor);
		self.FontColor:SetColor(fontColor);
		self.BackColor:SetColor(backColor);
		self.HeadingsColor:SetColor(headingsColor);
		self.ListTextColor:SetColor(listTextColor);
	end

	self.OpacityCaption=Turbine.UI.Label();
	self.OpacityCaption:SetParent(self.OptionsPanel);
	self.OpacityCaption:SetPosition(10,self.ResetColors:GetTop()+self.ResetColors:GetHeight()+9);
	self.OpacityCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.OpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.OpacityCaption:SetForeColor(fontColor);
	self.OpacityCaption:SetText(Resource[language][71]..":");
	self.OpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	self.OpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.OpacityScrollbar:SetParent(self.OptionsPanel)
	self.OpacityScrollbar:SetPosition(self.OpacityCaption:GetLeft()+self.OpacityCaption:GetWidth()+5,self.OpacityCaption:GetTop());
	self.OpacityScrollbar:SetSize(self.OptionsPanel:GetWidth()-self.OpacityCaption:GetWidth()-self.OpacityCaption:GetLeft()-15,10);
	self.OpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	self.OpacityScrollbar:SetMinimum(0);
	self.OpacityScrollbar:SetMaximum(100);
	self.OpacityScrollbar.OriginalValue=100;
	self.OpacityScrollbar.ValueChanged=function()
		mapWindow.Map:SetOpacity(self.OpacityScrollbar:GetValue()/100);
	end

-- **** There's a MAJOR BUG with checkboxes, they don't always change Checked value when you click IN the box, only on the label :(
-- so we implement the base checkbox class and provide our own image that we can forward mouse clicks on to here...
-- yeah, it's hokey, but it works as a place holder until Turbine fixes their Checkboxes


-- Load Minimized
	self.LoadMinimizedCB=Turbine.UI.Lotro.CheckBox();
	self.LoadMinimizedCB:SetParent(self.OptionsPanel);
	self.LoadMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.LoadMinimizedCB:SetForeColor(fontColor);
	self.LoadMinimizedCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.LoadMinimizedCB:SetPosition(10,self.OpacityCaption:GetTop()+self.OpacityCaption:GetHeight()+4);
	self.LoadMinimizedCB:SetText(Resource[language][17]);

	self.LMCBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.LMCBIcon:SetParent(self.OptionsPanel);
	self.LMCBIcon:SetSize(self.LoadMinimizedCB:GetSize());
	self.LMCBIcon:SetPosition(self.LoadMinimizedCB:GetPosition());
	self.LMCBIcon.MouseClick=function()
		self.LoadMinimizedCB:SetChecked(not self.LoadMinimizedCB:IsChecked());
	end
	self.LMCBIcon:SetZOrder(self.LoadMinimizedCB:GetZOrder()+1);

-- Show Icon when Minimized
	self.ShowIconWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
	self.ShowIconWhenMinimizedCB:SetParent(self.OptionsPanel);
	self.ShowIconWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ShowIconWhenMinimizedCB:SetForeColor(fontColor);
	self.ShowIconWhenMinimizedCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.ShowIconWhenMinimizedCB:SetPosition(10,self.LoadMinimizedCB:GetTop()+self.LoadMinimizedCB:GetHeight()+4);
	self.ShowIconWhenMinimizedCB:SetText(Resource[language][18]);

	self.SIWMCBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.SIWMCBIcon:SetParent(self.OptionsPanel);
	self.SIWMCBIcon:SetSize(self.ShowIconWhenMinimizedCB:GetSize());
	self.SIWMCBIcon:SetPosition(self.ShowIconWhenMinimizedCB:GetPosition());
	self.SIWMCBIcon.MouseClick=function()
		self.ShowIconWhenMinimizedCB:SetChecked(not self.ShowIconWhenMinimizedCB:IsChecked());
	end
	self.SIWMCBIcon:SetZOrder(self.ShowIconWhenMinimizedCB:GetZOrder()+1);

-- Show Quick Annotation control
	self.ShowQuickAnnotCB=Turbine.UI.Lotro.CheckBox();
	self.ShowQuickAnnotCB:SetParent(self.OptionsPanel);
	self.ShowQuickAnnotCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ShowQuickAnnotCB:SetForeColor(fontColor);
	self.ShowQuickAnnotCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.ShowQuickAnnotCB:SetPosition(10,self.ShowIconWhenMinimizedCB:GetTop()+self.ShowIconWhenMinimizedCB:GetHeight()+4);
	self.ShowQuickAnnotCB:SetText(Resource[language][160]);

	self.SQACBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.SQACBIcon:SetParent(self.OptionsPanel);
	self.SQACBIcon:SetSize(self.ShowQuickAnnotCB:GetSize());
	self.SQACBIcon:SetPosition(self.ShowQuickAnnotCB:GetPosition());
	self.SQACBIcon.MouseClick=function()
		self.ShowQuickAnnotCB:SetChecked(not self.ShowQuickAnnotCB:IsChecked());
	end
	self.SQACBIcon:SetZOrder(self.ShowQuickAnnotCB:GetZOrder()+1);

	self.QAOpacityCaption=Turbine.UI.Label();
	self.QAOpacityCaption:SetParent(self.OptionsPanel);
	self.QAOpacityCaption:SetPosition(10,self.ShowQuickAnnotCB:GetTop()+self.ShowQuickAnnotCB:GetHeight()+9);
	self.QAOpacityCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.QAOpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.QAOpacityCaption:SetForeColor(fontColor);
	self.QAOpacityCaption:SetText(Resource[language][161]..":");
	self.QAOpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	self.QAOpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.QAOpacityScrollbar:SetParent(self.OptionsPanel)
	self.QAOpacityScrollbar:SetPosition(self.QAOpacityCaption:GetLeft()+self.QAOpacityCaption:GetWidth()+5,self.QAOpacityCaption:GetTop());
	self.QAOpacityScrollbar:SetSize(self.OptionsPanel:GetWidth()-self.QAOpacityCaption:GetWidth()-self.QAOpacityCaption:GetLeft()-15,10);
	self.QAOpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	self.QAOpacityScrollbar:SetMinimum(0);
	self.QAOpacityScrollbar:SetMaximum(100);
	self.QAOpacityScrollbar.OriginalValue=15;
	self.QAOpacityScrollbar.ValueChanged=function()
		quickWindow:SetOpacity(self.QAOpacityScrollbar:GetValue()/100);
	end

-- Other Options ?
	self.DebugCB=Turbine.UI.Lotro.CheckBox();
	self.DebugCB:SetParent(self.OptionsPanel);
	self.DebugCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DebugCB:SetForeColor(fontColor);
	self.DebugCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.DebugCB:SetPosition(10,self.QAOpacityCaption:GetTop()+self.QAOpacityCaption:GetHeight()+4);
	self.DebugCB:SetText("Debug");

	self.DebugIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.DebugIcon:SetParent(self.OptionsPanel);
	self.DebugIcon:SetSize(self.DebugCB:GetSize());
	self.DebugIcon:SetPosition(self.DebugCB:GetPosition());
	self.DebugIcon.MouseClick=function()
		self.DebugCB:SetChecked(not self.DebugCB:IsChecked());
	end
	self.DebugIcon:SetZOrder(self.DebugCB:GetZOrder()+1);

--** SAVE AND CANCEL
	self.SaveButton=Turbine.UI.Lotro.Button();
	self.SaveButton:SetParent(self);
	self.SaveButton:SetSize(100,20);
	self.SaveButton:SetPosition(20,self:GetHeight()-40);
	self.SaveButton:SetText(Resource[language][11]);
	self.SaveButton.Click=function()
		local hasError=false;
		-- validate option values

		if hasError then
			self.ErrorLabel:SetVisible(true);
			self.HadErrors=true;
			self.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			self:SetWantsUpdates(true);
		else
			debug=self.DebugCB:IsChecked();
			rb=self.LoadMinimizedCB:IsChecked();
			mapWindow:SetLoadMinimized(rb);
			rb=self.ShowIconWhenMinimizedCB:IsChecked();
			mapWindow:SetShowIconWhenMinimized(rb);
			quickWindow.Displayed=self.ShowQuickAnnotCB:IsChecked();
			quickWindow:SetVisible(quickWindow.Displayed);
			quickWindow.Opacity=self.QAOpacityScrollbar:GetValue()/100;

			fontColor=self.FontColor:GetColor();
			trimColor=self.TrimColor:GetColor();
			backColor=self.BackColor:GetColor();
			headingsColor=self.HeadingsColor:GetColor();
			listTextColor=self.ListTextColor:GetColor();

			local newLanguage=self.LanguageList:GetValue();

			mapWindow:SetFontColor();
			mapWindow:SetTrimColor();
			mapWindow:SetBackColor();
			mapWindow:SetHeadingsColor();
			mapWindow:SetLanguage();
			mapWindow:SetListTextColor();
			self:SetVisible(false);
			local newWorldName=self.WorldList:GetValue();
			if newLanguage~=language or (worldName~=newWorldName and mapWindow.CurrentMapID==1) then
				language=newLanguage;
				worldName=newWorldName;
				mapWindow.PreserveMapID=true;
				-- load the plugin that will unload and reload this plugin (we can only read the annotation files without a 15 second delay while we are "loading")
				Turbine.PluginManager.LoadPlugin("MoorMapLoader");
			else
				worldName=newWorldName;
				annotWindow:SetLanguage();
				annotWindow:LoadAnnotationList(); -- force reload of the translated values
				mapWindow.Map.IconSearch.OldText=tostring(mapWindow.Map.IconSearch.OldText).."X"; -- any change to the old text will force a refresh in case there was a filter applied
				mapWindow.NeedsRefresh=true;
				mapWindow:SetWantsUpdates(true); -- will reload all map components, including icon search list
			end
		end
	end

	self.CancelButton=Turbine.UI.Lotro.Button();
	self.CancelButton:SetParent(self);
	self.CancelButton:SetSize(100,20);
	self.CancelButton:SetPosition(self:GetWidth()-20-self.CancelButton:GetWidth(),self:GetHeight()-40);
	self.CancelButton:SetText(Resource[language][12]);
	self.CancelButton.Click=function()
		mapWindow.Map:SetOpacity(self.OpacityScrollbar.OriginalValue);
		quickWindow:SetOpacity(self.QAOpacityScrollbar.OriginalValue);
		self.FontColor:SetColor(fontColor);
		self.TrimColor:SetColor(trimColor);
		self.BackColor:SetColor(backColor);
		self.HeadingsColor:SetColor(headingsColor);
		self:SetVisible(false);
	end

	self.ErrorLabel=Turbine.UI.Label();
	self.ErrorLabel:SetParent(self);
	self.ErrorLabel:SetText("Adjusted Invalid Values")
	self.ErrorLabel:SetPosition(self.SaveButton:GetLeft()+self.SaveButton:GetWidth(),self.SaveButton:GetTop());
	self.ErrorLabel:SetSize(self.CancelButton:GetLeft()-(self.ErrorLabel:GetLeft()),self.SaveButton:GetHeight());
	self.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	self.ErrorLabel:SetVisible(false);
	self.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	self.WorldList:SetZOrder(self.ErrorLabel:GetZOrder()+1);
	self.LanguageList:SetZOrder(self.WorldList:GetZOrder()+1);

	self.VisibleChanged=function(sender,args)
		if self:IsVisible() then
			-- refresh the options status to reflect current values
			self.OpacityScrollbar:SetValue(math.floor(mapWindow.Map:GetOpacity()*100));
			self.OpacityScrollbar.OriginalValue=mapWindow.Map:GetOpacity();
			self.QAOpacityScrollbar:SetValue(math.floor(quickWindow:GetOpacity()*100));
			self.QAOpacityScrollbar.OriginalValue=quickWindow:GetOpacity();
			self.LoadMinimizedCB:SetChecked(mapWindow:GetLoadMinimized());
			self.ShowIconWhenMinimizedCB:SetChecked(mapWindow:GetShowIconWhenMinimized());
			self.ShowQuickAnnotCB:SetChecked(quickWindow.Displayed);
			self.DebugCB:SetChecked(debug);

			local index;
			for index=1,self.LanguageList.ListData:GetItemCount() do
				if self.LanguageList.ListData:GetItem(index):GetValue()==language then
					self.LanguageList:SetSelectedIndex(index);
					break;
				end
			end
			for index=1,self.WorldList.ListData:GetItemCount() do
				if self.WorldList.ListData:GetItem(index).DataValue==worldName then
					self.WorldList:SetSelectedIndex(index);
					break;
				end
			end
			self:SetLanguage(language);
		end
	end
	self.Update=function(sender,args)
		if self.HadErrors then
			if Turbine.Engine:GetGameTime()>self.ErrorFadeTime then
				self:SetWantsUpdates(false);
				self.ErrorLabel:SetVisible(false);
				self.HadErrors=false
			end
		end
	end
	self.SetTrimColor=function(sender,color)
		self.LanguageList:SetBorderColor(color);
		self.FontColor:SetTrimColor(color);
		self.TrimColor:SetTrimColor(color);
		self.BackColor:SetTrimColor(color);
		self.HeadingsColor:SetTrimColor(color);
		self.ListTextColor:SetTrimColor(color);
	end
	self.SetBackColor=function(sender,color)
		self.LanguageList:SetBackColor(color);
		self.LanguageList:SetCurrentBackColor(color);
		self.OptionsPanel:SetBackColor(color);
		self.FontColor:SetBackColor(color);
		self.TrimColor:SetBackColor(color);
		self.BackColor:SetBackColor(color);
		self.HeadingsColor:SetBackColor(color);
		self.ListTextColor:SetBackColor(color);
	end
	self.SetFontColor=function(sender,color)
		self.LanguageCaption:SetForeColor(color);
		self.WorldCaption:SetForeColor(color);
		self.LoadMinimizedCB:SetForeColor(color);
		self.ShowIconWhenMinimizedCB:SetForeColor(color);
		self.TrimCaption:SetForeColor(color);
		self.FontCaption:SetForeColor(color);
		self.BackCaption:SetForeColor(color);
		self.HeadingsCaption:SetForeColor(color);
		self.ListTextCaption:SetForeColor(color);
		self.OpacityCaption:SetForeColor(color);
	end
	self.SetHeadingsColor=function(sender,color)
		self.OptionsCaption:SetForeColor(color);
	end
	self.SetListTextColor=function(sender,color)
		self.LanguageList:SetTextColor(color);
	end

	self.SetLanguage=function(sender,tmpLanguage)
		self:SetText(Resource[tmpLanguage][3]);
		self.OptionsCaption:SetText(Resource[tmpLanguage][4]..":");
		self.LanguageCaption:SetText(Resource[tmpLanguage][5]..":");
		self.WorldCaption:SetText(Resource[tmpLanguage][149]..":");
		self.TrimCaption:SetText(Resource[tmpLanguage][6]..":");
		self.BackCaption:SetText(Resource[tmpLanguage][7]..":");
		self.FontCaption:SetText(Resource[tmpLanguage][8]..":");
		self.HeadingsCaption:SetText(Resource[tmpLanguage][15]..":");
		self.ListTextCaption:SetText(Resource[tmpLanguage][16]..":");
		self.ResetColors:SetText(Resource[tmpLanguage][9]);
		self.OpacityCaption:SetText(Resource[tmpLanguage][71]..":");

		self.LoadMinimizedCB:SetText(Resource[tmpLanguage][17]);
		self.ShowIconWhenMinimizedCB:SetText(Resource[tmpLanguage][18]);
		self.ShowQuickAnnotCB:SetText(Resource[tmpLanguage][160]);
		self.QAOpacityCaption:SetText(Resource[tmpLanguage][161]..":");

		self.SaveButton:SetText(Resource[tmpLanguage][11]);
		self.CancelButton:SetText(Resource[tmpLanguage][12]);
	end
end
