-- to do


-- add standard icons to annotation maintenance ? hmmm. not sure

-- foreign language support, need french and german translations of String.lua, especially the EXACT map names from the client


import "GaranStuff.MoorMap.Class";
import "GaranStuff.MoorMap.VindarPatch";
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import "GaranStuff.MoorMap.Strings";
import "GaranStuff.MoorMap.Table";
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "GaranStuff.MoorMap.DropDownList";
import "GaranStuff.MoorMap.OptionsWindow";
import "GaranStuff.MoorMap.AnnotationsWindow";
import "GaranStuff.MoorMap.MinimizedWindow";
import "GaranStuff.MoorMap.PopUpDialog";
import "GaranStuff.MoorMap.RadioButtonGroup";

language=1;
debug=false;
debugSetting=PatchDataLoad( Turbine.DataScope.Account, "MM_Debug");
if debugSetting~=nil then
	debug=debugSetting;
end
NumCustomAnnot=0;
NumDefaultAnnot=0;
LoadedMapID=1;

colorGold=Turbine.UI.Color(.80,.60,.1);
colorSilver=Turbine.UI.Color(.75,.75,.75);
colorDarkGrey=Turbine.UI.Color(.1,.1,.1);

trimColor=Turbine.UI.Color(.2,.5,.9);
fontColor=Turbine.UI.Color(1,.9,.5);
backColor=Turbine.UI.Color(.05,.05,.05);
headingsColor=Turbine.UI.Color(1,1,1);
listTextColor=Turbine.UI.Color(1,1,1);

fontFace=Turbine.UI.Lotro.Font.TrajanPro14;
dataLoadError=false;
saveSettings=true;
priorDataVersion=nil;
worldName="Landroval";

euroFormat=(tonumber("1,000")==1);
locale=Turbine.Engine.GetLocale(); -- seems to always return "en" regardless of which client is running, so it is probably picking up the OS setting. Unfortunately, that is useless :(
localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
currentCharacterName=string.gsub(localPlayer:GetName(),"~","_");
undefinedCategoryIndex=1;
loadingDefaults=0;

annotations={};
mapStrings={};
-- all annotations have the form:{Map ID, X, Y, Z, H, V, Icon (either resourceID or path), Type, TextID, Description}
-- Annotation Type follows the Map Filter types plus the Creep specific "Map In"
-- TextID is only valid for the defaults and will allow using the appropriately translated text value from Resource
mapInfo={};
-- mapInfo is in the form {MapName,Height,Width,HFactor,HOffset,WFactor,WOffset}
-- HFactor and HOffset are used in the conversion from map coordinates to pixels: X=Height*HFactor+HOffset will convert coordinate "Height" to pixel "X"

iconInfo={};

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

function UnloadPlugin()
	mapWindow:SetPluginUnloading(true);
	if saveSettings then -- if there were errors loading data, the user can choose to abort saving as it would destroy their prior data
		SaveData();
	end

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	mapWindow:RemoveShellCommands();
	mapWindow.MouseClick=nil;

	if not mapWindow.PreserveMapID then
		Turbine.Shell.WriteLine("MoorMap "..Plugins["MoorMap"]:GetVersion()..Resource[language][10]);
	end
end

function SaveData()

	PatchDataSave( Turbine.DataScope.Account, "MM_Debug", debug );
	local settings={};
	local tmpIndex;
	local tmpCustAnnot={};
	local tmpMapID;
	local tmpCustAnnotID;
	local tmpSubIndex;
	settings[#settings+1]={"MapTop",mapWindow:GetTop()};
	settings[#settings+1]={"MapLeft",mapWindow:GetLeft()};
	settings[#settings+1]={"MapHeight",mapWindow:GetHeight()};
	settings[#settings+1]={"MapWidth",mapWindow:GetWidth()};
	settings[#settings+1]={"MapOpacity",mapWindow.Map:GetOpacity()};
	settings[#settings+1]={"DataVersion",Plugins["MoorMap"]:GetVersion()};

	settings[#settings+1]={"IconTop",minWindow:GetTop()};
	settings[#settings+1]={"IconLeft",minWindow:GetLeft()};

	settings[#settings+1]={"fontColor",fontColor};
	settings[#settings+1]={"trimColor",trimColor};
	settings[#settings+1]={"backColor",backColor};
	settings[#settings+1]={"headingsColor",headingsColor};
	settings[#settings+1]={"listTextColor",listTextColor};
	settings[#settings+1]={"loadMinimized",mapWindow:GetLoadMinimized()};
	settings[#settings+1]={"language",language};
	settings[#settings+1]={"showIconWhenMinimized",mapWindow:GetShowIconWhenMinimized()};
	settings[#settings+1]={"worldName",worldName};
	settings[#settings+1]={"euroFormat",euroFormat};
	settings[#settings+1]={"filterMainDefault",mapWindow.FilterMainDefault};
	settings[#settings+1]={"filterSecondaryDefault",mapWindow.FilterSecondaryDefault};
	settings[#settings+1]={"filterBaseDefault",mapWindow.FilterBaseDefault};
	settings[#settings+1]={"filterOutpostDefault",mapWindow.FilterOutpostDefault};
	settings[#settings+1]={"filterFortDefault",mapWindow.FilterFortDefault};
	settings[#settings+1]={"filterPOIDefault",mapWindow.FilterPOIDefault};
	settings[#settings+1]={"filterRezDefault",mapWindow.FilterRezDefault};
	settings[#settings+1]={"filterMapDefault",mapWindow.FilterMapDefault};
	settings[#settings+1]={"filterNPCDefault",mapWindow.FilterNPCDefault};
	settings[#settings+1]={"filterCookDefault",mapWindow.FilterCookDefault};
	settings[#settings+1]={"filterScholarIngredientDefault",mapWindow.FilterScholarIngredientDefault};
	settings[#settings+1]={"filterAuctioneerDefault",mapWindow.FilterAuctioneerDefault};
	settings[#settings+1]={"filterBarberDefault",mapWindow.FilterBarberDefault};
	settings[#settings+1]={"filterBardDefault",mapWindow.FilterBardDefault};
	settings[#settings+1]={"filterCampSiteDefault",mapWindow.FilterCampSiteDefault};
	settings[#settings+1]={"filterCraftSiteDefault",mapWindow.FilterCraftSiteDefault};
	settings[#settings+1]={"filterCraftVendorDefault",mapWindow.FilterCraftVendorDefault};
	settings[#settings+1]={"filterFactionRepDefault",mapWindow.FilterFactionRepDefault};
	settings[#settings+1]={"filterItemMasterDefault",mapWindow.FilterItemMasterDefault};
	settings[#settings+1]={"filterMailboxDefault",mapWindow.FilterMailboxDefault};
	settings[#settings+1]={"filterMilestoneDefault",mapWindow.FilterMilestoneDefault};
	settings[#settings+1]={"filterMusteringHornDefault",mapWindow.FilterMusteringHornDefault};
	settings[#settings+1]={"filterReflectingPoolDefault",mapWindow.FilterReflectingPoolDefault};
	settings[#settings+1]={"filterSettlementDefault",mapWindow.FilterSettlementDefault};
	settings[#settings+1]={"filterStableMasterDefault",mapWindow.FilterStableMasterDefault};
	settings[#settings+1]={"filterTownCrierDefault",mapWindow.FilterTownCrierDefault};
	settings[#settings+1]={"filterTraderDefault",mapWindow.FilterTraderDefault};
	settings[#settings+1]={"filterTrainerDefault",mapWindow.FilterTrainerDefault};
	settings[#settings+1]={"filterVaultKeeperDefault",mapWindow.FilterVaultKeeperDefault};
	settings[#settings+1]={"filterVendorDefault",mapWindow.FilterVendorDefault};
	settings[#settings+1]={"filterSkirmishCampDefault",mapWindow.FilterSkirmishCampDefault};
	settings[#settings+1]={"filterOreNodeDefault",mapWindow.FilterOreNodeDefault};
	settings[#settings+1]={"filterWoodNodeDefault",mapWindow.FilterWoodNodeDefault};
	settings[#settings+1]={"filterScholarNodeDefault",mapWindow.FilterScholarNodeDefault};
	settings[#settings+1]={"filterDungeonDefault",mapWindow.FilterDungeonDefault};

	settings[#settings+1]={"quickWindow.Top",quickWindow:GetTop()};
	settings[#settings+1]={"quickWindow.Left",quickWindow:GetLeft()};
	settings[#settings+1]={"quickWindow.Displayed",quickWindow.Displayed};
	settings[#settings+1]={"quickWindow.Opacity",quickWindow.Opacity};

	if mapWindow.PreserveMapID==true then
		-- we're changing maps, save the new mapID and the search/filter settings
		if mapWindow.CurrentMapID~=nil then
			settings[#settings+1]={"currentMapID", mapWindow.CurrentMapID};
		end
		settings[#settings+1]={"filterAllegianceCreep", mapWindow.FilterPanel.AllegianceCreep:IsChecked()};
		settings[#settings+1]={"filterAllegianceFreep", mapWindow.FilterPanel.AllegianceFreep:IsChecked()};
		settings[#settings+1]={"filterAllegianceDelving", mapWindow.FilterPanel.AllegianceDelving:IsChecked()};
		settings[#settings+1]={"filterTypeMain", mapWindow.FilterPanel.TypeMain:IsChecked()};
		settings[#settings+1]={"filterTypeSecondary", mapWindow.FilterPanel.TypeSecondary:IsChecked()};
		settings[#settings+1]={"filterTypeBase", mapWindow.FilterPanel.TypeBase:IsChecked()};
		settings[#settings+1]={"filterTypeOutpost", mapWindow.FilterPanel.TypeOutpost:IsChecked()};
		settings[#settings+1]={"filterTypePOI", mapWindow.FilterPanel.TypePOI:IsChecked()};
		settings[#settings+1]={"filterTypeFort", mapWindow.FilterPanel.TypeFort:IsChecked()};
		settings[#settings+1]={"filterTypeRez", mapWindow.FilterPanel.TypeRez:IsChecked()};
		settings[#settings+1]={"filterTypeMap", mapWindow.FilterPanel.TypeMap:IsChecked()};
		settings[#settings+1]={"filterTypeNPC", mapWindow.FilterPanel.TypeNPC:IsChecked()};
		settings[#settings+1]={"filterTypeCook", mapWindow.FilterPanel.TypeCook:IsChecked()};
		settings[#settings+1]={"filterTypeScholarIngredient", mapWindow.FilterPanel.TypeScholarIngredient:IsChecked()};
		settings[#settings+1]={"filterTypeAuctioneer", mapWindow.FilterPanel.TypeAuctioneer:IsChecked()};
		settings[#settings+1]={"filterTypeBarber", mapWindow.FilterPanel.TypeBarber:IsChecked()};
		settings[#settings+1]={"filterTypeBard", mapWindow.FilterPanel.TypeBard:IsChecked()};
		settings[#settings+1]={"filterTypeCampSite", mapWindow.FilterPanel.TypeCampSite:IsChecked()};
		settings[#settings+1]={"filterTypeCraftSite", mapWindow.FilterPanel.TypeCraftSite:IsChecked()};
		settings[#settings+1]={"filterTypeCraftVendor", mapWindow.FilterPanel.TypeCraftVendor:IsChecked()};
		settings[#settings+1]={"filterTypeFactionRep", mapWindow.FilterPanel.TypeFactionRep:IsChecked()};
		settings[#settings+1]={"filterTypeItemMaster", mapWindow.FilterPanel.TypeItemMaster:IsChecked()};
		settings[#settings+1]={"filterTypeMailbox", mapWindow.FilterPanel.TypeMailbox:IsChecked()};
		settings[#settings+1]={"filterTypeMilestone", mapWindow.FilterPanel.TypeMilestone:IsChecked()};
		settings[#settings+1]={"filterTypeMusteringHorn", mapWindow.FilterPanel.TypeMusteringHorn:IsChecked()};
		settings[#settings+1]={"filterTypeReflectingPool", mapWindow.FilterPanel.TypeReflectingPool:IsChecked()};
		settings[#settings+1]={"filterTypeSettlement", mapWindow.FilterPanel.TypeSettlement:IsChecked()};
		settings[#settings+1]={"filterTypeStableMaster", mapWindow.FilterPanel.TypeStableMaster:IsChecked()};
		settings[#settings+1]={"filterTypeTownCrier", mapWindow.FilterPanel.TypeTownCrier:IsChecked()};
		settings[#settings+1]={"filterTypeTrader", mapWindow.FilterPanel.TypeTrader:IsChecked()};
		settings[#settings+1]={"filterTypeTrainer", mapWindow.FilterPanel.TypeTrainer:IsChecked()};
		settings[#settings+1]={"filterTypeVaultKeeper", mapWindow.FilterPanel.TypeVaultKeeper:IsChecked()};
		settings[#settings+1]={"filterTypeVendor", mapWindow.FilterPanel.TypeVendor:IsChecked()};
		settings[#settings+1]={"filterTypeSkirmishCamp", mapWindow.FilterPanel.TypeSkirmishCamp:IsChecked()};
		settings[#settings+1]={"filterTypeOreNode", mapWindow.FilterPanel.TypeOreNode:IsChecked()};
		settings[#settings+1]={"filterTypeWoodNode", mapWindow.FilterPanel.TypeWoodNode:IsChecked()};
		settings[#settings+1]={"filterTypeScholarNode", mapWindow.FilterPanel.TypeScholarNode:IsChecked()};
		settings[#settings+1]={"filterTypeDungeon", mapWindow.FilterPanel.TypeDungeon:IsChecked()};
		settings[#settings+1]={"filterOreNodeTier", mapWindow.FilterPanel.TypeOreNodeTier:GetValue()};
		settings[#settings+1]={"filterWoodNodeTier", mapWindow.FilterPanel.TypeWoodNodeTier:GetValue()};
		settings[#settings+1]={"filterScholarNodeTier", mapWindow.FilterPanel.TypeScholarNodeTier:GetValue()};
	end
	if mapWindow.ExternalPing then
		settings[#settings+1]={"pingNS", mapWindow.PingNS};
		settings[#settings+1]={"pingEW", mapWindow.PingEW};
		settings[#settings+1]={"pingName", mapWindow.PingName};
		settings[#settings+1]={"pingDesc", mapWindow.PingDesc};
	end
	PatchDataSave( Turbine.DataScope.Account, "MoorMapSettings", settings);

	-- remove any Default annotations
	tmpIndex=1;
	while tmpIndex<=#annotations do
		if annotations[tmpIndex][6]==nil then
			tmpMapID=annotations[tmpIndex][1];
			if tmpMapID==LoadedMapID then
				tmpCustAnnotID=#tmpCustAnnot+1;
				tmpCustAnnot[tmpCustAnnotID]={};
				for tmpSubIndex=1, #annotations[tmpIndex] do
					tmpCustAnnot[tmpCustAnnotID][tmpSubIndex]=annotations[tmpIndex][tmpSubIndex];
				end
				table.remove(annotations,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		else
			table.remove(annotations,tmpIndex);
		end
	end
	
	if #tmpCustAnnot>0 then
		PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(LoadedMapID), tmpCustAnnot);
	else
		PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(LoadedMapID), nil);
	end

	PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnotations", annotations);

	if defAnnWindow~=nil then
		if defAnnWindow.AnnotationText~=nil then
			local tmpAnnotText=defAnnWindow.AnnotationText:GetText();
			local tmpResourceText=defAnnWindow.ResourceText:GetText();
			if tmpAnnotText~=nil and tmpAnnotText~="" then
				-- the admin window had unsaved text, preserve it incase this is an accidental shutdown
				PatchDataSave( Turbine.DataScope.Account, "MoorMapAnnotText", tmpAnnotText);
				PatchDataSave( Turbine.DataScope.Account, "MoorMapResourceText", tmpResourceText);
			end
		end
	end
end

function LoadData()
	-- try to load saved annotations
	iconInfo=PatchDataLoad( Turbine.DataScope.Account, "MM_IconInfo");
	annotations=PatchDataLoad( Turbine.DataScope.Account, "MM_CustomAnotations");
	-- create a backup just incase anything goes awry during update
	if annotations~=nil and type(annotations)=="table" then
		PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnotations_bak", annotations);
	end
	mapInfo=PatchDataLoad( Turbine.DataScope.Account, "MM_MapInfo");

	if iconInfo==nil or mapInfo==nil then
		-- need to preload old defaults so that the constructor can run, I need to revisit this and fix it so that it can run without these defaults
		iconInfo={};
		iconInfo[1]={106,36,36,"GaranStuff/MoorMap/Resources/MainBase.tga","GaranStuff/MoorMap/Resources/MainBase_hover.tga"}; --placeholder
		iconInfo[2]={107,32,32,"GaranStuff/MoorMap/Resources/Base.tga","GaranStuff/MoorMap/Resources/Base_hover.tga"};
		iconInfo[3]={108,24,24,"GaranStuff/MoorMap/Resources/Fort.tga","GaranStuff/MoorMap/Resources/Fort_hover.tga"};
		iconInfo[4]={109,24,24,"GaranStuff/MoorMap/Resources/Outpost.tga","GaranStuff/MoorMap/Resources/Outpost_hover.tga"};
		iconInfo[5]={110,24,24,"GaranStuff/MoorMap/Resources/POI.tga","GaranStuff/MoorMap/Resources/POI_hover.tga"};
		iconInfo[6]={111,18,18,"GaranStuff/MoorMap/Resources/Stockade.tga","GaranStuff/MoorMap/Resources/Stockade_hover.tga"};
		iconInfo[7]={112,24,24,"GaranStuff/MoorMap/Resources/Rez.tga","GaranStuff/MoorMap/Resources/Rez_hover.tga"};
		iconInfo[8]={113,18,18,"GaranStuff/MoorMap/Resources/CrudeMap.tga","GaranStuff/MoorMap/Resources/CrudeMap_hover.tga"};
		iconInfo[9]={114,18,18,"GaranStuff/MoorMap/Resources/PoorMap.tga","GaranStuff/MoorMap/Resources/PoorMap_hover.tga"};
		iconInfo[10]={115,18,18,"GaranStuff/MoorMap/Resources/GoodMap.tga","GaranStuff/MoorMap/Resources/GoodMap_hover.tga"};
		iconInfo[11]={116,16,16,"GaranStuff/MoorMap/Resources/NPC.tga","GaranStuff/MoorMap/Resources/NPC_hover.tga"};
		iconInfo[12]={117,18,18,"GaranStuff/MoorMap/Resources/FreepMap.tga","GaranStuff/MoorMap/Resources/FreepMap_hover.tga"};
		iconInfo[13]={118,18,18,"GaranStuff/MoorMap/Resources/UnearnedMap.tga","GaranStuff/MoorMap/Resources/UnearnedMap_hover.tga"};
		iconInfo[14]={120,32,32,"GaranStuff/MoorMap/Resources/Auctioneer.tga","GaranStuff/MoorMap/Resources/Auctioneer_hover.tga"};
		iconInfo[15]={121,32,32,"GaranStuff/MoorMap/Resources/Barber.tga","GaranStuff/MoorMap/Resources/Barber_hover.tga"};
		iconInfo[16]={122,32,32,"GaranStuff/MoorMap/Resources/Bard.tga","GaranStuff/MoorMap/Resources/Bard_hover.tga"};
		iconInfo[17]={123,30,30,0x410d4635,0x410d4637}; -- Camp Site (mini=0x410d4636 (15x15))
		iconInfo[18]={124,30,30,"GaranStuff/MoorMap/Resources/CraftSite.tga","GaranStuff/MoorMap/Resources/CraftSite_hover.tga"}; -- Craft Facility (mini=0x410d4636 (15x15))
		iconInfo[19]={125,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- ResourceNode
		iconInfo[20]={126,32,32,"GaranStuff/MoorMap/Resources/CraftVendor.tga","GaranStuff/MoorMap/Resources/CraftVendor_hover.tga"};
		iconInfo[21]={127,32,32,"GaranStuff/MoorMap/Resources/FactionRep.tga","GaranStuff/MoorMap/Resources/FactionRep_hover.tga"};
		iconInfo[22]={128,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Fellow
		iconInfo[23]={129,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- FellowLeader
		iconInfo[24]={130,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- FellowTrack
		iconInfo[25]={131,32,32,"GaranStuff/MoorMap/Resources/Item-master.tga","GaranStuff/MoorMap/Resources/Item-master_hover.tga"};
		iconInfo[26]={132,32,32,"GaranStuff/MoorMap/Resources/Mailbox.tga","GaranStuff/MoorMap/Resources/Mailbox_hover.tga"};--Mailbox mini = 0x41007f7a (18x18)
		iconInfo[27]={133,32,32,"GaranStuff/MoorMap/Resources/Milestone.tga","GaranStuff/MoorMap/Resources/Milestone_hover.tga"};
		iconInfo[28]={134,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Pet
		iconInfo[29]={135,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Quest NPC
		iconInfo[30]={136,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Quest Escort
		iconInfo[31]={137,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Quest Failer
		iconInfo[32]={138,32,32,"GaranStuff/MoorMap/Resources/ReflectingPool.tga","GaranStuff/MoorMap/Resources/ReflectingPool_hover.tga"};
		iconInfo[33]={139,32,32,"GaranStuff/MoorMap/Resources/Settlement.tga","GaranStuff/MoorMap/Resources/Settlement_hover.tga"}; -- Settlement
		iconInfo[34]={140,32,32,"GaranStuff/MoorMap/Resources/Stablemaster.tga","GaranStuff/MoorMap/Resources/Stablemaster_hover.tga"};
		iconInfo[35]={141,32,32,"GaranStuff/MoorMap/Resources/TownCrier.tga","GaranStuff/MoorMap/Resources/TownCrier_hover.tga"};
		iconInfo[36]={142,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Tracked Target
		iconInfo[37]={143,30,30,0x410d465c,0x410d465d}; -- Trader
		iconInfo[38]={144,32,32,"GaranStuff/MoorMap/Resources/Trainer.tga","GaranStuff/MoorMap/Resources/Trainer_hover.tga"};
		iconInfo[39]={145,32,32,"GaranStuff/MoorMap/Resources/VaultKeeper.tga","GaranStuff/MoorMap/Resources/VaultKeeper_hover.tga"};
		iconInfo[40]={146,32,32,"GaranStuff/MoorMap/Resources/Vendor.tga","GaranStuff/MoorMap/Resources/Vendor_hover.tga"};
		iconInfo[41]={147,63,63,"GaranStuff/MoorMap/Resources/MapConnector_blank.tga",0x410081a2};
		iconInfo[42]={154,32,32,"GaranStuff/MoorMap/Resources/SkirmishCamp.tga","GaranStuff/MoorMap/Resources/SkirmishCamp_hover.tga"};
		iconInfo[43]={155,32,32,"GaranStuff/MoorMap/Resources/OreNode.tga","GaranStuff/MoorMap/Resources/OreNode_hover.tga"};
		iconInfo[44]={156,32,32,"GaranStuff/MoorMap/Resources/WoodNode.tga","GaranStuff/MoorMap/Resources/WoodNode_hover.tga"};
		iconInfo[45]={157,32,32,"GaranStuff/MoorMap/Resources/ScholarNode.tga","GaranStuff/MoorMap/Resources/ScholarNode_hover.tga"};
		iconInfo[46]={162,32,32,"GaranStuff/MoorMap/Resources/Cook.tga","GaranStuff/MoorMap/Resources/Cook_hover.tga"};
		iconInfo[47]={163,32,32,"GaranStuff/MoorMap/Resources/MusterHorn.tga","GaranStuff/MoorMap/Resources/MusterHorn_hover.tga"};
		iconInfo[48]={182,32,32,"GaranStuff/MoorMap/Resources/Scholar.tga","GaranStuff/MoorMap/Resources/Scholar_hover.tga"};
		iconInfo[49]={183,32,32,"GaranStuff/MoorMap/Resources/Dungeon.tga","GaranStuff/MoorMap/Resources/Dungeon_hover.tga"};
	end
	if mapInfo==nil then
		-- just enough to let the constructor run, then the current defaults will get imported
		mapInfo={{1,19,tonumber("0x41008133"),1024,768,63.6,1541,-63.6,-636,3,1}};
	end
	if annotations==nil then annotations={} end
	-- I need to load the strings for each ore/wood/scholar node and their tier
	-- I use this table to derive the tier from "add" target arguments

	nodeTier={};
	if not euroFormat then
		-- ore
		nodeTier[#nodeTier+1]={"Copper Deposit",43,1,0};
		nodeTier[#nodeTier+1]={"Rich Copper Deposit",43,1,0};
		nodeTier[#nodeTier+1]={"Tin Deposit",43,1,0};
		nodeTier[#nodeTier+1]={"Rich Tin Deposit",43,1,0};
		nodeTier[#nodeTier+1]={"Barrow-iron Deposit",43,2,0};
		nodeTier[#nodeTier+1]={"Rich Barrow-iron Deposit",43,2,0};
		nodeTier[#nodeTier+1]={"Silver Deposit",43,2,0};
		nodeTier[#nodeTier+1]={"Rich Silver Deposit",43,2,0};
		nodeTier[#nodeTier+1]={"Rich Iron Deposit",43,3,0};
		nodeTier[#nodeTier+1]={"Bountiful Iron Deposit",43,3,0};
		nodeTier[#nodeTier+1]={"Gold Deposit",43,3,0};
		nodeTier[#nodeTier+1]={"Rich Gold Deposit",43,3,0};
		nodeTier[#nodeTier+1]={"Dwarf-iron Deposit",43,4,0};
		nodeTier[#nodeTier+1]={"Rich Dwarf-iron Deposit",43,4,0};
		nodeTier[#nodeTier+1]={"Platinum Deposit",43,4,0};
		nodeTier[#nodeTier+1]={"Rich Platinum Deposit",43,4,0};
		nodeTier[#nodeTier+1]={"Ancient Iron Deposit",43,5,0};
		nodeTier[#nodeTier+1]={"Rich Ancient Iron Deposit",43,5,0};
		nodeTier[#nodeTier+1]={"Ancient Silver Deposit",43,5,0};
		nodeTier[#nodeTier+1]={"Rich Ancient Silver Deposit",43,5,0};
		nodeTier[#nodeTier+1]={"Khaz"..string.char(195)..string.char(162).."d-tin Deposit",43,6,0};
		nodeTier[#nodeTier+1]={"Khaz"..string.char(195)..string.char(162).."d-copper Deposit",43,6,0};
		nodeTier[#nodeTier+1]={"Khaz"..string.char(195)..string.char(162).."d-iron Deposit",43,6,0};
		nodeTier[#nodeTier+1]={"Khaz"..string.char(195)..string.char(162).."d-gold Deposit",43,6,0};
		nodeTier[#nodeTier+1]={"Rich Khaz"..string.char(195)..string.char(162).."d-tin Deposit",43,6,0};
		nodeTier[#nodeTier+1]={"Rich Khaz"..string.char(195)..string.char(162).."d-copper Deposit",43,6,0};
		nodeTier[#nodeTier+1]={"Rich Khaz"..string.char(195)..string.char(162).."d-iron Deposit",43,6,0};
		nodeTier[#nodeTier+1]={"Rich Khaz"..string.char(195)..string.char(162).."d-gold Deposit",43,6,0};
		-- wood
		nodeTier[#nodeTier+1]={"Rowan Branches",44,1,0};
		nodeTier[#nodeTier+1]={"Heavy Rowan Branches",44,1,0};
		nodeTier[#nodeTier+1]={"Ash Branches",44,2,0};
		nodeTier[#nodeTier+1]={"Heavy Ash Branches",44,2,0};
		nodeTier[#nodeTier+1]={"Yew Branches",44,3,0};
		nodeTier[#nodeTier+1]={"Heavy Yew Branches",44,3,0};
		nodeTier[#nodeTier+1]={"Lebethron Branches",44,4,0};
		nodeTier[#nodeTier+1]={"Heavy Lebethron Branches",44,4,0};
		nodeTier[#nodeTier+1]={"Black Ash Branches",44,5,0};
		nodeTier[#nodeTier+1]={"Heavy Black Ash Branches",44,5,0};
		nodeTier[#nodeTier+1]={"Ilex Branches",44,6,0};
		nodeTier[#nodeTier+1]={"Heavy Ilex Branches",44,6,0};
		nodeTier[#nodeTier+1]={"Pile of Ilex Wood",44,6,0};
		nodeTier[#nodeTier+1]={"Pile of Heavy Ilex Wood",44,6,0};
		nodeTier[#nodeTier+1]={"Pile of Mallorn Wood",44,6,0};
		nodeTier[#nodeTier+1]={"Pile of Heavy Mallorn Wood",44,6,0};
		-- scholar node
		nodeTier[#nodeTier+1]={"Shattered Pitcher",45,1,0};
		nodeTier[#nodeTier+1]={"Broken Urn",45,2,0};
		nodeTier[#nodeTier+1]={"Antique Vase",45,3,0};
		nodeTier[#nodeTier+1]={"Forgotten Text",45,4,0};
		nodeTier[#nodeTier+1]={"Ancient Vase",45,5,0};
		nodeTier[#nodeTier+1]={"Sage's Locker",45,6,0};
		-- scholar items
		nodeTier[#nodeTier+1]={"Yarrow Root",48,1,0};
		nodeTier[#nodeTier+1]={"Woad Plant",48,2,0};
--*** need to check tier on Indigo plant
		nodeTier[#nodeTier+1]={"Indigo Plant",48,2,0};
		-- cook items
		nodeTier[#nodeTier+1]={"Cabbage",46,0,0};
		nodeTier[#nodeTier+1]={"Green Onion",46,0,0};
		nodeTier[#nodeTier+1]={"Stalk of Rhubarb",46,0,0};
		nodeTier[#nodeTier+1]={"Bunch of Raspberries",46,0,0};
		nodeTier[#nodeTier+1]={"Bunch of Strawberries",46,0,0};
		nodeTier[#nodeTier+1]={"Bunch of Blueberries",46,0,0};
		nodeTier[#nodeTier+1]={"Bunch of Blackberries",46,0,0};
		nodeTier[#nodeTier+1]={"Tater",46,0,0};
		nodeTier[#nodeTier+1]={"Golden Shire Tater",46,0,0};
		nodeTier[#nodeTier+1]={"Drop of Honey",46,0,0};
		nodeTier[#nodeTier+1]={"Drop of Fine Clover Honey",46,0,0};
		-- I use the nodeTier mechanism to autodetect the icon type for some of the fixed default items.
		nodeTier[#nodeTier+1]={"Mailbox",26,0,1};
		nodeTier[#nodeTier+1]={"Milestone",27,0,1};
		nodeTier[#nodeTier+1]={"Camp Site Fire",17,0,1};
		nodeTier[#nodeTier+1]={"Mustering Horn",47,0,1};
		nodeTier[#nodeTier+1]={"Forge",18,0,1};
		nodeTier[#nodeTier+1]={"Superior Forge",18,0,1};
		nodeTier[#nodeTier+1]={"Workbench",18,0,1};
		nodeTier[#nodeTier+1]={"Superior Workbench",18,0,1};
		nodeTier[#nodeTier+1]={"Oven",18,0,1};
		nodeTier[#nodeTier+1]={"Superior Oven",18,0,1};
		nodeTier[#nodeTier+1]={"Study",18,0,1};
		nodeTier[#nodeTier+1]={"Superior Study",18,0,1};
	else
		-- french /dire Garann ;cible
		-- ore
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de cuivre",43,1,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de cuivre riche",43,1,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t d'"..string.char(195)..string.char(169).."tain",43,1,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t d'"..string.char(195)..string.char(169).."tain riche",43,1,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de fer des galgals",43,2,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de fer riche des galgals",43,2,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t d'argent",43,2,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t d'argent riche",43,2,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de fer riche",43,3,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de fer abondant",43,3,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t d'or",43,3,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t d'or riche",43,3,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de fer des nains",43,4,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de fer riche des nains",43,4,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de platine",43,4,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de platine riche",43,4,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de fer ancien",43,5,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t de fer riche ancien",43,5,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t d'argent ancien",43,5,0};
		nodeTier[#nodeTier+1]={"D"..string.char(195)..string.char(169).."p"..string.char(195)..string.char(180).."t d'argent riche ancien",43,5,0};
		nodeTier[#nodeTier+1]={"Filon d'"..string.char(195)..string.char(169).."tain de Khaz"..string.char(195)..string.char(162).."d",43,6,0};
		nodeTier[#nodeTier+1]={"Filon de cuivre de Khaz"..string.char(195)..string.char(162).."d",43,6,0};
		nodeTier[#nodeTier+1]={"Filon de fer de Khaz"..string.char(195)..string.char(162).."d",43,6,0};
		nodeTier[#nodeTier+1]={"Filon d'or de Khaz"..string.char(195)..string.char(162).."d",43,6,0};
		nodeTier[#nodeTier+1]={"Riche filon d'tain de Khaz"..string.char(195)..string.char(162).."dd",43,6,0};
		nodeTier[#nodeTier+1]={"Riche filon de cuivre de Khaz"..string.char(195)..string.char(162).."d",43,6,0};
		nodeTier[#nodeTier+1]={"Riche filon de fer de Khaz"..string.char(195)..string.char(162).."d",43,6,0};
		nodeTier[#nodeTier+1]={"Riche filon d'or de Khaz"..string.char(195)..string.char(162).."d",43,6,0};
		-- wood
		nodeTier[#nodeTier+1]={"Branches de sorbier",44,1,0};
		nodeTier[#nodeTier+1]={"Lourdes branches de sorbier",44,1,0};
		nodeTier[#nodeTier+1]={"Branches de fr"..string.char(195)..string.char(170).."ne",44,2,0};
		nodeTier[#nodeTier+1]={"Lourdes branches de fr"..string.char(195)..string.char(170).."ne",44,2,0};
		nodeTier[#nodeTier+1]={"Branches d'if",44,3,0};
		nodeTier[#nodeTier+1]={"Lourdes branches d'if",44,3,0};
		nodeTier[#nodeTier+1]={"Branches de lebethron",44,4,0};
		nodeTier[#nodeTier+1]={"Lourdes branches de lebethron",44,4,0};
		nodeTier[#nodeTier+1]={"Branches de fr"..string.char(195)..string.char(170).."ne noir",44,5,0};
		nodeTier[#nodeTier+1]={"Lourdes branches de fr"..string.char(195)..string.char(170).."ne noir",44,5,0};
		nodeTier[#nodeTier+1]={"Branches d'ilex",44,6,0};
		nodeTier[#nodeTier+1]={"Lourdes branches d'ilex",44,6,0};
		nodeTier[#nodeTier+1]={"Tas de bois d'ilex",44,6,0}; -- unverified
		nodeTier[#nodeTier+1]={"Bois d'ilex lourd",44,6,0}; -- unverified
		nodeTier[#nodeTier+1]={"Tas de bois de mallorne",44,6,0};
		nodeTier[#nodeTier+1]={"Bois de mallorne lourd",44,6,0};
		-- scholar
		nodeTier[#nodeTier+1]={"Broc cass"..string.char(195)..string.char(169),45,1,0};
		nodeTier[#nodeTier+1]={"Urne bris"..string.char(195)..string.char(169).."e",45,2,0};
		nodeTier[#nodeTier+1]={"Vase antique",45,3,0};
		nodeTier[#nodeTier+1]={"Texte oubli"..string.char(195)..string.char(169),45,4,0};
		nodeTier[#nodeTier+1]={"Vase ancien",45,5,0};
		nodeTier[#nodeTier+1]={"Cassette de sage",45,6,0};
		-- scholar items
		nodeTier[#nodeTier+1]={"Racine d'achill"..string.char(195)..string.char(169).."e",48,1,0};
		nodeTier[#nodeTier+1]={"Pousse de gu"..string.char(195)..string.char(168).."de",48,2,0};
		-- cook
		nodeTier[#nodeTier+1]={"Chou",46,0,0};
		nodeTier[#nodeTier+1]={"Oignon vert",46,0,0};
		nodeTier[#nodeTier+1]={"P"..string.char(195)..string.char(169).."tiole de rhubarbe",46,0,0};
		nodeTier[#nodeTier+1]={"Framboises",46,0,0};
		nodeTier[#nodeTier+1]={"Fraises",46,0,0};
		nodeTier[#nodeTier+1]={"Myrtilles",46,0,0};
		nodeTier[#nodeTier+1]={"M"..string.char(195)..string.char(187).."res",46,0,0};
		nodeTier[#nodeTier+1]={"Patate",46,0,0};
		nodeTier[#nodeTier+1]={"Patate dor"..string.char(195)..string.char(169).."e de la Comt"..string.char(195)..string.char(169),46,0,0};
		nodeTier[#nodeTier+1]={"Goutte de miel",46,0,0};
		nodeTier[#nodeTier+1]={"Goutte de d"..string.char(195)..string.char(169).."licieux miel de tr"..string.char(195)..string.char(168).."fle",46,0,0};
		--
		-- german /flstern Garann ;ziel
		-- ore
		nodeTier[#nodeTier+1]={"Ader: Kupfer",43,1,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Kupfer",43,1,0};
		nodeTier[#nodeTier+1]={"Ader: Zinn",43,1,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Zinn",43,1,0};
		nodeTier[#nodeTier+1]={"Ader: H"..string.char(195)..string.char(188).."gelgrab-Eisen",43,2,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: H"..string.char(195)..string.char(188).."gelgrab-Eisen",43,2,0};
		nodeTier[#nodeTier+1]={"Ader: Silber",43,2,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Silber",43,2,0};
		nodeTier[#nodeTier+1]={"Ader: Hochwertiges Eisen",43,3,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Hochwertiges Eisen",43,3,0};
		nodeTier[#nodeTier+1]={"Ader: Gold",43,3,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Gold",43,3,0};
		nodeTier[#nodeTier+1]={"Ader: Zwergeneisen",43,4,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Zwergeneisen",43,4,0};
		nodeTier[#nodeTier+1]={"Ader: Platin",43,4,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Platin",43,4,0};
		nodeTier[#nodeTier+1]={"Ader: Uraltes Eisen",43,5,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Uraltes Eisen",43,5,0};
		nodeTier[#nodeTier+1]={"Ader: Uraltes Silber",43,5,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Uraltes Silber",43,5,0};
		nodeTier[#nodeTier+1]={"Ader: Khaz"..string.char(195)..string.char(162).."d-Zinn",43,6,0};
		nodeTier[#nodeTier+1]={"Ader: Khaz"..string.char(195)..string.char(162).."d-Kupfer",43,6,0};
		nodeTier[#nodeTier+1]={"Ader: Khaz"..string.char(195)..string.char(162).."d-Eisen",43,6,0};
		nodeTier[#nodeTier+1]={"Ader: Khaz"..string.char(195)..string.char(162).."d-Gold",43,6,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Khaz"..string.char(195)..string.char(162).."d-Zinn",43,6,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Khaz"..string.char(195)..string.char(162).."d-Kupfer",43,6,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Khaz"..string.char(195)..string.char(162).."d-Eisen",43,6,0};
		nodeTier[#nodeTier+1]={"Reichhaltige Ader: Khaz"..string.char(195)..string.char(162).."d-Gold",43,6,0};
		-- wood
		nodeTier[#nodeTier+1]={"Ebereschen-Zweige",44,1,0};
		nodeTier[#nodeTier+1]={"Schwere Ebereschen-Zweige",44,1,0};
		nodeTier[#nodeTier+1]={"Eschenzweige",44,2,0};
		nodeTier[#nodeTier+1]={"Schwere Eschenzweige",44,2,0};
		nodeTier[#nodeTier+1]={"Eibenzweige",44,3,0};
		nodeTier[#nodeTier+1]={"Schwere Eibenzweige",44,3,0};
		nodeTier[#nodeTier+1]={"Lebethron-Zweige",44,4,0};
		nodeTier[#nodeTier+1]={"Schwere Lebethron-Zweige",44,4,0};
		nodeTier[#nodeTier+1]={"Schwarzeschen-Zweige",44,5,0};
		nodeTier[#nodeTier+1]={"Schwere Schwarzeschen-Zweige",44,5,0};
		nodeTier[#nodeTier+1]={"Stechpalmen-Zweige",44,6,0};
		nodeTier[#nodeTier+1]={"Schwere Stechpalmen-Zweige",44,6,0};
		nodeTier[#nodeTier+1]={"Stapel Stechpalmen-Holz",44,6,0}; -- not verified
		nodeTier[#nodeTier+1]={"Stapel schweres Stechpalmen-Holz",44,6,0}; -- not verified
		nodeTier[#nodeTier+1]={"Stapel Stechpalmenholz",44,6,0}; -- not verified (this is another likely candidate)
		nodeTier[#nodeTier+1]={"Stapel schweres Stechpalmenholz",44,6,0}; -- not verified (this is another likely candidate)
		nodeTier[#nodeTier+1]={"Stapel Mallorn-Holz",44,6,0};
		nodeTier[#nodeTier+1]={"Stapel schweres Mallorn-Holz",44,6,0};
		-- scholar node
		nodeTier[#nodeTier+1]={"Zerschmetterter Krug",45,1,0};
		nodeTier[#nodeTier+1]={"Zerbrochene Urne",45,2,0};
		nodeTier[#nodeTier+1]={"Antike Vase",45,3,0};
		nodeTier[#nodeTier+1]={"Vergessener Text",45,4,0};
		nodeTier[#nodeTier+1]={"Uralte Vase",45,5,0};
		nodeTier[#nodeTier+1]={"Schrank des Weisen",45,6,0};
		-- scholar items
		nodeTier[#nodeTier+1]={"Schafgarben-Wurzel",48,1,0};
		nodeTier[#nodeTier+1]={"Waidpflanze",48,2,0};
		-- cook
		nodeTier[#nodeTier+1]={"Kohlkopf",46,0,0};
		nodeTier[#nodeTier+1]={"Fr"..string.char(195)..string.char(188).."hlingszwiebel",46,0,0};
		nodeTier[#nodeTier+1]={"Rhabarberst"..string.char(195)..string.char(164).."ngel",46,0,0};
		nodeTier[#nodeTier+1]={"Handvoll Himbeeren",46,0,0};
		nodeTier[#nodeTier+1]={"Handvoll Erdbeeren",46,0,0};
		nodeTier[#nodeTier+1]={"Handvoll Blaubeeren",46,0,0};
		nodeTier[#nodeTier+1]={"Handvoll Brombeeren",46,0,0};
		nodeTier[#nodeTier+1]={"Kartoffel",46,0,0};
		nodeTier[#nodeTier+1]={"Goldene Auenland-Kartoffel",46,0,0};
		nodeTier[#nodeTier+1]={"Tropfen Honig",46,0,0};
		nodeTier[#nodeTier+1]={"Tropfen edler Kleehonig",46,0,0};
	end
--[[	nodeTier[#nodeTier+1]={"Bo"..string.char(195)..string.char(174).."te de r"..string.char(195)..string.char(169).."ception",26,0,1};
	nodeTier[#nodeTier+1]={"Rep"..string.char(195)..string.char(168).."re",27,0,1};
	nodeTier[#nodeTier+1]={"Feu de camp",17,0,1};
	nodeTier[#nodeTier+1]={"Cor de rassemblement",47,0,1};
	nodeTier[#nodeTier+1]={"Briefkasten",26,0,1};
	nodeTier[#nodeTier+1]={"Markstein",27,0,1};
	nodeTier[#nodeTier+1]={"Lagerfeuerst"..string.char(195)..string.char(164).."tte",17,0,1};
	nodeTier[#nodeTier+1]={"Versammlungshorn",47,0,1};
]]--

end

-- I create the quickslot window here so that it exists prior to setting it's position, etc
	quickWindow = Turbine.UI.Window();
	quickWindow:SetSize(34,34);
	quickWindow:SetPosition(32,Turbine.UI.Display:GetHeight()-32);
	quickWindow:SetBackground("GaranStuff/MoorMap/Resources/ClearBorder.tga");
	quickWindow:SetBackColor(trimColor);
	quickWindow:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
	quickWindow.Container=Turbine.UI.Control();
	quickWindow.Container:SetParent(quickWindow);
	quickWindow.Container:SetSize(26,26);
	quickWindow.Container:SetPosition(4,4);
	quickWindow.Quickslot=Turbine.UI.Lotro.Quickslot();
	quickWindow.Quickslot:SetParent(quickWindow.Container);
	quickWindow.Quickslot:SetSize(66,66);
	quickWindow.Quickslot:SetPosition(-34,-34);
	quickWindow.Quickslot:SetAllowDrop(false);
	quickWindow.Displayed=true;
	quickWindow.Icon=Turbine.UI.Control();
	quickWindow.Icon:SetParent(quickWindow);
	quickWindow.Icon:SetPosition(1,1);
	quickWindow.Icon:SetSize(32,32);
	quickWindow.Icon:SetBackground("GaranStuff/MoorMap/Resources/QuickPOI.tga");
	quickWindow.Icon:SetMouseVisible(false);
	quickWindow.Icon:SetVisible(true);
	quickWindow.Opacity=.15;
	quickWindow:SetOpacity(quickWindow.Opacity);
	quickWindow:SetVisible(true);
	quickWindow.MouseEnter=function()
		quickWindow:SetOpacity(1);
	end
	quickWindow.MouseLeave=function()
		quickWindow:SetOpacity(quickWindow.Opacity);
	end
	quickWindow.MoveX=-1;
	quickWindow.MoveY=0;
	quickWindow.Moving=false;

	quickWindow.MouseClick = function(sender,args)
		quickWindow:SetBackground("GaranStuff/MoorMap/Resources/ClearBorder.tga");
		if quickWindow.Moving then
			quickWindow.Moving=false;
			quickWindow.MoveX=-1;
		end
	end
	quickWindow.MouseDown=function(sender,args)
		if (args.X<4 or args.Y<4 or args.X>36 or args.Y>36) then
			quickWindow:SetBackground("GaranStuff/MoorMap/Resources/MovingBorder.tga");
			quickWindow.MoveX=args.X;
			quickWindow.MoveY=args.Y;
		end
	end
	quickWindow.MouseUp=function(sender,args)
		quickWindow:SetBackground("GaranStuff/MoorMap/Resources/ClearBorder.tga");
		quickWindow.MoveX=-1;
		quickWindow.MoveY=0;
		-- reestablish the quickslot incase the user dragged it out...
		if language==2 then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5:FR:;cible"))
		elseif language==3 then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;pos:5:DE:;ziel"))
		else
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5::;target"))
		end
		quickWindow.Quickslot:SetVisible(true);
	end

	quickWindow.MouseMove=function(sender,args)
		if quickWindow.MoveX~=-1 and (args.X~=quickWindow.MoveX or args.Y~= quickWindow.MoveY) then
			quickWindow:SetBackground("GaranStuff/MoorMap/Resources/MovingBorder.tga");
			quickWindow.Moving=true;
			local newLeft=quickWindow:GetLeft()-(quickWindow.MoveX-args.X)
			local newTop=quickWindow:GetTop()-(quickWindow.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-quickWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-quickWindow:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-quickWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-quickWindow:GetHeight() end;
			quickWindow:SetPosition(newLeft,newTop);
		end
	end

MMWindow = class( Turbine.UI.Window );

function MMWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	self:SetSize(1024,768);
	self.Loaded=false;
	self.Refreshing=false;
	self.ExternalPing=false;

	-- load the settings and set the window position if possible, otherwise default to center
	local initHeight=768;
	local initWidth=1024;
	local initLeft=(Turbine.UI.Display:GetWidth() - initWidth) / 2;
	local initTop=(Turbine.UI.Display:GetHeight() - initHeight) / 2;
	local tmpIndex;
	local mapOpacity=1;

	self.PreserveMapID=false;
	self.CurrentMapID=1; -- default to the Ettenmoors map since we can't autodetect the correct map
	self.NeedsRefresh=false;
	self.PopUp=nil;

	local filterAllegianceCreep=true;
	local filterAllegianceFreep=true;
	local filterAllegianceDelving=true;
	local filterTypeMain=nil;
	local filterTypeSecondary=nil;
	local filterTypeBase=nil;
	local filterTypeOutpost=nil;
	local filterTypePOI=nil;
	local filterTypeFort=nil;
	local filterTypeRez=nil;
	local filterTypeMap=nil;
	local filterTypeNPC=nil;
	local filterTypeCook=nil;
	local filterTypeScholarIngredient=nil;
	local filterTypeAuctioneer=nil;
	local filterTypeBarber=nil;
	local filterTypeBard=nil;
	local filterTypeCampSite=nil;
	local filterTypeCraftSite=nil;
	local filterTypeCraftVendor=nil;
	local filterTypeFactionRep=nil;
	local filterTypeItemMaster=nil;
	local filterTypeMailbox=nil;
	local filterTypeMilestone=nil;
	local filterTypeMusteringHorn=nil;
	local filterTypeReflectingPool=nil;
	local filterTypeSettlement=nil;
	local filterTypeStableMaster=nil;
	local filterTypeTownCrier=nil;
	local filterTypeTrader=nil;
	local filterTypeTrainer=nil;
	local filterTypeVaultKeeper=nil;
	local filterTypeVendor=nil;
	local filterTypeSkirmishCamp=nil;
	local filterTypeOreNode=nil;
	local filterTypeWoodNode=nil;
	local filterTypeScholarNode=nil;
	local filterTypeDungeon=nil;
	local filterOreNodeTier=0;
	local filterWoodNodeTier=0;
	local filterScholarNodeTier=0;
	self.FilterMainDefault=true;
	self.FilterSecondaryDefault=true;
	self.FilterBaseDefault=true;
	self.FilterOutpostDefault=true;
	self.FilterFortDefault=true;
	self.FilterPOIDefault=true;
	self.FilterRezDefault=true;
	self.FilterMapDefault=true;
	self.FilterNPCDefault=false;
	self.FilterCookDefault=true;
	self.FilterScholarIngredientDefault=true;
	self.FilterAuctioneerDefault=true;
	self.FilterBarberDefault=true;
	self.FilterBardDefault=true;
	self.FilterCampSiteDefault=true;
	self.FilterCraftSiteDefault=true;
	self.FilterCraftVendorDefault=true;
	self.FilterFactionRepDefault=true;
	self.FilterItemMasterDefault=true;
	self.FilterMailboxDefault=true;
	self.FilterMilestoneDefault=true;
	self.FilterMusteringHornDefault=true;
	self.FilterReflectingPoolDefault=true;
	self.FilterSettlementDefault=true;
	self.FilterStableMasterDefault=true;
	self.FilterTownCrierDefault=true;
	self.FilterTraderDefault=true;
	self.FilterTrainerDefault=true;
	self.FilterVaultKeeperDefault=true;
	self.FilterVendorDefault=true;
	self.FilterSkirmishCampDefault=true;
	self.FilterOreNodeDefault=true;
	self.FilterWoodNodeDefault=true;
	self.FilterScholarNodeDefault=true;
	self.FilterDungeonDefault=true;
	self.PluginUnloading=false;
	self.Resizing=false;
	self.MoveX=-1;
	self.MoveY=-1;
	self.LoadMinimized=true;
	self.ShowIconWhenMinimized=true;
	tmpSettings=PatchDataLoad(Turbine.DataScope.Account, "MoorMapSettings");
	if (tmpSettings~=nil) then
		local priorFormat=euroFormat;
		if tostring(type(tmpSettings))=="table" then
			for index=1,#tmpSettings do
				if tostring(type(tmpSettings[index]))=="table" then
					if (tmpSettings[index][1]=="MapTop") then
						initTop=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="MapLeft") then
						initLeft=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="MapHeight") then
						initHeight=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="MapWidth") then
						initWidth=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="MapOpacity") then
						mapOpacity=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="trimColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							trimColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							trimColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
						quickWindow:SetBackColor(trimColor);
						quickWindow:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
					elseif (tmpSettings[index][1]=="fontColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							fontColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							fontColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="backColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							backColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							backColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="headingsColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							headingsColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							headingsColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="listTextColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							listTextColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							listTextColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="loadMinimized") then
						self.LoadMinimized=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="language") then
						if tonumber(tmpSettings[index][2])~=nil then
							language=tonumber(tmpSettings[index][2]);
						end
					elseif (tmpSettings[index][1]=="showIconWhenMinimized") then
						self.ShowIconWhenMinimized=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="DataVersion") then
						priorDataVersion=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="currentMapID") then
						self.CurrentMapID=tmpSettings[index][2];
						self.Refreshing=true;
					elseif (tmpSettings[index][1]=="filterAllegianceCreep") then
						filterAllegianceCreep=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterAllegianceFreep") then
						filterAllegianceFreep=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterAllegianceDelving") then
						filterAllegianceDelving=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeMain") then
						filterTypeMain=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeSecondary") then
						filterTypeSecondary=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeBase") then
						filterTypeBase=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeOutpost") then
						filterTypeOutpost=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypePOI") then
						filterTypePOI=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeFort") then
						filterTypeFort=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeRez") then
						filterTypeRez=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeMap") then
						filterTypeMap=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeNPC") then
						filterTypeNPC=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeCook") then
						filterTypeCook=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeScholarIngredient") then
						filterTypeScholarIngredient=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeAuctioneer") then
						filterTypeAuctioneer=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeBarber") then
						filterTypeBarber=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeBard") then
						filterTypeBard=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeCampSite") then
						filterTypeCampSite=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeCraftSite") then
						filterTypeCraftSite=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeCraftVendor") then
						filterTypeCraftVendor=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeFactionRep") then
						filterTypeFactionRep=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeItemMaster") then
						filterTypeItemMaster=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeMailbox") then
						filterTypeMailbox=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeMilestone") then
						filterTypeMilestone=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeMusteringHorn") then
						filterTypeMusteringHorn=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeReflectingPool") then
						filterTypeReflectingPool=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeSettlement") then
						filterTypeSettlement=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeStableMaster") then
						filterTypeStableMaster=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeTownCrier") then
						filterTypeTownCrier=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeTrader") then
						filterTypeTrader=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeTrainer") then
						filterTypeTrainer=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeVaultKeeper") then
						filterTypeVaultKeeper=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeVendor") then
						filterTypeVendor=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeSkirmishCamp") then
						filterTypeSkirmishCamp=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeOreNode") then
						filterTypeOreNode=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeWoodNode") then
						filterTypeWoodNode=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeScholarNode") then
						filterTypeScholarNode=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTypeDungeon") then
						filterTypeDungeon=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterOreNodeTier") then
						filterOreNodeTier=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterWoodNodeTier") then
						filterWoodNodeTier=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterScholarNodeTier") then
						filterScholarNodeTier=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="euroFormat") then
						priorFormat=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="worldName") then
						worldName=tmpSettings[index][2];
						if worldName==nil then worldName="Landroval" end
					elseif (tmpSettings[index][1]=="pingNS") then
						self.PingNS=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="pingEW") then
						self.PingEW=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="pingName") then
						self.PingName=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="pingDesc") then
						self.PingDesc=tmpSettings[index][2];
						self.ExternalPing=true;
					elseif (tmpSettings[index][1]=="filterMainDefault") then
						self.FilterMainDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterSecondaryDefault") then
						self.FilterSecondaryDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterBaseDefault") then
						self.FilterBaseDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterOutpostDefault") then
						self.FilterOutpostDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterFortDefault") then
						self.FilterFortDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterPOIDefault") then
						self.FilterPOIDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterRezDefault") then
						self.FilterRezDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterMapDefault") then
						self.FilterMapDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterNPCDefault") then
						self.FilterNPCDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterCookDefault") then
						self.FilterCookDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterScholarIngredientDefault") then
						self.FilterScholarIngredientDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterAuctioneerDefault") then
						self.FilterAuctioneerDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterBarberDefault") then
						self.FilterBarberDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterBardDefault") then
						self.FilterBardDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterCampSiteDefault") then
						self.FilterCampSiteDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterCraftSiteDefault") then
						self.FilterCraftSiteDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterCraftVendorDefault") then
						self.FilterCraftVendorDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterFactionRepDefault") then
						self.FilterFactionRepDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterItemMasterDefault") then
						self.FilterItemMasterDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterMailboxDefault") then
						self.FilterMailboxDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterMilestoneDefault") then
						self.FilterMilestoneDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterMusteringHornDefault") then
						self.FilterMusteringHornDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterReflectingPoolDefault") then
						self.FilterReflectingPoolDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterSettlementDefault") then
						self.FilterSettlementDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterStableMasterDefault") then
						self.FilterStableMasterDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTownCrierDefault") then
						self.FilterTownCrierDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTraderDefault") then
						self.FilterTraderDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterTrainerDefault") then
						self.FilterTrainerDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterVaultKeeperDefault") then
						self.FilterVaultKeeperDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterVendorDefault") then
						self.FilterVendorDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterSkirmishCampDefault") then
						self.FilterSkirmishCampDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterOreNodeDefault") then
						self.FilterOreNodeDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterWoodNodeDefault") then
						self.FilterWoodNodeDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterScholarNodeDefault") then
						self.FilterScholarNodeDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="filterDungeonDefault") then
						self.FilterDungeonDefault=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="quickWindow.Top") then
						quickWindow:SetTop(tmpSettings[index][2]);
					elseif (tmpSettings[index][1]=="quickWindow.Left") then
						quickWindow:SetLeft(tmpSettings[index][2]);
					elseif (tmpSettings[index][1]=="quickWindow.Opacity") then
						quickWindow.Opacity=tmpSettings[index][2];
						quickWindow:SetOpacity(quickWindow.Opacity);
					elseif (tmpSettings[index][1]=="quickWindow.Displayed") then
						quickWindow.Displayed=tmpSettings[index][2];
						quickWindow:SetVisible(quickWindow.Displayed);
					end
				end
			end
		else
			-- data was unreadable, we need to display a message to the user that the data could not be read
			dataLoadError=true
		end
		if language==2 then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5:FR:;cible"))
		elseif language==3 then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;pos:5:DE:;ziel"))
		else
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5::;target"))
		end
		quickWindow.Quickslot:SetVisible(true);

		-- we have to force client decimal formats since we don't know what format they were saved in, iterate through annotations to fix Coordinates and mapInfo to fix Factors
		for tmpIndex=1,#annotations do
			if euroFormat then
				annotations[tmpIndex][2]=tonumber((string.gsub(annotations[tmpIndex][2],"%.",",")))
				annotations[tmpIndex][3]=tonumber((string.gsub(annotations[tmpIndex][3],"%.",",")))
			else
				annotations[tmpIndex][2]=tonumber((string.gsub(annotations[tmpIndex][2],",",".")))
				annotations[tmpIndex][3]=tonumber((string.gsub(annotations[tmpIndex][3],",",".")))
			end
		end
		for tmpIndex=1,#mapInfo do
			if euroFormat then
				mapInfo[tmpIndex][6]=tonumber((string.gsub(mapInfo[tmpIndex][6],"%.",",")))
				mapInfo[tmpIndex][8]=tonumber((string.gsub(mapInfo[tmpIndex][8],"%.",",")))
				mapInfo[tmpIndex][13]=tonumber((string.gsub(mapInfo[tmpIndex][13],"%.",",")))
				mapInfo[tmpIndex][14]=tonumber((string.gsub(mapInfo[tmpIndex][14],"%.",",")))
				mapInfo[tmpIndex][15]=tonumber((string.gsub(mapInfo[tmpIndex][15],"%.",",")))
				mapInfo[tmpIndex][16]=tonumber((string.gsub(mapInfo[tmpIndex][16],"%.",",")))
			else
				mapInfo[tmpIndex][6]=tonumber((string.gsub(mapInfo[tmpIndex][6],",",".")))
				mapInfo[tmpIndex][8]=tonumber((string.gsub(mapInfo[tmpIndex][8],",",".")))
				mapInfo[tmpIndex][13]=tonumber((string.gsub(mapInfo[tmpIndex][13],",",".")))
				mapInfo[tmpIndex][14]=tonumber((string.gsub(mapInfo[tmpIndex][14],",",".")))
				mapInfo[tmpIndex][15]=tonumber((string.gsub(mapInfo[tmpIndex][15],",",".")))
				mapInfo[tmpIndex][16]=tonumber((string.gsub(mapInfo[tmpIndex][16],",",".")))
			end
		end

		local tmpAnn;
		LoadedMapID=self.CurrentMapID;
		tmpAnn=PatchDataLoad( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(self.CurrentMapID));
		if tmpAnn~=nil and type(tmpAnn)=="table" then
			NumCustomAnnot=#tmpAnn;
			for tmpIndex=1,#tmpAnn do
				-- force conversion of fields 2 and 3 to match current euroFormat setting
				if euroFormat then
					annotations[#annotations+1]={tmpAnn[tmpIndex][1],tonumber((string.gsub(tmpAnn[tmpIndex][2],"%.",","))),tonumber((string.gsub(tmpAnn[tmpIndex][3],"%.",","))),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
				else
					annotations[#annotations+1]={tmpAnn[tmpIndex][1],tonumber((string.gsub(tmpAnn[tmpIndex][2],",","."))),tonumber((string.gsub(tmpAnn[tmpIndex][3],",","."))),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
				end
			end
		end

		tmpAnn=PatchDataLoad( Turbine.DataScope.Account, "MM_MapAnnotations_"..tostring(self.CurrentMapID));
		if tmpAnn~=nil and type(tmpAnn)=="table" then
			for tmpIndex=1,#tmpAnn do
				-- force conversion of fields 2 and 3 to match current euroFormat setting
				if euroFormat then
					annotations[#annotations+1]={tmpAnn[tmpIndex][1],tonumber((string.gsub(tmpAnn[tmpIndex][2],"%.",","))),tonumber((string.gsub(tmpAnn[tmpIndex][3],"%.",","))),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
				else
					annotations[#annotations+1]={tmpAnn[tmpIndex][1],tonumber((string.gsub(tmpAnn[tmpIndex][2],",","."))),tonumber((string.gsub(tmpAnn[tmpIndex][3],",","."))),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
				end
			end
		end
		mapStrings=PatchDataLoad( Turbine.DataScope.Account, "MM_MapStrings_"..tostring(self.CurrentMapID));
		if mapStrings==nil or type(mapStrings)~="table" then
			mapStrings={};
		end
		if mapStrings[language]==nil or type(mapStrings[language])~="table" then
			mapStrings[language]={};
		end

		if self.CurrentMapID==1 then
			local stringOffset=#mapStrings[language];
			-- load any server specific annotations and strings and append them to the defaults

			tmpAnn=PatchDataLoad( Turbine.DataScope.Account, "MM_MapAnnotations_1_"..worldName);
			if tmpAnn~=nil and type(tmpAnn)=="table" then
				for tmpIndex=1,#tmpAnn do
					-- force conversion of fields 2 and 3 to match current euroFormat setting
					if euroFormat then
						annotations[#annotations+1]={tmpAnn[tmpIndex][1],tonumber((string.gsub(tmpAnn[tmpIndex][2],"%.",","))),tonumber((string.gsub(tmpAnn[tmpIndex][3],"%.",","))),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],stringOffset+tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
					else
						annotations[#annotations+1]={tmpAnn[tmpIndex][1],tonumber((string.gsub(tmpAnn[tmpIndex][2],",","."))),tonumber((string.gsub(tmpAnn[tmpIndex][3],",","."))),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],stringOffset+tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
					end
				end
			end
			local tmpMapStrings;
			local tmpLang;
			tmpMapStrings=PatchDataLoad( Turbine.DataScope.Account, "MM_MapStrings_1_"..worldName);
			if tmpMapStrings~=nil and type(tmpMapStrings)=="table" then
-- we only really need the language specific values, right? if the user changes languages, the plugin reloads anyway...
				for tmpIndex=1,#tmpMapStrings[language] do
					mapStrings[language][#mapStrings[language]+1]=tmpMapStrings[language][tmpIndex];
				end
			end
		end
		if annotations==nil then
			NumDefaultAnnot=0;
		else
			NumDefaultAnnot=#annotations-NumCustomAnnot;
		end		
		if debug then
			Turbine.Shell.WriteLine("NumCustomAnnot="..tostring(NumCustomAnnot));
			Turbine.Shell.WriteLine("NumDefaultAnnot="..tostring(NumDefaultAnnot));
		end
		-- account for changed resolution
		if initLeft>(Turbine.UI.Display.GetWidth()-initWidth) then initLeft=Turbine.UI.Display.GetWidth()-initWidth end;
		if initLeft<0 then initLeft=0 end;
		if initWidth>(Turbine.UI.Display.GetWidth()-initLeft) then initWidth=Turbine.UI.Display.GetWidth()-initLeft end;
		if initTop>(Turbine.UI.Display.GetHeight()-initHeight) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;
		if initTop<0 then initTop=0 end;
		if initHeight>(Turbine.UI.Display.GetHeight()-initTop) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;
	end
	if filterTypeMain==nil then filterTypeMain=self.FilterMainDefault end
	if filterTypeSecondary==nil then filterTypeSecondary=self.FilterSecondaryDefault end
	if filterTypeBase==nil then filterTypeBase=self.FilterBaseDefault end
	if filterTypeOutpost==nil then filterTypeOutpost=self.FilterOutpostDefault end
	if filterTypePOI==nil then filterTypePOI=self.FilterPOIDefault end
	if filterTypeFort==nil then filterTypeFort=self.FilterFortDefault end
	if filterTypeRez==nil then filterTypeRez=self.FilterRezDefault end
	if filterTypeMap==nil then filterTypeMap=self.FilterMapDefault end
	if filterTypeNPC==nil then filterTypeNPC=self.FilterNPCDefault end
	if filterTypeCook==nil then filterTypeCook=self.FilterCookDefault end
	if filterTypeScholarIngredient==nil then filterTypeScholarIngredient=self.FilterScholarIngredientDefault end
	if filterTypeAuctioneer==nil then filterTypeAuctioneer=self.FilterAuctioneerDefault end
	if filterTypeBarber==nil then filterTypeBarber=self.FilterBarberDefault end
	if filterTypeBard==nil then filterTypeBard=self.FilterBardDefault end
	if filterTypeCampSite==nil then filterTypeCampSite=self.FilterCampSiteDefault end
	if filterTypeCraftSite==nil then filterTypeCraftSite=self.FilterCraftSiteDefault end
	if filterTypeCraftVendor==nil then filterTypeCraftVendor=self.FilterCraftVendorDefault end
	if filterTypeFactionRep==nil then filterTypeFactionRep=self.FilterFactionRepDefault end
	if filterTypeItemMaster==nil then filterTypeItemMaster=self.FilterItemMasterDefault end
	if filterTypeMailbox==nil then filterTypeMailbox=self.FilterMailboxDefault end
	if filterTypeMilestone==nil then filterTypeMilestone=self.FilterMilestoneDefault end
	if filterTypeMusteringHorn==nil then filterTypeMusteringHorn=self.FilterMusteringHornDefault end
	if filterTypeReflectingPool==nil then filterTypeReflectingPool=self.FilterReflectingPoolDefault end
	if filterTypeSettlement==nil then filterTypeSettlement=self.FilterSettlementDefault end
	if filterTypeStableMaster==nil then filterTypeStableMaster=self.FilterStableMasterDefault end
	if filterTypeTownCrier==nil then filterTypeTownCrier=self.FilterTownCrierDefault end
	if filterTypeTrader==nil then filterTypeTrader=self.FilterTraderDefault end
	if filterTypeTrainer==nil then filterTypeTrainer=self.FilterTrainerDefault end
	if filterTypeVaultKeeper==nil then filterTypeVaultKeeper=self.FilterVaultKeeperDefault end
	if filterTypeVendor==nil then filterTypeVendor=self.FilterVendorDefault end
	if filterTypeSkirmishCamp==nil then filterTypeSkirmishCamp=self.FilterSkirmishCampDefault end
	if filterTypeOreNode==nil then filterTypeOreNode=self.FilterOreNodeDefault end
	if filterTypeWoodNode==nil then filterTypeWoodNode=self.FilterWoodNodeDefault end
	if filterTypeScholarNode==nil then filterTypeScholarNode=self.FilterScholarNodeDefault end
	if filterTypeDungeon==nil then filterTypeDungeon=self.FilterDungeonDefault end

	self:SetPosition( initLeft, initTop );
	self:SetHeight(initHeight);
	self:SetWidth(initWidth);
	self:SetVisible(false);

	self.Map=Turbine.UI.Control();
	self.Map:SetParent(self);
	self.Map:SetMouseVisible(false);
--
--	self.Map:SetSize(mapInfo[self.CurrentMapID][4],mapInfo[self.CurrentMapID][5]);
--	self.Map:SetBackground(mapInfo[self.CurrentMapID][3]);
--	self.Map:SetStretchMode(1);
--self.Map:SetPosition((self:GetWidth()-mapInfo[self.CurrentMapID][4])/2,(self:GetHeight()-mapInfo[self.CurrentMapID][5])/2)
--	self.Map:SetSize(self:GetSize());
	self.Map:SetOpacity(mapOpacity);

	self.ControlPanel=Turbine.UI.Control();
	self.ControlPanel:SetParent(self);
	self.ControlPanel:SetSize(1024,32);
	self.ControlPanel:SetTop(4);
	self.ControlPanel:SetStretchMode(3);

	self.ControlPanel.OptionsButton=Turbine.UI.Control();
	self.ControlPanel.OptionsButton:SetParent(self.ControlPanel);
--	self.ControlPanel.OptionsButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ControlPanel.OptionsButton:SetBackground("GaranStuff/MoorMap/Resources/options.tga");
	self.ControlPanel.OptionsButton:SetSize(32,32);
	self.ControlPanel.OptionsButton:SetLeft(18);
	self.ControlPanel.OptionsButton.MouseEnter=function()
		self.ControlPanel.OptionsButton:SetBackground("GaranStuff/MoorMap/Resources/options_hover.tga");
	end
	self.ControlPanel.OptionsButton.MouseLeave=function()
		self.ControlPanel.OptionsButton:SetBackground("GaranStuff/MoorMap/Resources/options.tga");
	end
	self.ControlPanel.OptionsButton.MouseClick=function()
		optWindow:SetVisible(true);
	end
	self.ControlPanel.AnnotationsButton=Turbine.UI.Control();
	self.ControlPanel.AnnotationsButton:SetParent(self.ControlPanel);
--	self.ControlPanel.AnnotationsButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ControlPanel.AnnotationsButton:SetBackground("GaranStuff/MoorMap/Resources/annotations.tga");
	self.ControlPanel.AnnotationsButton:SetSize(32,32);
	self.ControlPanel.AnnotationsButton:SetLeft(self.ControlPanel.OptionsButton:GetLeft()+self.ControlPanel.OptionsButton:GetWidth()+5);
	self.ControlPanel.AnnotationsButton.MouseEnter=function()
		self.ControlPanel.AnnotationsButton:SetBackground("GaranStuff/MoorMap/Resources/annotations_hover.tga");
	end
	self.ControlPanel.AnnotationsButton.MouseLeave = function()
		self.ControlPanel.AnnotationsButton:SetBackground("GaranStuff/MoorMap/Resources/annotations.tga");
	end
	self.ControlPanel.AnnotationsButton.MouseClick=function()
		annotWindow:SetVisible(true);
	end

	self.FilterButton=Turbine.UI.Control();
	self.FilterButton:SetParent(self.ControlPanel);
--	self.FilterButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.FilterButton:SetBackground("GaranStuff/MoorMap/Resources/Filter.tga");
	self.FilterButton:SetSize(32,32);
	self.FilterButton:SetLeft(self.ControlPanel.AnnotationsButton:GetLeft()+self.ControlPanel.AnnotationsButton:GetWidth()+5);
	self.FilterButton.MouseEnter=function()
		self.FilterButton:SetBackground("GaranStuff/MoorMap/Resources/Filter_hover.tga");
	end
	self.FilterButton.MouseLeave=function()
		self.FilterButton:SetBackground("GaranStuff/MoorMap/Resources/Filter.tga");
	end
	self.FilterButton.MouseClick=function()
		self.FilterPanel:SetVisible(not self.FilterPanel:IsVisible());
	end

	self.SearchButton=Turbine.UI.Control();
	self.SearchButton:SetParent(self.ControlPanel);
--	self.SearchButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.SearchButton:SetBackground("GaranStuff/MoorMap/Resources/Search.tga");
	self.SearchButton:SetSize(32,32);
	self.SearchButton:SetLeft(self.FilterButton:GetLeft()+self.FilterButton:GetWidth()+5);
	self.SearchButton.MouseEnter=function()
		self.SearchButton:SetBackground("GaranStuff/MoorMap/Resources/Search_hover.tga");
	end
	self.SearchButton.MouseLeave=function()
		self.SearchButton:SetBackground("GaranStuff/MoorMap/Resources/Search.tga");
	end
	self.SearchButton.MouseClick=function()
		self.SearchPanel:SetVisible(not self.SearchPanel:IsVisible());
		self.Map.IconSearch:SetWantsUpdates(self.SearchPanel:IsVisible());
	end

	if debug then
		self.LocationContainer=Turbine.UI.Control();
		self.LocationContainer:SetParent(self.ControlPanel);
		self.LocationContainer:SetSize(22,22);
		self.LocationContainer:SetPosition(self.SearchButton:GetLeft()+self.SearchButton:GetWidth()+10,9);

		self.LocationQuickSlot=Turbine.UI.Lotro.Quickslot();
		self.LocationQuickSlot:SetParent(self.LocationContainer);
		self.LocationQuickSlot:SetSize(66,66);
		self.LocationQuickSlot:SetPosition(-34,-34);
		self.LocationQuickSlot:SetAllowDrop(false);
		if language==2 then
			self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
		elseif language==3 then
			self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;pos"))
		else
			self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
		end
		self.LocationQuickSlot:SetVisible(true);

		self.LocationButton=Turbine.UI.Control();
		self.LocationButton:SetParent(self.ControlPanel);
--		self.LocationButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
		self.LocationButton:SetSize(32,32);
		self.LocationButton:SetBackground("GaranStuff/MoorMap/Resources/Location.tga");
		self.LocationButton:SetPosition(self.SearchButton:GetLeft()+self.SearchButton:GetWidth()+5,0);
		self.LocationButton:SetMouseVisible(false);

		self.LocationContainer.MouseEnter=function()
			self.LocationButton:SetBackground("GaranStuff/MoorMap/Resources/Location_hover.tga");
		end
		self.LocationContainer.MouseLeave=function()
			self.LocationButton:SetBackground("GaranStuff/MoorMap/Resources/Location.tga");
		end

		self.LocationContainer.MouseUp=function(sender,args)
			-- reestablish the quickslot incase the user dragged it out...
			if language==2 then
				self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
			elseif language==3 then
				self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;pos"))
			else
				self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
			end
			self.LocationQuickSlot:SetVisible(true);
		end
	-- I wish we could use /loc for this :(
	--/Moormap setloc ;loc
	end

	self.NSCoord=Turbine.UI.Label();
	self.NSCoord:SetParent(self.ControlPanel);
	self.NSCoord:SetSize(45,18);
	if self.LocationButton~=nil then
		self.NSCoord:SetPosition(self.LocationButton:GetLeft()+self.LocationButton:GetWidth()+5,6);
	else
		self.NSCoord:SetPosition(self.SearchButton:GetLeft()+self.SearchButton:GetWidth()+5,6);
	end
	self.NSCoord:SetForeColor(fontColor);
	self.NSCoord:SetBackColor(backColor);
	self.NSCoord:SetFont(fontFace);
	self.NSCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.NSCoord:SetText("");

	self.EWCoord=Turbine.UI.Label();
	self.EWCoord:SetParent(self.ControlPanel);
	self.EWCoord:SetSize(45,18);
	self.EWCoord:SetPosition(self.NSCoord:GetLeft()+self.NSCoord:GetWidth()+5,6);
	self.EWCoord:SetForeColor(fontColor);
	self.EWCoord:SetBackColor(backColor);
	self.EWCoord:SetFont(fontFace);
	self.EWCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.EWCoord:SetText("");

	if self.CurrentMapID==2 then
		-- we don't show coords on world map since they are meaningless (and erroneous)
		self.NSCoord:SetVisible(false);
		self.EWCoord:SetVisible(false);
	end

	self.MapSelect=GaranStuff.MoorMap.DropDownList()
	self.MapSelect:SetParent(self);
	self.MapSelect:SetSize(280,20); -- the excess space is used in German and French map names
	self.MapSelect:SetPosition(self.EWCoord:GetLeft()+self.EWCoord:GetWidth()+5,9);
	self.MapSelect:SetStretchMode(3);
	self.MapSelect:SetBorderColor(trimColor);
	self.MapSelect:SetBackColor(backColor);
	self.MapSelect.CurrentValue:SetBackColor(backColor);
	self.MapSelect:SetTextColor(listTextColor);
	self.MapSelect:SetDropRows(15);

	self.MapSelect:SetSelectedIndex(1);
	self.MapSelect.SelectedIndexChanged=function()
		self.PreserveMapID=true;
		if debug then Turbine.Shell.WriteLine("self.MapSelect:GetValue()="..tostring(self.MapSelect:GetValue())) end
		RefreshMap(self.MapSelect:GetValue());
	end

	self.CloseButton=Turbine.UI.Control();
	self.CloseButton:SetParent(self);
--	self.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.CloseButton:SetStretchMode(3);
	self.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close.tga");
	self.CloseButton:SetSize(16,16);
	self.CloseButton:SetLeft(self.Map:GetWidth()-20);
	self.CloseButton.MouseEnter = function()
		self.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close_hover.tga");
	end
	self.CloseButton.MouseLeave = function()
		self.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close.tga");
	end
	self.CloseButton.MouseClick=function()
		mapWindow:SetVisible(false);
	end

	self.Map.Icons={};
	self.Map.MapPoints={};
	self.Map.MapPoints.Item={};

	self.SearchPanel=Turbine.UI.Control();
	self.SearchPanel:SetParent(self);
	self.SearchPanel:SetPosition(self:GetWidth()-400,35);
	self.SearchPanel:SetSize(380,self:GetHeight()-50);
	self.SearchPanel:SetBackColor(Turbine.UI.Color(.05,.07,.12));
	self.SearchPanel:SetVisible(false);
	self.SearchPanel:SetStretchMode(3);
	self.Map.SearchFilterCaption=Turbine.UI.Label();
	self.Map.SearchFilterCaption:SetParent(self.SearchPanel);
	self.Map.SearchFilterCaption:SetPosition(0,4);
	self.Map.SearchFilterCaption:SetSize(55,18);
	self.Map.SearchFilterCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.Map.SearchFilterCaption:SetForeColor(fontColor);
	self.Map.SearchFilterCaption:SetText(Resource[language][65]..":");

	self.Map.IconSearch=Turbine.UI.Lotro.TextBox();
	self.Map.IconSearch:SetParent(self.SearchPanel);
	self.Map.IconSearch:SetSize(self.SearchPanel:GetWidth()-57,20);
	self.Map.IconSearch:SetFont(fontFace);
	self.Map.IconSearch:SetPosition(56,0);
	self.Map.IconSearch:SetText("");
	self.Map.IconSearch.OldText="";
	self.Map.IconSearch.OldAllegianceCreep=true;
	self.Map.IconSearch.OldAllegianceFreep=true;
	self.Map.IconSearch.OldAllegianceDelving=true;
	self.Map.IconSearch.Update=function(sender)
		if mapWindow.Map.IconSearch:GetText()~=mapWindow.Map.IconSearch.OldText or mapWindow.Map.IconSearch.OldAllegianceCreep~=mapWindow.Map.IconCreepCB:IsChecked() or mapWindow.Map.IconSearch.OldAllegianceFreep~=mapWindow.Map.IconFreepCB:IsChecked() or mapWindow.Map.IconSearch.OldAllegianceDelving~=mapWindow.Map.IconDelvingCB:IsChecked() then
			mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
			mapWindow.Map.IconSearch.OldAllegianceCreep=mapWindow.Map.IconCreepCB:IsChecked();
			mapWindow.Map.IconSearch.OldAllegianceFreep=mapWindow.Map.IconFreepCB:IsChecked();
			mapWindow.Map.IconSearch.OldAllegianceDelving=mapWindow.Map.IconDelvingCB:IsChecked();
			-- filter the results by search string and checkboxes ...
			local tmpIndex;
			local tmpHeight;
			local tmpAnnotationIndex;
			for tmpIndex=1,mapWindow.Map.IconList:GetItemCount() do
				tmpHeight=mapWindow.Map.IconList:GetItem(tmpIndex).NormalHeight

				tmpAnnotationIndex=mapWindow.Map.IconList:GetItem(tmpIndex).AnnotationIndex
				if tmpAnnotationIndex~=nil and tmpAnnotationIndex~=0 then
					if annotations[tmpAnnotationIndex][5]==2 then
						if not mapWindow.Map.IconCreepCB:IsChecked() then tmpHeight=0 end
					elseif annotations[tmpAnnotationIndex][5]==3 then
						if not mapWindow.Map.IconFreepCB:IsChecked() then tmpHeight=0 end
					elseif annotations[tmpAnnotationIndex][5]==4 then
						if not mapWindow.Map.IconDelvingCB:IsChecked() then tmpHeight=0 end
					end

					if tmpHeight>0 and mapWindow.Map.IconSearch:GetText()~="" then
						if string.find(string.lower(mapWindow.Map.IconList:GetItem(tmpIndex):GetText()),string.lower(mapWindow.Map.IconSearch:GetText()),nil,true)==nil then
							tmpHeight=0;
						end
					end
				end
				mapWindow.Map.IconList:GetItem(tmpIndex):SetHeight(tmpHeight);
			end
		end
	end

	self.Map.IconCreepCB=Turbine.UI.Lotro.CheckBox();
	self.Map.IconCreepCB:SetParent(self.SearchPanel);
	self.Map.IconCreepCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.Map.IconCreepCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.Map.IconCreepCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.Map.IconCreepCB:SetForeColor(Turbine.UI.Color(1,0,0));
	self.Map.IconCreepCB:SetSize(self.SearchPanel:GetWidth()/3-1,18);
	self.Map.IconCreepCB:SetPosition(2,24);
	self.Map.IconCreepCB:SetText(Resource[language][68]);
	self.Map.IconCreepCB:SetChecked(true);
	self.Map.IconCreepCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.Map.IconCreepCBHS:SetParent(self.SearchPanel);
	self.Map.IconCreepCBHS:SetSize(self.Map.IconCreepCB:GetSize());
	self.Map.IconCreepCBHS:SetPosition(self.Map.IconCreepCB:GetPosition());
	self.Map.IconCreepCBHS.MouseClick=function()
		self.Map.IconCreepCB:SetChecked(not self.Map.IconCreepCB:IsChecked());
	end
	self.Map.IconCreepCBHS:SetZOrder(self.Map.IconCreepCB:GetZOrder()+1);

	self.Map.IconFreepCB=Turbine.UI.Lotro.CheckBox();
	self.Map.IconFreepCB:SetParent(self.SearchPanel);
	self.Map.IconFreepCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.Map.IconFreepCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.Map.IconFreepCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.Map.IconFreepCB:SetForeColor(Turbine.UI.Color(.35,.35,1));
	self.Map.IconFreepCB:SetSize(self.SearchPanel:GetWidth()/3-1,18);
	self.Map.IconFreepCB:SetPosition(self.SearchPanel:GetWidth()/3+2,24);
	self.Map.IconFreepCB:SetText(Resource[language][69]);
	self.Map.IconFreepCB:SetChecked(true);
	self.Map.IconFreepCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.Map.IconFreepCBHS:SetParent(self.SearchPanel);
	self.Map.IconFreepCBHS:SetSize(self.Map.IconFreepCB:GetSize());
	self.Map.IconFreepCBHS:SetPosition(self.Map.IconFreepCB:GetPosition());
	self.Map.IconFreepCBHS.MouseClick=function()
		self.Map.IconFreepCB:SetChecked(not self.Map.IconFreepCB:IsChecked());
	end
	self.Map.IconFreepCBHS:SetZOrder(self.Map.IconFreepCB:GetZOrder()+1);
--Turbine.UI.Color(.35,.35,1)
--Turbine.UI.Color(.5,.35,.7)
	self.Map.IconDelvingCB=Turbine.UI.Lotro.CheckBox();
	self.Map.IconDelvingCB:SetParent(self.SearchPanel);
	self.Map.IconDelvingCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.Map.IconDelvingCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.Map.IconDelvingCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.Map.IconDelvingCB:SetForeColor(Turbine.UI.Color(.5,.35,.7));
	self.Map.IconDelvingCB:SetSize(self.SearchPanel:GetWidth()/3-1,18);
	self.Map.IconDelvingCB:SetPosition(self.SearchPanel:GetWidth()*2/3+2,24);
	self.Map.IconDelvingCB:SetText(Resource[language][70]);
	self.Map.IconDelvingCB:SetChecked(true);
	self.Map.IconDelvingCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.Map.IconDelvingCBHS:SetParent(self.SearchPanel);
	self.Map.IconDelvingCBHS:SetSize(self.Map.IconDelvingCB:GetSize());
	self.Map.IconDelvingCBHS:SetPosition(self.Map.IconDelvingCB:GetPosition());
	self.Map.IconDelvingCBHS.MouseClick=function()
		self.Map.IconDelvingCB:SetChecked(not self.Map.IconDelvingCB:IsChecked());
	end
	self.Map.IconDelvingCBHS:SetZOrder(self.Map.IconDelvingCB:GetZOrder()+1);

	self.Map.IconList=Turbine.UI.ListBox();
	self.Map.IconList:SetParent(self.SearchPanel);
	self.Map.IconList:SetSize(self.SearchPanel:GetWidth(),self.SearchPanel:GetHeight()-46);
	self.Map.IconList:SetPosition(0,46);
	self.Map.IconList:SetBackColor(Turbine.UI.Color(.05,.07,.12));

	self.Map.IconSearch:SetWantsUpdates(false);
	self.Map.IconList.VScroll=Turbine.UI.Lotro.ScrollBar();
	self.Map.IconList.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.Map.IconList.VScroll:SetParent(self.Map.IconList);
	self.Map.IconList.VScroll:SetBackColor(backColor);
	self.Map.IconList.VScroll:SetPosition(self.Map.IconList:GetWidth()-12,0);
	self.Map.IconList.VScroll:SetWidth(12);
	self.Map.IconList.VScroll:SetHeight(self.Map.IconList:GetHeight());
	self.Map.IconList:SetVerticalScrollBar(self.Map.IconList.VScroll);
	self.Map.IconList.VScroll:SetVisible(false);

	self.FilterPanel=Turbine.UI.Control();
	self.FilterPanel:SetParent(self);
	self.FilterPanel:SetPosition(20,35);
	self.FilterPanel:SetSize(390,self:GetHeight()-50);
	self.FilterPanel:SetStretchMode(3);
	self.FilterPanel:SetBackColor(Turbine.UI.Color(.10,.07,.05));
	self.FilterPanel:SetVisible(false);

	self.FilterPanel.CloseButton=Turbine.UI.Control();
	self.FilterPanel.CloseButton:SetParent(self.FilterPanel);
	self.FilterPanel.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.FilterPanel.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close.tga");
	self.FilterPanel.CloseButton:SetSize(16,16);
	self.FilterPanel.CloseButton:SetTop(4);
	self.FilterPanel.CloseButton:SetLeft(self.FilterPanel:GetWidth()-20);
	self.FilterPanel.CloseButton.MouseEnter = function()
		self.FilterPanel.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close_hover.tga");
	end
	self.FilterPanel.CloseButton.MouseLeave = function()
		self.FilterPanel.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close.tga");
	end
	self.FilterPanel.CloseButton.MouseClick=function()
		self.FilterPanel:SetVisible(false);
	end
	self.FilterPanel.Title=Turbine.UI.Label()
	self.FilterPanel.Title:SetParent(self.FilterPanel);
	self.FilterPanel.Title:SetSize(self.FilterPanel:GetWidth()-45,18);
	self.FilterPanel.Title:SetPosition((self.FilterPanel:GetWidth()-self.FilterPanel.Title:GetWidth())/2,1);
	self.FilterPanel.Title:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.FilterPanel.Title:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.FilterPanel.Title:SetText(Resource[language][66]);

	self.FilterPanel.Separator1=Turbine.UI.Control();
	self.FilterPanel.Separator1:SetParent(self.FilterPanel);
	self.FilterPanel.Separator1:SetPosition(5,self.FilterPanel.Title:GetTop()+21);
	self.FilterPanel.Separator1:SetSize(self.FilterPanel:GetWidth()-10,1);
	self.FilterPanel.Separator1:SetBackColor(trimColor);

	self.FilterPanel.ViewPane=Turbine.UI.Control()
	self.FilterPanel.ViewPane:SetParent(self.FilterPanel);
	self.FilterPanel.ViewPane:SetPosition(0,self.FilterPanel.Separator1:GetTop()+3);
	self.FilterPanel.ViewPane:SetSize(380,self.FilterPanel:GetHeight()-self.FilterPanel.Separator1:GetTop()-3);
	self.FilterPanel.ViewPane:SetBackColor(Turbine.UI.Color(.10,.07,.05));

	self.FilterPanel.ScrollPanel=Turbine.UI.Control();
	self.FilterPanel.ScrollPanel:SetParent(self.FilterPanel.ViewPane);
	self.FilterPanel.ScrollPanel:SetPosition(0,0);
	if self.CurrentMapID==1 then
		self.FilterPanel.ScrollPanel:SetSize(380,816);
	else
		self.FilterPanel.ScrollPanel:SetSize(380,696);
	end
	self.FilterPanel.ScrollPanel:SetBackColor(Turbine.UI.Color(.10,.07,.05));
	self.FilterPanel.VScroll=Turbine.UI.Lotro.ScrollBar();

	self.FilterPanel.VScroll:SetParent(self.FilterPanel);
	self.FilterPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.FilterPanel.VScroll:SetPosition(380,self.FilterPanel.ViewPane:GetTop());
	self.FilterPanel.VScroll:SetSize(10,self.FilterPanel.ViewPane:GetHeight());

	self.FilterPanel.VScroll.ValueChanged=function(sender,args)
		local lValue=self.FilterPanel.VScroll:GetValue();
		self.FilterPanel.ScrollPanel:SetTop(0-lValue);
	end
	self.FilterPanel.VScroll:SetMaximum(self.FilterPanel.ScrollPanel:GetHeight()-self.FilterPanel.ViewPane:GetHeight());
	self.FilterPanel.VScroll:SetVisible(self.FilterPanel.ViewPane:GetHeight()<self.FilterPanel.ScrollPanel:GetHeight());

	self.FilterPanel.AllegianceCaption=Turbine.UI.Label();
	self.FilterPanel.AllegianceCaption:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.AllegianceCaption:SetPosition(5,0);
	self.FilterPanel.AllegianceCaption:SetSize(95,18);
	self.FilterPanel.AllegianceCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.AllegianceCaption:SetForeColor(fontColor);
	self.FilterPanel.AllegianceCaption:SetText(Resource[language][67]..":");

	self.FilterPanel.AllegianceCreep=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.AllegianceCreep:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.AllegianceCreep:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.AllegianceCreep:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.FilterPanel.AllegianceCreep:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.FilterPanel.AllegianceCreep:SetForeColor(Turbine.UI.Color(1,0,0));
	self.FilterPanel.AllegianceCreep:SetSize((self.FilterPanel.ScrollPanel:GetWidth()-self.FilterPanel.AllegianceCaption:GetWidth()-10),18);
	self.FilterPanel.AllegianceCreep:SetPosition(self.FilterPanel.AllegianceCaption:GetLeft()+self.FilterPanel.AllegianceCaption:GetWidth(),self.FilterPanel.AllegianceCaption:GetTop());
	self.FilterPanel.AllegianceCreep:SetText(Resource[language][68]);
	self.FilterPanel.AllegianceCreep:SetChecked(filterAllegianceCreep);
	self.FilterPanel.AllegianceCreepHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.AllegianceCreepHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.AllegianceCreepHS:SetSize(self.FilterPanel.AllegianceCreep:GetSize());
	self.FilterPanel.AllegianceCreepHS:SetPosition(self.FilterPanel.AllegianceCreep:GetPosition());
	self.FilterPanel.AllegianceCreepHS.MouseClick=function()
		self.FilterPanel.AllegianceCreep:SetChecked(not self.FilterPanel.AllegianceCreep:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.AllegianceCreepHS:SetZOrder(self.FilterPanel.AllegianceCreep:GetZOrder()+1);

	self.FilterPanel.AllegianceFreep=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.AllegianceFreep:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.AllegianceFreep:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.FilterPanel.AllegianceFreep:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.FilterPanel.AllegianceFreep:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.AllegianceFreep:SetForeColor(Turbine.UI.Color(.35,.35,1));
	self.FilterPanel.AllegianceFreep:SetSize((self.FilterPanel.ScrollPanel:GetWidth()-self.FilterPanel.AllegianceCaption:GetWidth()-10),18);
	self.FilterPanel.AllegianceFreep:SetPosition(self.FilterPanel.AllegianceCreep:GetLeft(),self.FilterPanel.AllegianceCreep:GetTop()+20);
	self.FilterPanel.AllegianceFreep:SetText(Resource[language][69]);
	self.FilterPanel.AllegianceFreep:SetChecked(filterAllegianceFreep);
	self.FilterPanel.AllegianceFreepHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.AllegianceFreepHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.AllegianceFreepHS:SetSize(self.FilterPanel.AllegianceFreep:GetSize());
	self.FilterPanel.AllegianceFreepHS:SetPosition(self.FilterPanel.AllegianceFreep:GetPosition());
	self.FilterPanel.AllegianceFreepHS.MouseClick=function()
		self.FilterPanel.AllegianceFreep:SetChecked(not self.FilterPanel.AllegianceFreep:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.AllegianceFreepHS:SetZOrder(self.FilterPanel.AllegianceFreep:GetZOrder()+1);

	self.FilterPanel.AllegianceDelving=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.AllegianceDelving:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.AllegianceDelving:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.FilterPanel.AllegianceDelving:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.FilterPanel.AllegianceDelving:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.AllegianceDelving:SetForeColor(Turbine.UI.Color(.5,.35,.7));
	self.FilterPanel.AllegianceDelving:SetSize((self.FilterPanel.ScrollPanel:GetWidth()-self.FilterPanel.AllegianceCaption:GetWidth()-10),18);
	self.FilterPanel.AllegianceDelving:SetPosition(self.FilterPanel.AllegianceCreep:GetLeft(),self.FilterPanel.AllegianceFreep:GetTop()+20);
	self.FilterPanel.AllegianceDelving:SetText(Resource[language][70]);
	self.FilterPanel.AllegianceDelving:SetChecked(filterAllegianceDelving);
	self.FilterPanel.AllegianceDelvingHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.AllegianceDelvingHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.AllegianceDelvingHS:SetSize(self.FilterPanel.AllegianceDelving:GetSize());
	self.FilterPanel.AllegianceDelvingHS:SetPosition(self.FilterPanel.AllegianceDelving:GetPosition());
	self.FilterPanel.AllegianceDelvingHS.MouseClick=function()
		self.FilterPanel.AllegianceDelving:SetChecked(not self.FilterPanel.AllegianceDelving:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.AllegianceDelvingHS:SetZOrder(self.FilterPanel.AllegianceDelving:GetZOrder()+1);

	self.FilterPanel.Separator2=Turbine.UI.Control();
	self.FilterPanel.Separator2:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.Separator2:SetPosition(5,self.FilterPanel.AllegianceDelving:GetTop()+22);
	self.FilterPanel.Separator2:SetSize(self.FilterPanel.ScrollPanel:GetWidth()-10,1);
	self.FilterPanel.Separator2:SetBackColor(trimColor);

	self.FilterPanel.SelectAllButton=Turbine.UI.Lotro.Button();
	self.FilterPanel.SelectAllButton:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.SelectAllButton:SetSize(140,18);
	self.FilterPanel.SelectAllButton:SetTop(self.FilterPanel.Separator2:GetTop()+6);
	self.FilterPanel.SelectAllButton:SetLeft(5);
	self.FilterPanel.SelectAllButton:SetText("Select All");
	self.FilterPanel.SelectAllButton.MouseClick=function()
		-- we don't currently include allegiance in "select all"
		--self.FilterPanel.AllegianceCreep:SetChecked(true);
		--self.FilterPanel.AllegianceFreep:SetChecked(true);
		--self.FilterPanel.AllegianceDelving:SetChecked(true);
		-- set all Type filter options on
		self.FilterPanel.TypeMain:SetChecked(true);
		self.FilterPanel.TypeSecondary:SetChecked(true);
		self.FilterPanel.TypeBase:SetChecked(true);
		self.FilterPanel.TypeOutpost:SetChecked(true);
		self.FilterPanel.TypeFort:SetChecked(true);
		self.FilterPanel.TypePOI:SetChecked(true);
		self.FilterPanel.TypeRez:SetChecked(true);
		self.FilterPanel.TypeMap:SetChecked(true);
		self.FilterPanel.TypeNPC:SetChecked(true);
		self.FilterPanel.TypeCook:SetChecked(true);
		self.FilterPanel.TypeScholarIngredient:SetChecked(true);
		self.FilterPanel.TypeAuctioneer:SetChecked(true);
		self.FilterPanel.TypeBarber:SetChecked(true);
		self.FilterPanel.TypeBard:SetChecked(true);
		self.FilterPanel.TypeCampSite:SetChecked(true);
		self.FilterPanel.TypeCraftSite:SetChecked(true);
		self.FilterPanel.TypeCraftVendor:SetChecked(true);
		self.FilterPanel.TypeFactionRep:SetChecked(true);
		self.FilterPanel.TypeItemMaster:SetChecked(true);
		self.FilterPanel.TypeMailbox:SetChecked(true);
		self.FilterPanel.TypeMilestone:SetChecked(true);
		self.FilterPanel.TypeMusteringHorn:SetChecked(true);
		self.FilterPanel.TypeReflectingPool:SetChecked(true);
		self.FilterPanel.TypeSettlement:SetChecked(true);
		self.FilterPanel.TypeStableMaster:SetChecked(true);
		self.FilterPanel.TypeTownCrier:SetChecked(true);
		self.FilterPanel.TypeTrader:SetChecked(true);
		self.FilterPanel.TypeTrainer:SetChecked(true);
		self.FilterPanel.TypeVaultKeeper:SetChecked(true);
		self.FilterPanel.TypeVendor:SetChecked(true);
		self.FilterPanel.TypeSkirmishCamp:SetChecked(true);
		self.FilterPanel.TypeOreNode:SetChecked(true);
		self.FilterPanel.TypeWoodNode:SetChecked(true);
		self.FilterPanel.TypeScholarNode:SetChecked(true);
		self.FilterPanel.TypeDungeon:SetChecked(true);
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end

	self.FilterPanel.ClearAllButton=Turbine.UI.Lotro.Button();
	self.FilterPanel.ClearAllButton:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.ClearAllButton:SetSize(140,18);
	self.FilterPanel.ClearAllButton:SetTop(self.FilterPanel.SelectAllButton:GetTop());
	self.FilterPanel.ClearAllButton:SetLeft(self.FilterPanel.ScrollPanel:GetWidth()-145);
	self.FilterPanel.ClearAllButton:SetText("Clear All");
	self.FilterPanel.ClearAllButton.MouseClick=function()
		--self.FilterPanel.AllegianceCreep:SetChecked(false);
		--self.FilterPanel.AllegianceFreep:SetChecked(false);
		--self.FilterPanel.AllegianceDelving:SetChecked(false);
		-- set all Type filter options off
		self.FilterPanel.TypeMain:SetChecked(false);
		self.FilterPanel.TypeSecondary:SetChecked(false);
		self.FilterPanel.TypeBase:SetChecked(false);
		self.FilterPanel.TypeOutpost:SetChecked(false);
		self.FilterPanel.TypeFort:SetChecked(false);
		self.FilterPanel.TypePOI:SetChecked(false);
		self.FilterPanel.TypeRez:SetChecked(false);
		self.FilterPanel.TypeMap:SetChecked(false);
		self.FilterPanel.TypeNPC:SetChecked(false);
		self.FilterPanel.TypeCook:SetChecked(false);
		self.FilterPanel.TypeScholarIngredient:SetChecked(false);
		self.FilterPanel.TypeAuctioneer:SetChecked(false);
		self.FilterPanel.TypeBarber:SetChecked(false);
		self.FilterPanel.TypeBard:SetChecked(false);
		self.FilterPanel.TypeCampSite:SetChecked(false);
		self.FilterPanel.TypeCraftSite:SetChecked(false);
		self.FilterPanel.TypeCraftVendor:SetChecked(false);
		self.FilterPanel.TypeFactionRep:SetChecked(false);
		self.FilterPanel.TypeItemMaster:SetChecked(false);
		self.FilterPanel.TypeMailbox:SetChecked(false);
		self.FilterPanel.TypeMilestone:SetChecked(false);
		self.FilterPanel.TypeMusteringHorn:SetChecked(false);
		self.FilterPanel.TypeReflectingPool:SetChecked(false);
		self.FilterPanel.TypeSettlement:SetChecked(false);
		self.FilterPanel.TypeStableMaster:SetChecked(false);
		self.FilterPanel.TypeTownCrier:SetChecked(false);
		self.FilterPanel.TypeTrader:SetChecked(false);
		self.FilterPanel.TypeTrainer:SetChecked(false);
		self.FilterPanel.TypeVaultKeeper:SetChecked(false);
		self.FilterPanel.TypeVendor:SetChecked(false);
		self.FilterPanel.TypeSkirmishCamp:SetChecked(false);
		self.FilterPanel.TypeOreNode:SetChecked(false);
		self.FilterPanel.TypeWoodNode:SetChecked(false);
		self.FilterPanel.TypeScholarNode:SetChecked(false);
		self.FilterPanel.TypeDungeon:SetChecked(false);
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end

	self.FilterPanel.SetDefaultButton=Turbine.UI.Lotro.Button();
	self.FilterPanel.SetDefaultButton:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.SetDefaultButton:SetSize(140,18);
	self.FilterPanel.SetDefaultButton:SetTop(self.FilterPanel.SelectAllButton:GetTop()+20);
	self.FilterPanel.SetDefaultButton:SetLeft(5);
	self.FilterPanel.SetDefaultButton:SetText("Select Default");
	self.FilterPanel.SetDefaultButton.MouseClick=function()
		self.FilterPanel.TypeMain:SetChecked(self.FilterMainDefault);
		self.FilterPanel.TypeSecondary:SetChecked(self.FilterSecondaryDefault);
		self.FilterPanel.TypeBase:SetChecked(self.FilterBaseDefault);
		self.FilterPanel.TypeOutpost:SetChecked(self.FilterOutpostDefault);
		self.FilterPanel.TypeFort:SetChecked(self.FilterFortDefault);
		self.FilterPanel.TypePOI:SetChecked(self.FilterPOIDefault);
		self.FilterPanel.TypeRez:SetChecked(self.FilterRezDefault);
		self.FilterPanel.TypeMap:SetChecked(self.FilterMapDefault);
		self.FilterPanel.TypeNPC:SetChecked(self.FilterNPCDefault);
		self.FilterPanel.TypeCook:SetChecked(self.FilterCookDefault);
		self.FilterPanel.TypeScholarIngredient:SetChecked(self.FilterScholarIngredientDefault);
		self.FilterPanel.TypeAuctioneer:SetChecked(self.FilterAuctioneerDefault);
		self.FilterPanel.TypeBarber:SetChecked(self.FilterBarberDefault);
		self.FilterPanel.TypeBard:SetChecked(self.FilterBardDefault);
		self.FilterPanel.TypeCampSite:SetChecked(self.FilterCampSiteDefault);
		self.FilterPanel.TypeCraftSite:SetChecked(self.FilterCraftSiteDefault);
		self.FilterPanel.TypeCraftVendor:SetChecked(self.FilterCraftVendorDefault);
		self.FilterPanel.TypeFactionRep:SetChecked(self.FilterFactionRepDefault);
		self.FilterPanel.TypeItemMaster:SetChecked(self.FilterItemMasterDefault);
		self.FilterPanel.TypeMailbox:SetChecked(self.FilterMailboxDefault);
		self.FilterPanel.TypeMilestone:SetChecked(self.FilterMilestoneDefault);
		self.FilterPanel.TypeMusteringHorn:SetChecked(self.FilterMusteringHornDefault);
		self.FilterPanel.TypeReflectingPool:SetChecked(self.FilterReflectingPoolDefault);
		self.FilterPanel.TypeSettlement:SetChecked(self.FilterSettlementDefault);
		self.FilterPanel.TypeStableMaster:SetChecked(self.FilterStableMasterDefault);
		self.FilterPanel.TypeTownCrier:SetChecked(self.FilterTownCrierDefault);
		self.FilterPanel.TypeTrader:SetChecked(self.FilterTraderDefault);
		self.FilterPanel.TypeTrainer:SetChecked(self.FilterTrainerDefault);
		self.FilterPanel.TypeVaultKeeper:SetChecked(self.FilterVaultKeeperDefault);
		self.FilterPanel.TypeVendor:SetChecked(self.FilterVendorDefault);
		self.FilterPanel.TypeSkirmishCamp:SetChecked(self.FilterSkirmishCampDefault);
		self.FilterPanel.TypeOreNode:SetChecked(self.FilterOreNodeDefault);
		self.FilterPanel.TypeWoodNode:SetChecked(self.FilterWoodNodeDefault);
		self.FilterPanel.TypeScholarNode:SetChecked(self.FilterScholarNodeDefault);
		self.FilterPanel.TypeDungeon:SetChecked(self.FilterDungeonDefault);
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end

	self.FilterPanel.SaveDefaultButton=Turbine.UI.Lotro.Button();
	self.FilterPanel.SaveDefaultButton:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.SaveDefaultButton:SetSize(140,18);
	self.FilterPanel.SaveDefaultButton:SetTop(self.FilterPanel.SelectAllButton:GetTop()+20);
	self.FilterPanel.SaveDefaultButton:SetLeft(self.FilterPanel.ScrollPanel:GetWidth()-145);
	self.FilterPanel.SaveDefaultButton:SetText("Save Default");
	self.FilterPanel.SaveDefaultButton.MouseClick=function()
		self.FilterMainDefault=self.FilterPanel.TypeMain:IsChecked();
		self.FilterSecondaryDefault=self.FilterPanel.TypeSecondary:IsChecked();
		self.FilterBaseDefault=self.FilterPanel.TypeBase:IsChecked();
		self.FilterOutpostDefault=self.FilterPanel.TypeOutpost:IsChecked();
		self.FilterFortDefault=self.FilterPanel.TypeFort:IsChecked();
		self.FilterPOIDefault=self.FilterPanel.TypePOI:IsChecked();
		self.FilterRezDefault=self.FilterPanel.TypeRez:IsChecked();
		self.FilterMapDefault=self.FilterPanel.TypeMap:IsChecked();
		self.FilterNPCDefault=self.FilterPanel.TypeNPC:IsChecked();
		self.FilterCookDefault=self.FilterPanel.TypeCook:IsChecked();
		self.FilterScholarIngredientDefault=self.FilterPanel.TypeScholarIngredient:IsChecked();
		self.FilterAuctioneerDefault=self.FilterPanel.TypeAuctioneer:IsChecked();
		self.FilterBarberDefault=self.FilterPanel.TypeBarber:IsChecked();
		self.FilterBardDefault=self.FilterPanel.TypeBard:IsChecked();
		self.FilterCampSiteDefault=self.FilterPanel.TypeCampSite:IsChecked();
		self.FilterCraftSiteDefault=self.FilterPanel.TypeCraftSite:IsChecked();
		self.FilterCraftVendorDefault=self.FilterPanel.TypeCraftVendor:IsChecked();
		self.FilterFactionRepDefault=self.FilterPanel.TypeFactionRep:IsChecked();
		self.FilterItemMasterDefault=self.FilterPanel.TypeItemMaster:IsChecked();
		self.FilterMailboxDefault=self.FilterPanel.TypeMailbox:IsChecked();
		self.FilterMilestoneDefault=self.FilterPanel.TypeMilestone:IsChecked();
		self.FilterMusteringHornDefault=self.FilterPanel.TypeMusteringHorn:IsChecked();
		self.FilterReflectingPoolDefault=self.FilterPanel.TypeReflectingPool:IsChecked();
		self.FilterSettlementDefault=self.FilterPanel.TypeSettlement:IsChecked();
		self.FilterStableMasterDefault=self.FilterPanel.TypeStableMaster:IsChecked();
		self.FilterTownCrierDefault=self.FilterPanel.TypeTownCrier:IsChecked();
		self.FilterTraderDefault=self.FilterPanel.TypeTrader:IsChecked();
		self.FilterTrainerDefault=self.FilterPanel.TypeTrainer:IsChecked();
		self.FilterVaultKeeperDefault=self.FilterPanel.TypeVaultKeeper:IsChecked();
		self.FilterVendorDefault=self.FilterPanel.TypeVendor:IsChecked();
		self.FilterSkirmishCampDefault=self.FilterPanel.TypeSkirmishCamp:IsChecked();
		self.FilterOreNodeDefault=self.FilterPanel.TypeOreNode:IsChecked();
		self.FilterWoodNodeDefault=self.FilterPanel.TypeWoodNode:IsChecked();
		self.FilterScholarNodeDefault=self.FilterPanel.TypeScholarNode:IsChecked();
		self.FilterDungeonDefault=self.FilterPanel.TypeDungeon:IsChecked();
	end

	self.FilterPanel.TypeCaption=Turbine.UI.Label();
	self.FilterPanel.TypeCaption:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCaption:SetPosition(5,self.FilterPanel.SetDefaultButton:GetTop()+22);
	self.FilterPanel.TypeCaption:SetSize(80,18);
	self.FilterPanel.TypeCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeCaption:SetForeColor(fontColor);
	self.FilterPanel.TypeCaption:SetText(Resource[language][74]..":");

	self.FilterPanel.TypeMain=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeMain:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMain:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeMain:SetForeColor(fontColor);
	self.FilterPanel.TypeMain:SetSize(self.FilterPanel.ScrollPanel:GetWidth()-self.FilterPanel.TypeCaption:GetWidth()-10,18);
	self.FilterPanel.TypeMain:SetPosition(self.FilterPanel.TypeCaption:GetLeft()+self.FilterPanel.TypeCaption:GetWidth(),self.FilterPanel.TypeCaption:GetTop());
	self.FilterPanel.TypeMain:SetText(Resource[language][106]);
	self.FilterPanel.TypeMain:SetChecked(filterTypeMain);
	self.FilterPanel.TypeMainHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeMainHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMainHS:SetSize(self.FilterPanel.TypeMain:GetSize());
	self.FilterPanel.TypeMainHS:SetPosition(self.FilterPanel.TypeMain:GetPosition());
	self.FilterPanel.TypeMainHS.MouseClick=function()
		self.FilterPanel.TypeMain:SetChecked(not self.FilterPanel.TypeMain:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeMainHS:SetZOrder(self.FilterPanel.TypeMain:GetZOrder()+1);
	self.FilterPanel.TypeMainIcon=Turbine.UI.Control();
	self.FilterPanel.TypeMainIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMainIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[1]~=nil and iconInfo[1][6]~=nil then
		self.FilterPanel.TypeMainIcon:SetBackground(iconInfo[1][6]);
	end
	self.FilterPanel.TypeMainIcon:SetStretchMode(2);
	self.FilterPanel.TypeMainIcon:SetSize(self.FilterPanel.TypeMainIcon:GetWidth(),self.FilterPanel.TypeMainIcon:GetHeight());
	self.FilterPanel.TypeMainIcon:SetStretchMode(0);
	self.FilterPanel.TypeMainIcon:SetPosition(self.FilterPanel.TypeMain:GetLeft()-20,self.FilterPanel.TypeMain:GetTop());

	self.FilterPanel.TypeMain:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeMainHS:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeMainIcon:SetVisible((self.CurrentMapID==1))

	self.FilterPanel.TypeSecondary=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeSecondary:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSecondary:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeSecondary:SetForeColor(fontColor);
	self.FilterPanel.TypeSecondary:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeSecondary:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeMain:GetTop()+20);
	self.FilterPanel.TypeSecondary:SetText(Resource[language][107]);
	self.FilterPanel.TypeSecondary:SetChecked(filterTypeSecondary);
	self.FilterPanel.TypeSecondaryHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeSecondaryHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSecondaryHS:SetSize(self.FilterPanel.TypeSecondary:GetSize());
	self.FilterPanel.TypeSecondaryHS:SetPosition(self.FilterPanel.TypeSecondary:GetPosition());
	self.FilterPanel.TypeSecondaryHS.MouseClick=function()
		self.FilterPanel.TypeSecondary:SetChecked(not self.FilterPanel.TypeSecondary:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeSecondaryHS:SetZOrder(self.FilterPanel.TypeSecondary:GetZOrder()+1);
	self.FilterPanel.TypeSecondaryIcon=Turbine.UI.Control();
	self.FilterPanel.TypeSecondaryIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSecondaryIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[2]~=nil and iconInfo[2][6]~=nil then
		self.FilterPanel.TypeSecondaryIcon:SetBackground(iconInfo[2][6]);
	end
	self.FilterPanel.TypeSecondaryIcon:SetStretchMode(2);
	self.FilterPanel.TypeSecondaryIcon:SetSize(self.FilterPanel.TypeSecondaryIcon:GetWidth(),self.FilterPanel.TypeSecondaryIcon:GetHeight());
	self.FilterPanel.TypeSecondaryIcon:SetStretchMode(0);
	self.FilterPanel.TypeSecondaryIcon:SetPosition(self.FilterPanel.TypeSecondary:GetLeft()-20,self.FilterPanel.TypeSecondary:GetTop());

	self.FilterPanel.TypeSecondary:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeSecondaryHS:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeSecondaryIcon:SetVisible((self.CurrentMapID==1))

	self.FilterPanel.TypeBase=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeBase:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBase:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeBase:SetForeColor(fontColor);
	self.FilterPanel.TypeBase:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeBase:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeSecondary:GetTop()+20);
	self.FilterPanel.TypeBase:SetText(Resource[language][108]);
	self.FilterPanel.TypeBase:SetChecked(filterTypeBase);
	self.FilterPanel.TypeBaseHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeBaseHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBaseHS:SetSize(self.FilterPanel.TypeBase:GetSize());
	self.FilterPanel.TypeBaseHS:SetPosition(self.FilterPanel.TypeBase:GetPosition());
	self.FilterPanel.TypeBaseHS.MouseClick=function()
		self.FilterPanel.TypeBase:SetChecked(not self.FilterPanel.TypeBase:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeBaseHS:SetZOrder(self.FilterPanel.TypeBase:GetZOrder()+1);
	self.FilterPanel.TypeBaseIcon=Turbine.UI.Control();
	self.FilterPanel.TypeBaseIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBaseIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[3]~=nil and iconInfo[3][6]~=nil then
		self.FilterPanel.TypeBaseIcon:SetBackground(iconInfo[3][6]);
	end
	self.FilterPanel.TypeBaseIcon:SetStretchMode(2);
	self.FilterPanel.TypeBaseIcon:SetSize(self.FilterPanel.TypeBaseIcon:GetWidth(),self.FilterPanel.TypeBaseIcon:GetHeight());
	self.FilterPanel.TypeBaseIcon:SetStretchMode(0);
	self.FilterPanel.TypeBaseIcon:SetPosition(self.FilterPanel.TypeBase:GetLeft()-20,self.FilterPanel.TypeBase:GetTop());

	self.FilterPanel.TypeBase:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeBaseHS:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeBaseIcon:SetVisible((self.CurrentMapID==1))

	self.FilterPanel.TypeOutpost=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeOutpost:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeOutpost:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeOutpost:SetForeColor(fontColor);
	self.FilterPanel.TypeOutpost:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeOutpost:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeBase:GetTop()+20);
	self.FilterPanel.TypeOutpost:SetText(Resource[language][109]);
	self.FilterPanel.TypeOutpost:SetChecked(filterTypeOutpost);
	self.FilterPanel.TypeOutpostHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeOutpostHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeOutpostHS:SetSize(self.FilterPanel.TypeOutpost:GetSize());
	self.FilterPanel.TypeOutpostHS:SetPosition(self.FilterPanel.TypeOutpost:GetPosition());
	self.FilterPanel.TypeOutpostHS.MouseClick=function()
		self.FilterPanel.TypeOutpost:SetChecked(not self.FilterPanel.TypeOutpost:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeOutpostHS:SetZOrder(self.FilterPanel.TypeOutpost:GetZOrder()+1);
	self.FilterPanel.TypeOutpostIcon=Turbine.UI.Control();
	self.FilterPanel.TypeOutpostIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeOutpostIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[4]~=nil and iconInfo[4][6]~=nil then
		self.FilterPanel.TypeOutpostIcon:SetBackground(iconInfo[4][6]);
	end
	self.FilterPanel.TypeOutpostIcon:SetStretchMode(2);
	self.FilterPanel.TypeOutpostIcon:SetSize(self.FilterPanel.TypeOutpostIcon:GetWidth(),self.FilterPanel.TypeOutpostIcon:GetHeight());
	self.FilterPanel.TypeOutpostIcon:SetStretchMode(0);
	self.FilterPanel.TypeOutpostIcon:SetPosition(self.FilterPanel.TypeOutpost:GetLeft()-20,self.FilterPanel.TypeOutpost:GetTop());

	self.FilterPanel.TypeOutpost:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeOutpostHS:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeOutpostIcon:SetVisible((self.CurrentMapID==1))

	self.FilterPanel.TypeFort=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeFort:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeFort:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeFort:SetForeColor(fontColor);
	self.FilterPanel.TypeFort:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeFort:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeOutpost:GetTop()+20);
	self.FilterPanel.TypeFort:SetText(Resource[language][111]);
	self.FilterPanel.TypeFort:SetChecked(filterTypeFort);
	self.FilterPanel.TypeFortHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeFortHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeFortHS:SetSize(self.FilterPanel.TypeFort:GetSize());
	self.FilterPanel.TypeFortHS:SetPosition(self.FilterPanel.TypeFort:GetPosition());
	self.FilterPanel.TypeFortHS.MouseClick=function()
		self.FilterPanel.TypeFort:SetChecked(not self.FilterPanel.TypeFort:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeFortHS:SetZOrder(self.FilterPanel.TypeFort:GetZOrder()+1);
	self.FilterPanel.TypeFortIcon=Turbine.UI.Control();
	self.FilterPanel.TypeFortIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeFortIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[6]~=nil and iconInfo[6][6]~=nil then
		self.FilterPanel.TypeFortIcon:SetBackground(iconInfo[6][6]);
	end
	self.FilterPanel.TypeFortIcon:SetStretchMode(2);
	self.FilterPanel.TypeFortIcon:SetSize(self.FilterPanel.TypeFortIcon:GetWidth(),self.FilterPanel.TypeFortIcon:GetHeight());
	self.FilterPanel.TypeFortIcon:SetStretchMode(0);
	self.FilterPanel.TypeFortIcon:SetPosition(self.FilterPanel.TypeFort:GetLeft()-20,self.FilterPanel.TypeFort:GetTop());

	self.FilterPanel.TypeFort:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeFortHS:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeFortIcon:SetVisible((self.CurrentMapID==1))

	self.FilterPanel.TypeMap=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeMap:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeMap:SetForeColor(fontColor);
	self.FilterPanel.TypeMap:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeMap:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeFort:GetTop()+20);
	self.FilterPanel.TypeMap:SetText(Resource[language][119]);
	self.FilterPanel.TypeMap:SetChecked(filterTypeMap);
	self.FilterPanel.TypeMapHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeMapHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMapHS:SetSize(self.FilterPanel.TypeMap:GetSize());
	self.FilterPanel.TypeMapHS:SetPosition(self.FilterPanel.TypeMap:GetPosition());
	self.FilterPanel.TypeMapHS.MouseClick=function()
		self.FilterPanel.TypeMap:SetChecked(not self.FilterPanel.TypeMap:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeMapHS:SetZOrder(self.FilterPanel.TypeMap:GetZOrder()+1);
	self.FilterPanel.TypeMapIcon=Turbine.UI.Control();
	self.FilterPanel.TypeMapIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMapIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[10]~=nil and iconInfo[10][6]~=nil then
		self.FilterPanel.TypeMapIcon:SetBackground(iconInfo[10][6]);
	end
	self.FilterPanel.TypeMapIcon:SetStretchMode(2);
	self.FilterPanel.TypeMapIcon:SetSize(self.FilterPanel.TypeMapIcon:GetWidth(),self.FilterPanel.TypeMapIcon:GetHeight());
	self.FilterPanel.TypeMapIcon:SetStretchMode(0);
	self.FilterPanel.TypeMapIcon:SetPosition(self.FilterPanel.TypeMap:GetLeft()-20,self.FilterPanel.TypeMap:GetTop());

	self.FilterPanel.TypeMap:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeMapHS:SetVisible((self.CurrentMapID==1))
	self.FilterPanel.TypeMapIcon:SetVisible((self.CurrentMapID==1))

	self.FilterPanel.TypePOI=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypePOI:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypePOI:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypePOI:SetForeColor(fontColor);
	self.FilterPanel.TypePOI:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	if self.CurrentMapID==1 then
		self.FilterPanel.TypePOI:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeMap:GetTop()+20);
	else
		self.FilterPanel.TypePOI:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeCaption:GetTop());
	end

	self.FilterPanel.TypePOI:SetText(Resource[language][110]);
	self.FilterPanel.TypePOI:SetChecked(filterTypePOI);
	self.FilterPanel.TypePOIHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypePOIHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypePOIHS:SetSize(self.FilterPanel.TypePOI:GetSize());
	self.FilterPanel.TypePOIHS:SetPosition(self.FilterPanel.TypePOI:GetPosition());
	self.FilterPanel.TypePOIHS.MouseClick=function()
		self.FilterPanel.TypePOI:SetChecked(not self.FilterPanel.TypePOI:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypePOIHS:SetZOrder(self.FilterPanel.TypePOI:GetZOrder()+1);
	self.FilterPanel.TypePOIIcon=Turbine.UI.Control();
	self.FilterPanel.TypePOIIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypePOIIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[5]~=nil and iconInfo[5][6]~=nil then
		self.FilterPanel.TypePOIIcon:SetBackground(iconInfo[5][6]);
	end
	self.FilterPanel.TypePOIIcon:SetStretchMode(2);
	self.FilterPanel.TypePOIIcon:SetSize(self.FilterPanel.TypePOIIcon:GetWidth(),self.FilterPanel.TypePOIIcon:GetHeight());
	self.FilterPanel.TypePOIIcon:SetStretchMode(0);
	self.FilterPanel.TypePOIIcon:SetPosition(self.FilterPanel.TypePOI:GetLeft()-20,self.FilterPanel.TypePOI:GetTop());

	self.FilterPanel.TypeRez=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeRez:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeRez:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeRez:SetForeColor(fontColor);
	self.FilterPanel.TypeRez:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeRez:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypePOI:GetTop()+20);
	self.FilterPanel.TypeRez:SetText(Resource[language][112]);
	self.FilterPanel.TypeRez:SetChecked(filterTypeRez);
	self.FilterPanel.TypeRezHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeRezHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeRezHS:SetSize(self.FilterPanel.TypeRez:GetSize());
	self.FilterPanel.TypeRezHS:SetPosition(self.FilterPanel.TypeRez:GetPosition());
	self.FilterPanel.TypeRezHS.MouseClick=function()
		self.FilterPanel.TypeRez:SetChecked(not self.FilterPanel.TypeRez:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeRezHS:SetZOrder(self.FilterPanel.TypeRez:GetZOrder()+1);
	self.FilterPanel.TypeRezIcon=Turbine.UI.Control();
	self.FilterPanel.TypeRezIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeRezIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[7]~=nil and iconInfo[7][6]~=nil then
		self.FilterPanel.TypeRezIcon:SetBackground(iconInfo[7][6]);
	end
	self.FilterPanel.TypeRezIcon:SetStretchMode(2);
	self.FilterPanel.TypeRezIcon:SetSize(self.FilterPanel.TypeRezIcon:GetWidth(),self.FilterPanel.TypeRezIcon:GetHeight());
	self.FilterPanel.TypeRezIcon:SetStretchMode(0);
	self.FilterPanel.TypeRezIcon:SetPosition(self.FilterPanel.TypeRez:GetLeft()-20,self.FilterPanel.TypeRez:GetTop());

	self.FilterPanel.TypeNPC=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeNPC:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeNPC:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeNPC:SetForeColor(fontColor);
	self.FilterPanel.TypeNPC:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeNPC:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeRez:GetTop()+20);
	self.FilterPanel.TypeNPC:SetText(Resource[language][116]);
	self.FilterPanel.TypeNPC:SetChecked(filterTypeNPC);
	self.FilterPanel.TypeNPCHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeNPCHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeNPCHS:SetSize(self.FilterPanel.TypeNPC:GetSize());
	self.FilterPanel.TypeNPCHS:SetPosition(self.FilterPanel.TypeNPC:GetPosition());
	self.FilterPanel.TypeNPCHS.MouseClick=function()
		self.FilterPanel.TypeNPC:SetChecked(not self.FilterPanel.TypeNPC:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeNPCHS:SetZOrder(self.FilterPanel.TypeNPC:GetZOrder()+1);
	self.FilterPanel.TypeNPCIcon=Turbine.UI.Control();
	self.FilterPanel.TypeNPCIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeNPCIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[11]~=nil and iconInfo[11][6]~=nil then
		self.FilterPanel.TypeNPCIcon:SetBackground(iconInfo[11][6]);
	end
	self.FilterPanel.TypeNPCIcon:SetStretchMode(2);
	self.FilterPanel.TypeNPCIcon:SetSize(self.FilterPanel.TypeNPCIcon:GetWidth(),self.FilterPanel.TypeNPCIcon:GetHeight());
	self.FilterPanel.TypeNPCIcon:SetStretchMode(0);
	self.FilterPanel.TypeNPCIcon:SetPosition(self.FilterPanel.TypeNPC:GetLeft()-20,self.FilterPanel.TypeNPC:GetTop());

	self.FilterPanel.TypeOreNode=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeOreNode:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeOreNode:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeOreNode:SetForeColor(fontColor);
	self.FilterPanel.TypeOreNode:SetSize(self.FilterPanel.TypeMain:GetWidth()/2,18);
	self.FilterPanel.TypeOreNode:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeNPC:GetTop()+20);
	self.FilterPanel.TypeOreNode:SetText(Resource[language][155]);
	self.FilterPanel.TypeOreNode:SetChecked(filterTypeOreNode);
	self.FilterPanel.TypeOreNodeHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeOreNodeHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeOreNodeHS:SetSize(self.FilterPanel.TypeOreNode:GetSize());
	self.FilterPanel.TypeOreNodeHS:SetPosition(self.FilterPanel.TypeOreNode:GetPosition());
	self.FilterPanel.TypeOreNodeHS.MouseClick=function()
		self.FilterPanel.TypeOreNode:SetChecked(not self.FilterPanel.TypeOreNode:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeOreNodeHS:SetZOrder(self.FilterPanel.TypeOreNode:GetZOrder()+1);
	self.FilterPanel.TypeOreNodeIcon=Turbine.UI.Control();
	self.FilterPanel.TypeOreNodeIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeOreNodeIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[43]~=nil and iconInfo[43][6]~=nil then
		self.FilterPanel.TypeOreNodeIcon:SetBackground(iconInfo[43][6]);
	end
	self.FilterPanel.TypeOreNodeIcon:SetStretchMode(2);
	self.FilterPanel.TypeOreNodeIcon:SetSize(self.FilterPanel.TypeOreNodeIcon:GetWidth(),self.FilterPanel.TypeOreNodeIcon:GetHeight());
	self.FilterPanel.TypeOreNodeIcon:SetStretchMode(0);
	self.FilterPanel.TypeOreNodeIcon:SetPosition(self.FilterPanel.TypeOreNode:GetLeft()-20,self.FilterPanel.TypeOreNode:GetTop());

	self.FilterPanel.TypeOreNodeTier=GaranStuff.MoorMap.DropDownList();
	self.FilterPanel.TypeOreNodeTier:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeOreNodeTier:SetSize(self.FilterPanel.TypeMain:GetWidth()/2,20);
	self.FilterPanel.TypeOreNodeTier:SetPosition(self.FilterPanel.TypeOreNode:GetLeft()+self.FilterPanel.TypeOreNode:GetWidth(),self.FilterPanel.TypeOreNode:GetTop());
	self.FilterPanel.TypeOreNodeTier:SetBorderColor(trimColor);
	self.FilterPanel.TypeOreNodeTier:SetBackColor(backColor);
	self.FilterPanel.TypeOreNodeTier.CurrentValue:SetBackColor(backColor);
	self.FilterPanel.TypeOreNodeTier:SetTextColor(listTextColor);
	self.FilterPanel.TypeOreNodeTier:SetDropRows(7);
	self.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][158],0);
	self.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 1",1);
	self.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 2",2);
	self.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 3",3);
	self.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 4",4);
	self.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 5",5);
	self.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 6",6);
	self.FilterPanel.TypeOreNodeTier:SetSelectedIndex(filterOreNodeTier+1);
	self.FilterPanel.TypeOreNodeTier.SelectedIndexChanged=function()
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end

	self.FilterPanel.TypeWoodNode=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeWoodNode:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeWoodNode:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeWoodNode:SetForeColor(fontColor);
	self.FilterPanel.TypeWoodNode:SetSize(self.FilterPanel.TypeMain:GetWidth()/2,18);
	self.FilterPanel.TypeWoodNode:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeOreNode:GetTop()+21);
	self.FilterPanel.TypeWoodNode:SetText(Resource[language][156]);
	self.FilterPanel.TypeWoodNode:SetChecked(filterTypeWoodNode);
	self.FilterPanel.TypeWoodNodeHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeWoodNodeHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeWoodNodeHS:SetSize(self.FilterPanel.TypeWoodNode:GetSize());
	self.FilterPanel.TypeWoodNodeHS:SetPosition(self.FilterPanel.TypeWoodNode:GetPosition());
	self.FilterPanel.TypeWoodNodeHS.MouseClick=function()
		self.FilterPanel.TypeWoodNode:SetChecked(not self.FilterPanel.TypeWoodNode:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeWoodNodeHS:SetZOrder(self.FilterPanel.TypeWoodNode:GetZOrder()+1);
	self.FilterPanel.TypeWoodNodeIcon=Turbine.UI.Control();
	self.FilterPanel.TypeWoodNodeIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeWoodNodeIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[44]~=nil and iconInfo[44][6]~=nil then
		self.FilterPanel.TypeWoodNodeIcon:SetBackground(iconInfo[44][6]);
	end
	self.FilterPanel.TypeWoodNodeIcon:SetStretchMode(2);
	self.FilterPanel.TypeWoodNodeIcon:SetSize(self.FilterPanel.TypeWoodNodeIcon:GetWidth(),self.FilterPanel.TypeWoodNodeIcon:GetHeight());
	self.FilterPanel.TypeWoodNodeIcon:SetStretchMode(0);
	self.FilterPanel.TypeWoodNodeIcon:SetPosition(self.FilterPanel.TypeWoodNode:GetLeft()-20,self.FilterPanel.TypeWoodNode:GetTop());

	self.FilterPanel.TypeWoodNodeTier=GaranStuff.MoorMap.DropDownList();
	self.FilterPanel.TypeWoodNodeTier:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeWoodNodeTier:SetSize(self.FilterPanel.TypeMain:GetWidth()/2,20);
	self.FilterPanel.TypeWoodNodeTier:SetPosition(self.FilterPanel.TypeWoodNode:GetLeft()+self.FilterPanel.TypeWoodNode:GetWidth(),self.FilterPanel.TypeWoodNode:GetTop());
	self.FilterPanel.TypeWoodNodeTier:SetBorderColor(trimColor);
	self.FilterPanel.TypeWoodNodeTier:SetBackColor(backColor);
	self.FilterPanel.TypeWoodNodeTier.CurrentValue:SetBackColor(backColor);
	self.FilterPanel.TypeWoodNodeTier:SetTextColor(listTextColor);
	self.FilterPanel.TypeWoodNodeTier:SetDropRows(7);
	self.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][158],0);
	self.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 1",1);
	self.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 2",2);
	self.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 3",3);
	self.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 4",4);
	self.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 5",5);
	self.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 6",6);
	self.FilterPanel.TypeWoodNodeTier:SetSelectedIndex(filterWoodNodeTier+1);
	self.FilterPanel.TypeWoodNodeTier.SelectedIndexChanged=function()
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end

	self.FilterPanel.TypeScholarNode=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeScholarNode:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeScholarNode:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeScholarNode:SetForeColor(fontColor);
	self.FilterPanel.TypeScholarNode:SetSize(self.FilterPanel.TypeMain:GetWidth()/2,18);
	self.FilterPanel.TypeScholarNode:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeWoodNode:GetTop()+21);
	self.FilterPanel.TypeScholarNode:SetText(Resource[language][157]);
	self.FilterPanel.TypeScholarNode:SetChecked(filterTypeScholarNode);
	self.FilterPanel.TypeScholarNodeHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeScholarNodeHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeScholarNodeHS:SetSize(self.FilterPanel.TypeScholarNode:GetSize());
	self.FilterPanel.TypeScholarNodeHS:SetPosition(self.FilterPanel.TypeScholarNode:GetPosition());
	self.FilterPanel.TypeScholarNodeHS.MouseClick=function()
		self.FilterPanel.TypeScholarNode:SetChecked(not self.FilterPanel.TypeScholarNode:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeScholarNodeHS:SetZOrder(self.FilterPanel.TypeScholarNode:GetZOrder()+1);
	self.FilterPanel.TypeScholarNodeIcon=Turbine.UI.Control();
	self.FilterPanel.TypeScholarNodeIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeScholarNodeIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[45]~=nil and iconInfo[45][6]~=nil then
		self.FilterPanel.TypeScholarNodeIcon:SetBackground(iconInfo[45][6]);
	end
	self.FilterPanel.TypeScholarNodeIcon:SetStretchMode(2);
	self.FilterPanel.TypeScholarNodeIcon:SetSize(self.FilterPanel.TypeScholarNodeIcon:GetWidth(),self.FilterPanel.TypeScholarNodeIcon:GetHeight());
	self.FilterPanel.TypeScholarNodeIcon:SetStretchMode(0);
	self.FilterPanel.TypeScholarNodeIcon:SetPosition(self.FilterPanel.TypeScholarNode:GetLeft()-20,self.FilterPanel.TypeScholarNode:GetTop());

	self.FilterPanel.TypeScholarNodeTier=GaranStuff.MoorMap.DropDownList();
	self.FilterPanel.TypeScholarNodeTier:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeScholarNodeTier:SetSize(self.FilterPanel.TypeMain:GetWidth()/2,20);
	self.FilterPanel.TypeScholarNodeTier:SetPosition(self.FilterPanel.TypeScholarNode:GetLeft()+self.FilterPanel.TypeScholarNode:GetWidth(),self.FilterPanel.TypeScholarNode:GetTop());
	self.FilterPanel.TypeScholarNodeTier:SetBorderColor(trimColor);
	self.FilterPanel.TypeScholarNodeTier:SetBackColor(backColor);
	self.FilterPanel.TypeScholarNodeTier.CurrentValue:SetBackColor(backColor);
	self.FilterPanel.TypeScholarNodeTier:SetTextColor(listTextColor);
	self.FilterPanel.TypeScholarNodeTier:SetDropRows(7);
	self.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][158],0);
	self.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 1",1);
	self.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 2",2);
	self.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 3",3);
	self.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 4",4);
	self.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 5",5);
	self.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 6",6);
	self.FilterPanel.TypeScholarNodeTier:SetSelectedIndex(filterScholarNodeTier+1);
	self.FilterPanel.TypeScholarNodeTier.SelectedIndexChanged=function()
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end

	self.FilterPanel.TypeCook=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeCook:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCook:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeCook:SetForeColor(fontColor);
	self.FilterPanel.TypeCook:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeCook:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeScholarNode:GetTop()+21);
	self.FilterPanel.TypeCook:SetText(Resource[language][162]);
	self.FilterPanel.TypeCook:SetChecked(filterTypeCook);
	self.FilterPanel.TypeCookHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeCookHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCookHS:SetSize(self.FilterPanel.TypeCook:GetSize());
	self.FilterPanel.TypeCookHS:SetPosition(self.FilterPanel.TypeCook:GetPosition());
	self.FilterPanel.TypeCookHS.MouseClick=function()
		self.FilterPanel.TypeCook:SetChecked(not self.FilterPanel.TypeCook:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeCookHS:SetZOrder(self.FilterPanel.TypeCook:GetZOrder()+1);
	self.FilterPanel.TypeCookIcon=Turbine.UI.Control();
	self.FilterPanel.TypeCookIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCookIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[46]~=nil and iconInfo[46][6]~=nil then
		self.FilterPanel.TypeCookIcon:SetBackground(iconInfo[46][6]);
	end
	self.FilterPanel.TypeCookIcon:SetStretchMode(2);
	self.FilterPanel.TypeCookIcon:SetSize(self.FilterPanel.TypeCookIcon:GetWidth(),self.FilterPanel.TypeCookIcon:GetHeight());
	self.FilterPanel.TypeCookIcon:SetStretchMode(0);
	self.FilterPanel.TypeCookIcon:SetPosition(self.FilterPanel.TypeCook:GetLeft()-20,self.FilterPanel.TypeCook:GetTop());

	self.FilterPanel.TypeScholarIngredient=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeScholarIngredient:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeScholarIngredient:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeScholarIngredient:SetForeColor(fontColor);
	self.FilterPanel.TypeScholarIngredient:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeScholarIngredient:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeCook:GetTop()+21);
	self.FilterPanel.TypeScholarIngredient:SetText(Resource[language][182]);
	self.FilterPanel.TypeScholarIngredient:SetChecked(filterTypeScholarIngredient);
	self.FilterPanel.TypeScholarIngredientHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeScholarIngredientHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeScholarIngredientHS:SetSize(self.FilterPanel.TypeScholarIngredient:GetSize());
	self.FilterPanel.TypeScholarIngredientHS:SetPosition(self.FilterPanel.TypeScholarIngredient:GetPosition());
	self.FilterPanel.TypeScholarIngredientHS.MouseClick=function()
		self.FilterPanel.TypeScholarIngredient:SetChecked(not self.FilterPanel.TypeScholarIngredient:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeScholarIngredientHS:SetZOrder(self.FilterPanel.TypeScholarIngredient:GetZOrder()+1);
	self.FilterPanel.TypeScholarIngredientIcon=Turbine.UI.Control();
	self.FilterPanel.TypeScholarIngredientIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeScholarIngredientIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[48]~=nil and iconInfo[48][6]~=nil then
		self.FilterPanel.TypeScholarIngredientIcon:SetBackground(iconInfo[48][6]);
	end
	self.FilterPanel.TypeScholarIngredientIcon:SetStretchMode(2);
	self.FilterPanel.TypeScholarIngredientIcon:SetSize(self.FilterPanel.TypeScholarIngredientIcon:GetWidth(),self.FilterPanel.TypeScholarIngredientIcon:GetHeight());
	self.FilterPanel.TypeScholarIngredientIcon:SetStretchMode(0);
	self.FilterPanel.TypeScholarIngredientIcon:SetPosition(self.FilterPanel.TypeScholarIngredient:GetLeft()-20,self.FilterPanel.TypeScholarIngredient:GetTop());

	self.FilterPanel.TypeAuctioneer=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeAuctioneer:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeAuctioneer:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeAuctioneer:SetForeColor(fontColor);
	self.FilterPanel.TypeAuctioneer:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeAuctioneer:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeScholarIngredient:GetTop()+21);
	self.FilterPanel.TypeAuctioneer:SetText(Resource[language][120]);
	self.FilterPanel.TypeAuctioneer:SetChecked(filterTypeAuctioneer);
	self.FilterPanel.TypeAuctioneerHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeAuctioneerHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeAuctioneerHS:SetSize(self.FilterPanel.TypeAuctioneer:GetSize());
	self.FilterPanel.TypeAuctioneerHS:SetPosition(self.FilterPanel.TypeAuctioneer:GetPosition());
	self.FilterPanel.TypeAuctioneerHS.MouseClick=function()
		self.FilterPanel.TypeAuctioneer:SetChecked(not self.FilterPanel.TypeAuctioneer:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeAuctioneerHS:SetZOrder(self.FilterPanel.TypeAuctioneer:GetZOrder()+1);
	self.FilterPanel.TypeAuctioneerIcon=Turbine.UI.Control();
	self.FilterPanel.TypeAuctioneerIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeAuctioneerIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[14]~=nil and iconInfo[14][6]~=nil then
		self.FilterPanel.TypeAuctioneerIcon:SetBackground(iconInfo[14][6]);
	end
	self.FilterPanel.TypeAuctioneerIcon:SetStretchMode(2);
	self.FilterPanel.TypeAuctioneerIcon:SetSize(self.FilterPanel.TypeAuctioneerIcon:GetWidth(),self.FilterPanel.TypeAuctioneerIcon:GetHeight());
	self.FilterPanel.TypeAuctioneerIcon:SetStretchMode(0);
	self.FilterPanel.TypeAuctioneerIcon:SetPosition(self.FilterPanel.TypeAuctioneer:GetLeft()-20,self.FilterPanel.TypeAuctioneer:GetTop());

	self.FilterPanel.TypeBarber=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeBarber:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBarber:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeBarber:SetForeColor(fontColor);
	self.FilterPanel.TypeBarber:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeBarber:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeAuctioneer:GetTop()+20);
	self.FilterPanel.TypeBarber:SetText(Resource[language][121]);
	self.FilterPanel.TypeBarber:SetChecked(filterTypeBarber);
	self.FilterPanel.TypeBarberHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeBarberHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBarberHS:SetSize(self.FilterPanel.TypeBarber:GetSize());
	self.FilterPanel.TypeBarberHS:SetPosition(self.FilterPanel.TypeBarber:GetPosition());
	self.FilterPanel.TypeBarberHS.MouseClick=function()
		self.FilterPanel.TypeBarber:SetChecked(not self.FilterPanel.TypeBarber:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeBarberHS:SetZOrder(self.FilterPanel.TypeBarber:GetZOrder()+1);
	self.FilterPanel.TypeBarberIcon=Turbine.UI.Control();
	self.FilterPanel.TypeBarberIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBarberIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[15]~=nil and iconInfo[15][6]~=nil then
		self.FilterPanel.TypeBarberIcon:SetBackground(iconInfo[15][6]);
	end
	self.FilterPanel.TypeBarberIcon:SetStretchMode(2);
	self.FilterPanel.TypeBarberIcon:SetSize(self.FilterPanel.TypeBarberIcon:GetWidth(),self.FilterPanel.TypeBarberIcon:GetHeight());
	self.FilterPanel.TypeBarberIcon:SetStretchMode(0);
	self.FilterPanel.TypeBarberIcon:SetPosition(self.FilterPanel.TypeBarber:GetLeft()-20,self.FilterPanel.TypeBarber:GetTop());

	self.FilterPanel.TypeBard=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeBard:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBard:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeBard:SetForeColor(fontColor);
	self.FilterPanel.TypeBard:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeBard:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeBarber:GetTop()+20);
	self.FilterPanel.TypeBard:SetText(Resource[language][122]);
	self.FilterPanel.TypeBard:SetChecked(filterTypeBard);
	self.FilterPanel.TypeBardHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeBardHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBardHS:SetSize(self.FilterPanel.TypeBard:GetSize());
	self.FilterPanel.TypeBardHS:SetPosition(self.FilterPanel.TypeBard:GetPosition());
	self.FilterPanel.TypeBardHS.MouseClick=function()
		self.FilterPanel.TypeBard:SetChecked(not self.FilterPanel.TypeBard:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeBardHS:SetZOrder(self.FilterPanel.TypeBard:GetZOrder()+1);
	self.FilterPanel.TypeBardIcon=Turbine.UI.Control();
	self.FilterPanel.TypeBardIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeBardIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[15]~=nil and iconInfo[16][6]~=nil then
		self.FilterPanel.TypeBardIcon:SetBackground(iconInfo[16][6]);
	end
	self.FilterPanel.TypeBardIcon:SetStretchMode(2);
	self.FilterPanel.TypeBardIcon:SetSize(self.FilterPanel.TypeBardIcon:GetWidth(),self.FilterPanel.TypeBardIcon:GetHeight());
	self.FilterPanel.TypeBardIcon:SetStretchMode(0);
	self.FilterPanel.TypeBardIcon:SetPosition(self.FilterPanel.TypeBard:GetLeft()-20,self.FilterPanel.TypeBard:GetTop());

	self.FilterPanel.TypeCampSite=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeCampSite:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCampSite:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeCampSite:SetForeColor(fontColor);
	self.FilterPanel.TypeCampSite:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeCampSite:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeBard:GetTop()+20);
	self.FilterPanel.TypeCampSite:SetText(Resource[language][123]);
	self.FilterPanel.TypeCampSite:SetChecked(filterTypeCampSite);
	self.FilterPanel.TypeCampSiteHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeCampSiteHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCampSiteHS:SetSize(self.FilterPanel.TypeCampSite:GetSize());
	self.FilterPanel.TypeCampSiteHS:SetPosition(self.FilterPanel.TypeCampSite:GetPosition());
	self.FilterPanel.TypeCampSiteHS.MouseClick=function()
		self.FilterPanel.TypeCampSite:SetChecked(not self.FilterPanel.TypeCampSite:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeCampSiteHS:SetZOrder(self.FilterPanel.TypeCampSite:GetZOrder()+1);
	self.FilterPanel.TypeCampSiteIcon=Turbine.UI.Control();
	self.FilterPanel.TypeCampSiteIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCampSiteIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[17]~=nil and iconInfo[17][6]~=nil then
		self.FilterPanel.TypeCampSiteIcon:SetBackground(iconInfo[17][6]);
	end
	self.FilterPanel.TypeCampSiteIcon:SetStretchMode(2);
	self.FilterPanel.TypeCampSiteIcon:SetSize(self.FilterPanel.TypeCampSiteIcon:GetWidth(),self.FilterPanel.TypeCampSiteIcon:GetHeight());
	self.FilterPanel.TypeCampSiteIcon:SetStretchMode(0);
	self.FilterPanel.TypeCampSiteIcon:SetPosition(self.FilterPanel.TypeCampSite:GetLeft()-20,self.FilterPanel.TypeCampSite:GetTop());

	self.FilterPanel.TypeCraftSite=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeCraftSite:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCraftSite:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeCraftSite:SetForeColor(fontColor);
	self.FilterPanel.TypeCraftSite:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeCraftSite:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeCampSite:GetTop()+20);
	self.FilterPanel.TypeCraftSite:SetText(Resource[language][124]);
	self.FilterPanel.TypeCraftSite:SetChecked(filterTypeCraftSite);
	self.FilterPanel.TypeCraftSiteHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeCraftSiteHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCraftSiteHS:SetSize(self.FilterPanel.TypeCraftSite:GetSize());
	self.FilterPanel.TypeCraftSiteHS:SetPosition(self.FilterPanel.TypeCraftSite:GetPosition());
	self.FilterPanel.TypeCraftSiteHS.MouseClick=function()
		self.FilterPanel.TypeCraftSite:SetChecked(not self.FilterPanel.TypeCraftSite:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeCraftSiteHS:SetZOrder(self.FilterPanel.TypeCraftSite:GetZOrder()+1);
	self.FilterPanel.TypeCraftSiteIcon=Turbine.UI.Control();
	self.FilterPanel.TypeCraftSiteIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCraftSiteIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[18]~=nil and iconInfo[18][6]~=nil then
		self.FilterPanel.TypeCraftSiteIcon:SetBackground(iconInfo[18][6]);
	end
	self.FilterPanel.TypeCraftSiteIcon:SetStretchMode(2);
	self.FilterPanel.TypeCraftSiteIcon:SetSize(self.FilterPanel.TypeCraftSiteIcon:GetWidth(),self.FilterPanel.TypeCraftSiteIcon:GetHeight());
	self.FilterPanel.TypeCraftSiteIcon:SetStretchMode(0);
	self.FilterPanel.TypeCraftSiteIcon:SetPosition(self.FilterPanel.TypeCraftSite:GetLeft()-20,self.FilterPanel.TypeCraftSite:GetTop());

	self.FilterPanel.TypeCraftVendor=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeCraftVendor:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCraftVendor:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeCraftVendor:SetForeColor(fontColor);
	self.FilterPanel.TypeCraftVendor:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeCraftVendor:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeCraftSite:GetTop()+20);
	self.FilterPanel.TypeCraftVendor:SetText(Resource[language][126]);
	self.FilterPanel.TypeCraftVendor:SetChecked(filterTypeCraftVendor);
	self.FilterPanel.TypeCraftVendorHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeCraftVendorHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCraftVendorHS:SetSize(self.FilterPanel.TypeCraftVendor:GetSize());
	self.FilterPanel.TypeCraftVendorHS:SetPosition(self.FilterPanel.TypeCraftVendor:GetPosition());
	self.FilterPanel.TypeCraftVendorHS.MouseClick=function()
		self.FilterPanel.TypeCraftVendor:SetChecked(not self.FilterPanel.TypeCraftVendor:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeCraftVendorHS:SetZOrder(self.FilterPanel.TypeCraftVendor:GetZOrder()+1);
	self.FilterPanel.TypeCraftVendorIcon=Turbine.UI.Control();
	self.FilterPanel.TypeCraftVendorIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeCraftVendorIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[20]~=nil and iconInfo[20][6]~=nil then
		self.FilterPanel.TypeCraftVendorIcon:SetBackground(iconInfo[20][6]);
	end
	self.FilterPanel.TypeCraftVendorIcon:SetStretchMode(2);
	self.FilterPanel.TypeCraftVendorIcon:SetSize(self.FilterPanel.TypeCraftVendorIcon:GetWidth(),self.FilterPanel.TypeCraftVendorIcon:GetHeight());
	self.FilterPanel.TypeCraftVendorIcon:SetStretchMode(0);
	self.FilterPanel.TypeCraftVendorIcon:SetPosition(self.FilterPanel.TypeCraftVendor:GetLeft()-20,self.FilterPanel.TypeCraftVendor:GetTop());

	self.FilterPanel.TypeDungeon=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeDungeon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeDungeon:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeDungeon:SetForeColor(fontColor);
	self.FilterPanel.TypeDungeon:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeDungeon:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeCraftVendor:GetTop()+20);
	self.FilterPanel.TypeDungeon:SetText(Resource[language][183]);
	self.FilterPanel.TypeDungeon:SetChecked(filterTypeDungeon);
	self.FilterPanel.TypeDungeonHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeDungeonHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeDungeonHS:SetSize(self.FilterPanel.TypeDungeon:GetSize());
	self.FilterPanel.TypeDungeonHS:SetPosition(self.FilterPanel.TypeDungeon:GetPosition());
	self.FilterPanel.TypeDungeonHS.MouseClick=function()
		self.FilterPanel.TypeDungeon:SetChecked(not self.FilterPanel.TypeDungeon:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeDungeonHS:SetZOrder(self.FilterPanel.TypeDungeon:GetZOrder()+1);
	self.FilterPanel.TypeDungeonIcon=Turbine.UI.Control();
	self.FilterPanel.TypeDungeonIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeDungeonIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[49]~=nil and iconInfo[49][6]~=nil then
		self.FilterPanel.TypeDungeonIcon:SetBackground(iconInfo[49][6]);
	end
	self.FilterPanel.TypeDungeonIcon:SetStretchMode(2);
	self.FilterPanel.TypeDungeonIcon:SetSize(self.FilterPanel.TypeDungeonIcon:GetWidth(),self.FilterPanel.TypeDungeonIcon:GetHeight());
	self.FilterPanel.TypeDungeonIcon:SetStretchMode(0);
	self.FilterPanel.TypeDungeonIcon:SetPosition(self.FilterPanel.TypeDungeon:GetLeft()-20,self.FilterPanel.TypeDungeon:GetTop());

	self.FilterPanel.TypeFactionRep=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeFactionRep:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeFactionRep:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeFactionRep:SetForeColor(fontColor);
	self.FilterPanel.TypeFactionRep:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeFactionRep:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeDungeon:GetTop()+20);
	self.FilterPanel.TypeFactionRep:SetText(Resource[language][127]);
	self.FilterPanel.TypeFactionRep:SetChecked(filterTypeFactionRep);
	self.FilterPanel.TypeFactionRepHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeFactionRepHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeFactionRepHS:SetSize(self.FilterPanel.TypeFactionRep:GetSize());
	self.FilterPanel.TypeFactionRepHS:SetPosition(self.FilterPanel.TypeFactionRep:GetPosition());
	self.FilterPanel.TypeFactionRepHS.MouseClick=function()
		self.FilterPanel.TypeFactionRep:SetChecked(not self.FilterPanel.TypeFactionRep:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeFactionRepHS:SetZOrder(self.FilterPanel.TypeFactionRep:GetZOrder()+1);
	self.FilterPanel.TypeFactionRepIcon=Turbine.UI.Control();
	self.FilterPanel.TypeFactionRepIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeFactionRepIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[21]~=nil and iconInfo[21][6]~=nil then
		self.FilterPanel.TypeFactionRepIcon:SetBackground(iconInfo[21][6]);
	end
	self.FilterPanel.TypeFactionRepIcon:SetStretchMode(2);
	self.FilterPanel.TypeFactionRepIcon:SetSize(self.FilterPanel.TypeFactionRepIcon:GetWidth(),self.FilterPanel.TypeFactionRepIcon:GetHeight());
	self.FilterPanel.TypeFactionRepIcon:SetStretchMode(0);
	self.FilterPanel.TypeFactionRepIcon:SetPosition(self.FilterPanel.TypeFactionRep:GetLeft()-20,self.FilterPanel.TypeFactionRep:GetTop());

	self.FilterPanel.TypeItemMaster=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeItemMaster:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeItemMaster:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeItemMaster:SetForeColor(fontColor);
	self.FilterPanel.TypeItemMaster:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeItemMaster:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeFactionRep:GetTop()+20);
	self.FilterPanel.TypeItemMaster:SetText(Resource[language][131]);
	self.FilterPanel.TypeItemMaster:SetChecked(filterTypeItemMaster);
	self.FilterPanel.TypeItemMasterHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeItemMasterHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeItemMasterHS:SetSize(self.FilterPanel.TypeItemMaster:GetSize());
	self.FilterPanel.TypeItemMasterHS:SetPosition(self.FilterPanel.TypeItemMaster:GetPosition());
	self.FilterPanel.TypeItemMasterHS.MouseClick=function()
		self.FilterPanel.TypeItemMaster:SetChecked(not self.FilterPanel.TypeItemMaster:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeItemMasterHS:SetZOrder(self.FilterPanel.TypeItemMaster:GetZOrder()+1);
	self.FilterPanel.TypeItemMasterIcon=Turbine.UI.Control();
	self.FilterPanel.TypeItemMasterIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeItemMasterIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[25]~=nil and iconInfo[25][6]~=nil then
		self.FilterPanel.TypeItemMasterIcon:SetBackground(iconInfo[25][6]);
	end
	self.FilterPanel.TypeItemMasterIcon:SetStretchMode(2);
	self.FilterPanel.TypeItemMasterIcon:SetSize(self.FilterPanel.TypeItemMasterIcon:GetWidth(),self.FilterPanel.TypeItemMasterIcon:GetHeight());
	self.FilterPanel.TypeItemMasterIcon:SetStretchMode(0);
	self.FilterPanel.TypeItemMasterIcon:SetPosition(self.FilterPanel.TypeItemMaster:GetLeft()-20,self.FilterPanel.TypeItemMaster:GetTop());

	self.FilterPanel.TypeMailbox=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeMailbox:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMailbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeMailbox:SetForeColor(fontColor);
	self.FilterPanel.TypeMailbox:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeMailbox:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeItemMaster:GetTop()+20);
	self.FilterPanel.TypeMailbox:SetText(Resource[language][132]);
	self.FilterPanel.TypeMailbox:SetChecked(filterTypeMailbox);
	self.FilterPanel.TypeMailboxHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeMailboxHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMailboxHS:SetSize(self.FilterPanel.TypeMailbox:GetSize());
	self.FilterPanel.TypeMailboxHS:SetPosition(self.FilterPanel.TypeMailbox:GetPosition());
	self.FilterPanel.TypeMailboxHS.MouseClick=function()
		self.FilterPanel.TypeMailbox:SetChecked(not self.FilterPanel.TypeMailbox:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeMailboxHS:SetZOrder(self.FilterPanel.TypeMailbox:GetZOrder()+1);
	self.FilterPanel.TypeMailboxIcon=Turbine.UI.Control();
	self.FilterPanel.TypeMailboxIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMailboxIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[26]~=nil and iconInfo[26][6]~=nil then
		self.FilterPanel.TypeMailboxIcon:SetBackground(iconInfo[26][6]);
	end
	self.FilterPanel.TypeMailboxIcon:SetStretchMode(2);
	self.FilterPanel.TypeMailboxIcon:SetSize(self.FilterPanel.TypeMailboxIcon:GetWidth(),self.FilterPanel.TypeMailboxIcon:GetHeight());
	self.FilterPanel.TypeMailboxIcon:SetStretchMode(0);
	self.FilterPanel.TypeMailboxIcon:SetPosition(self.FilterPanel.TypeMailbox:GetLeft()-20,self.FilterPanel.TypeMailbox:GetTop());

	self.FilterPanel.TypeMilestone=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeMilestone:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMilestone:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeMilestone:SetForeColor(fontColor);
	self.FilterPanel.TypeMilestone:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeMilestone:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeMailbox:GetTop()+20);
	self.FilterPanel.TypeMilestone:SetText(Resource[language][133]);
	self.FilterPanel.TypeMilestone:SetChecked(filterTypeMilestone);
	self.FilterPanel.TypeMilestoneHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeMilestoneHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMilestoneHS:SetSize(self.FilterPanel.TypeMilestone:GetSize());
	self.FilterPanel.TypeMilestoneHS:SetPosition(self.FilterPanel.TypeMilestone:GetPosition());
	self.FilterPanel.TypeMilestoneHS.MouseClick=function()
		self.FilterPanel.TypeMilestone:SetChecked(not self.FilterPanel.TypeMilestone:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeMilestoneHS:SetZOrder(self.FilterPanel.TypeMilestone:GetZOrder()+1);
	self.FilterPanel.TypeMilestoneIcon=Turbine.UI.Control();
	self.FilterPanel.TypeMilestoneIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMilestoneIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[27]~=nil and iconInfo[27][6]~=nil then
		self.FilterPanel.TypeMilestoneIcon:SetBackground(iconInfo[27][6]);
	end
	self.FilterPanel.TypeMilestoneIcon:SetStretchMode(2);
	self.FilterPanel.TypeMilestoneIcon:SetSize(self.FilterPanel.TypeMilestoneIcon:GetWidth(),self.FilterPanel.TypeMilestoneIcon:GetHeight());
	self.FilterPanel.TypeMilestoneIcon:SetStretchMode(0);
	self.FilterPanel.TypeMilestoneIcon:SetPosition(self.FilterPanel.TypeMilestone:GetLeft()-20,self.FilterPanel.TypeMilestone:GetTop());

	self.FilterPanel.TypeMusteringHorn=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeMusteringHorn:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMusteringHorn:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeMusteringHorn:SetForeColor(fontColor);
	self.FilterPanel.TypeMusteringHorn:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeMusteringHorn:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeMilestone:GetTop()+20);
	self.FilterPanel.TypeMusteringHorn:SetText(Resource[language][163]);
	self.FilterPanel.TypeMusteringHorn:SetChecked(filterTypeMusteringHorn);
	self.FilterPanel.TypeMusteringHornHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeMusteringHornHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMusteringHornHS:SetSize(self.FilterPanel.TypeMusteringHorn:GetSize());
	self.FilterPanel.TypeMusteringHornHS:SetPosition(self.FilterPanel.TypeMusteringHorn:GetPosition());
	self.FilterPanel.TypeMusteringHornHS.MouseClick=function()
		self.FilterPanel.TypeMusteringHorn:SetChecked(not self.FilterPanel.TypeMusteringHorn:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeMusteringHornHS:SetZOrder(self.FilterPanel.TypeMusteringHorn:GetZOrder()+1);
	self.FilterPanel.TypeMusteringHornIcon=Turbine.UI.Control();
	self.FilterPanel.TypeMusteringHornIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeMusteringHornIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[47]~=nil and iconInfo[47][6]~=nil then
		self.FilterPanel.TypeMusteringHornIcon:SetBackground(iconInfo[47][6]);
	end
	self.FilterPanel.TypeMusteringHornIcon:SetStretchMode(2);
	self.FilterPanel.TypeMusteringHornIcon:SetSize(self.FilterPanel.TypeMusteringHornIcon:GetWidth(),self.FilterPanel.TypeMusteringHornIcon:GetHeight());
	self.FilterPanel.TypeMusteringHornIcon:SetStretchMode(0);
	self.FilterPanel.TypeMusteringHornIcon:SetPosition(self.FilterPanel.TypeMusteringHorn:GetLeft()-20,self.FilterPanel.TypeMusteringHorn:GetTop());

	self.FilterPanel.TypeReflectingPool=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeReflectingPool:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeReflectingPool:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeReflectingPool:SetForeColor(fontColor);
	self.FilterPanel.TypeReflectingPool:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeReflectingPool:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeMusteringHorn:GetTop()+20);
	self.FilterPanel.TypeReflectingPool:SetText(Resource[language][138]);
	self.FilterPanel.TypeReflectingPool:SetChecked(filterTypeReflectingPool);
	self.FilterPanel.TypeReflectingPoolHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeReflectingPoolHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeReflectingPoolHS:SetSize(self.FilterPanel.TypeReflectingPool:GetSize());
	self.FilterPanel.TypeReflectingPoolHS:SetPosition(self.FilterPanel.TypeReflectingPool:GetPosition());
	self.FilterPanel.TypeReflectingPoolHS.MouseClick=function()
		self.FilterPanel.TypeReflectingPool:SetChecked(not self.FilterPanel.TypeReflectingPool:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeReflectingPoolHS:SetZOrder(self.FilterPanel.TypeReflectingPool:GetZOrder()+1);
	self.FilterPanel.TypeReflectingPoolIcon=Turbine.UI.Control();
	self.FilterPanel.TypeReflectingPoolIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeReflectingPoolIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[32]~=nil and iconInfo[32][6]~=nil then
		self.FilterPanel.TypeReflectingPoolIcon:SetBackground(iconInfo[32][6]);
	end
	self.FilterPanel.TypeReflectingPoolIcon:SetStretchMode(2);
	self.FilterPanel.TypeReflectingPoolIcon:SetSize(self.FilterPanel.TypeReflectingPoolIcon:GetWidth(),self.FilterPanel.TypeReflectingPoolIcon:GetHeight());
	self.FilterPanel.TypeReflectingPoolIcon:SetStretchMode(0);
	self.FilterPanel.TypeReflectingPoolIcon:SetPosition(self.FilterPanel.TypeReflectingPool:GetLeft()-20,self.FilterPanel.TypeReflectingPool:GetTop());

	self.FilterPanel.TypeSettlement=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeSettlement:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSettlement:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeSettlement:SetForeColor(fontColor);
	self.FilterPanel.TypeSettlement:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeSettlement:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeReflectingPool:GetTop()+20);
	self.FilterPanel.TypeSettlement:SetText(Resource[language][139]);
	self.FilterPanel.TypeSettlement:SetChecked(filterTypeSettlement);
	self.FilterPanel.TypeSettlementHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeSettlementHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSettlementHS:SetSize(self.FilterPanel.TypeSettlement:GetSize());
	self.FilterPanel.TypeSettlementHS:SetPosition(self.FilterPanel.TypeSettlement:GetPosition());
	self.FilterPanel.TypeSettlementHS.MouseClick=function()
		self.FilterPanel.TypeSettlement:SetChecked(not self.FilterPanel.TypeSettlement:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeSettlementHS:SetZOrder(self.FilterPanel.TypeSettlement:GetZOrder()+1);
	self.FilterPanel.TypeSettlementIcon=Turbine.UI.Control();
	self.FilterPanel.TypeSettlementIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSettlementIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[33]~=nil and iconInfo[33][6]~=nil then
		self.FilterPanel.TypeSettlementIcon:SetBackground(iconInfo[33][6]);
	end
	self.FilterPanel.TypeSettlementIcon:SetStretchMode(2);
	self.FilterPanel.TypeSettlementIcon:SetSize(self.FilterPanel.TypeSettlementIcon:GetWidth(),self.FilterPanel.TypeSettlementIcon:GetHeight());
	self.FilterPanel.TypeSettlementIcon:SetStretchMode(0);
	self.FilterPanel.TypeSettlementIcon:SetPosition(self.FilterPanel.TypeSettlement:GetLeft()-20,self.FilterPanel.TypeSettlement:GetTop());

	self.FilterPanel.TypeStableMaster=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeStableMaster:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeStableMaster:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeStableMaster:SetForeColor(fontColor);
	self.FilterPanel.TypeStableMaster:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeStableMaster:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeSettlement:GetTop()+20);
	self.FilterPanel.TypeStableMaster:SetText(Resource[language][140]);
	self.FilterPanel.TypeStableMaster:SetChecked(filterTypeStableMaster);
	self.FilterPanel.TypeStableMasterHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeStableMasterHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeStableMasterHS:SetSize(self.FilterPanel.TypeStableMaster:GetSize());
	self.FilterPanel.TypeStableMasterHS:SetPosition(self.FilterPanel.TypeStableMaster:GetPosition());
	self.FilterPanel.TypeStableMasterHS.MouseClick=function()
		self.FilterPanel.TypeStableMaster:SetChecked(not self.FilterPanel.TypeStableMaster:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeStableMasterHS:SetZOrder(self.FilterPanel.TypeStableMaster:GetZOrder()+1);
	self.FilterPanel.TypeStableMasterIcon=Turbine.UI.Control();
	self.FilterPanel.TypeStableMasterIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeStableMasterIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[34]~=nil and iconInfo[34][6]~=nil then
		self.FilterPanel.TypeStableMasterIcon:SetBackground(iconInfo[34][6]);
	end
	self.FilterPanel.TypeStableMasterIcon:SetStretchMode(2);
	self.FilterPanel.TypeStableMasterIcon:SetSize(self.FilterPanel.TypeStableMasterIcon:GetWidth(),self.FilterPanel.TypeStableMasterIcon:GetHeight());
	self.FilterPanel.TypeStableMasterIcon:SetStretchMode(0);
	self.FilterPanel.TypeStableMasterIcon:SetPosition(self.FilterPanel.TypeStableMaster:GetLeft()-20,self.FilterPanel.TypeStableMaster:GetTop());

	self.FilterPanel.TypeTownCrier=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeTownCrier:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTownCrier:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeTownCrier:SetForeColor(fontColor);
	self.FilterPanel.TypeTownCrier:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeTownCrier:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeStableMaster:GetTop()+20);
	self.FilterPanel.TypeTownCrier:SetText(Resource[language][141]);
	self.FilterPanel.TypeTownCrier:SetChecked(filterTypeTownCrier);
	self.FilterPanel.TypeTownCrierHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeTownCrierHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTownCrierHS:SetSize(self.FilterPanel.TypeTownCrier:GetSize());
	self.FilterPanel.TypeTownCrierHS:SetPosition(self.FilterPanel.TypeTownCrier:GetPosition());
	self.FilterPanel.TypeTownCrierHS.MouseClick=function()
		self.FilterPanel.TypeTownCrier:SetChecked(not self.FilterPanel.TypeTownCrier:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeTownCrierHS:SetZOrder(self.FilterPanel.TypeTownCrier:GetZOrder()+1);
	self.FilterPanel.TypeTownCrierIcon=Turbine.UI.Control();
	self.FilterPanel.TypeTownCrierIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTownCrierIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[35]~=nil and iconInfo[35][6]~=nil then
		self.FilterPanel.TypeTownCrierIcon:SetBackground(iconInfo[35][6]);
	end
	self.FilterPanel.TypeTownCrierIcon:SetStretchMode(2);
	self.FilterPanel.TypeTownCrierIcon:SetSize(self.FilterPanel.TypeTownCrierIcon:GetWidth(),self.FilterPanel.TypeTownCrierIcon:GetHeight());
	self.FilterPanel.TypeTownCrierIcon:SetStretchMode(0);
	self.FilterPanel.TypeTownCrierIcon:SetPosition(self.FilterPanel.TypeTownCrier:GetLeft()-20,self.FilterPanel.TypeTownCrier:GetTop());

	self.FilterPanel.TypeTrader=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeTrader:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTrader:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeTrader:SetForeColor(fontColor);
	self.FilterPanel.TypeTrader:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeTrader:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeTownCrier:GetTop()+20);
	self.FilterPanel.TypeTrader:SetText(Resource[language][143]);
	self.FilterPanel.TypeTrader:SetChecked(filterTypeTrader);
	self.FilterPanel.TypeTraderHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeTraderHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTraderHS:SetSize(self.FilterPanel.TypeTrader:GetSize());
	self.FilterPanel.TypeTraderHS:SetPosition(self.FilterPanel.TypeTrader:GetPosition());
	self.FilterPanel.TypeTraderHS.MouseClick=function()
		self.FilterPanel.TypeTrader:SetChecked(not self.FilterPanel.TypeTrader:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeTraderHS:SetZOrder(self.FilterPanel.TypeTrader:GetZOrder()+1);
	self.FilterPanel.TypeTraderIcon=Turbine.UI.Control();
	self.FilterPanel.TypeTraderIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTraderIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[37]~=nil and iconInfo[37][6]~=nil then
		self.FilterPanel.TypeTraderIcon:SetBackground(iconInfo[37][6]);
	end
	self.FilterPanel.TypeTraderIcon:SetStretchMode(2);
	self.FilterPanel.TypeTraderIcon:SetSize(self.FilterPanel.TypeTraderIcon:GetWidth(),self.FilterPanel.TypeTraderIcon:GetHeight());
	self.FilterPanel.TypeTraderIcon:SetStretchMode(0);
	self.FilterPanel.TypeTraderIcon:SetPosition(self.FilterPanel.TypeTrader:GetLeft()-20,self.FilterPanel.TypeTrader:GetTop());

	self.FilterPanel.TypeTrainer=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeTrainer:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTrainer:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeTrainer:SetForeColor(fontColor);
	self.FilterPanel.TypeTrainer:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeTrainer:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeTrader:GetTop()+20);
	self.FilterPanel.TypeTrainer:SetText(Resource[language][144]);
	self.FilterPanel.TypeTrainer:SetChecked(filterTypeTrainer);
	self.FilterPanel.TypeTrainerHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeTrainerHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTrainerHS:SetSize(self.FilterPanel.TypeTrainer:GetSize());
	self.FilterPanel.TypeTrainerHS:SetPosition(self.FilterPanel.TypeTrainer:GetPosition());
	self.FilterPanel.TypeTrainerHS.MouseClick=function()
		self.FilterPanel.TypeTrainer:SetChecked(not self.FilterPanel.TypeTrainer:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeTrainerHS:SetZOrder(self.FilterPanel.TypeTrainer:GetZOrder()+1);
	self.FilterPanel.TypeTrainerIcon=Turbine.UI.Control();
	self.FilterPanel.TypeTrainerIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeTrainerIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[38]~=nil and iconInfo[38][6]~=nil then
		self.FilterPanel.TypeTrainerIcon:SetBackground(iconInfo[38][6]);
	end
	self.FilterPanel.TypeTrainerIcon:SetStretchMode(2);
	self.FilterPanel.TypeTrainerIcon:SetSize(self.FilterPanel.TypeTrainerIcon:GetWidth(),self.FilterPanel.TypeTrainerIcon:GetHeight());
	self.FilterPanel.TypeTrainerIcon:SetStretchMode(0);
	self.FilterPanel.TypeTrainerIcon:SetPosition(self.FilterPanel.TypeTrainer:GetLeft()-20,self.FilterPanel.TypeTrainer:GetTop());

	self.FilterPanel.TypeVaultKeeper=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeVaultKeeper:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeVaultKeeper:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeVaultKeeper:SetForeColor(fontColor);
	self.FilterPanel.TypeVaultKeeper:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeVaultKeeper:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeTrainer:GetTop()+20);
	self.FilterPanel.TypeVaultKeeper:SetText(Resource[language][145]);
	self.FilterPanel.TypeVaultKeeper:SetChecked(filterTypeVaultKeeper);
	self.FilterPanel.TypeVaultKeeperHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeVaultKeeperHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeVaultKeeperHS:SetSize(self.FilterPanel.TypeVaultKeeper:GetSize());
	self.FilterPanel.TypeVaultKeeperHS:SetPosition(self.FilterPanel.TypeVaultKeeper:GetPosition());
	self.FilterPanel.TypeVaultKeeperHS.MouseClick=function()
		self.FilterPanel.TypeVaultKeeper:SetChecked(not self.FilterPanel.TypeVaultKeeper:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeVaultKeeperHS:SetZOrder(self.FilterPanel.TypeVaultKeeper:GetZOrder()+1);
	self.FilterPanel.TypeVaultKeeperIcon=Turbine.UI.Control();
	self.FilterPanel.TypeVaultKeeperIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeVaultKeeperIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[39]~=nil and iconInfo[39][6]~=nil then
		self.FilterPanel.TypeVaultKeeperIcon:SetBackground(iconInfo[39][6]);
	end
	self.FilterPanel.TypeVaultKeeperIcon:SetStretchMode(2);
	self.FilterPanel.TypeVaultKeeperIcon:SetSize(self.FilterPanel.TypeVaultKeeperIcon:GetWidth(),self.FilterPanel.TypeVaultKeeperIcon:GetHeight());
	self.FilterPanel.TypeVaultKeeperIcon:SetStretchMode(0);
	self.FilterPanel.TypeVaultKeeperIcon:SetPosition(self.FilterPanel.TypeVaultKeeper:GetLeft()-20,self.FilterPanel.TypeVaultKeeper:GetTop());

	self.FilterPanel.TypeVendor=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeVendor:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeVendor:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeVendor:SetForeColor(fontColor);
	self.FilterPanel.TypeVendor:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeVendor:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeVaultKeeper:GetTop()+20);
	self.FilterPanel.TypeVendor:SetText(Resource[language][146]);
	self.FilterPanel.TypeVendor:SetChecked(filterTypeVendor);
	self.FilterPanel.TypeVendorHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeVendorHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeVendorHS:SetSize(self.FilterPanel.TypeVendor:GetSize());
	self.FilterPanel.TypeVendorHS:SetPosition(self.FilterPanel.TypeVendor:GetPosition());
	self.FilterPanel.TypeVendorHS.MouseClick=function()
		self.FilterPanel.TypeVendor:SetChecked(not self.FilterPanel.TypeVendor:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeVendorHS:SetZOrder(self.FilterPanel.TypeVendor:GetZOrder()+1);
	self.FilterPanel.TypeVendorIcon=Turbine.UI.Control();
	self.FilterPanel.TypeVendorIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeVendorIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[40]~=nil and iconInfo[40][6]~=nil then
		self.FilterPanel.TypeVendorIcon:SetBackground(iconInfo[40][6]);
	end
	self.FilterPanel.TypeVendorIcon:SetStretchMode(2);
	self.FilterPanel.TypeVendorIcon:SetSize(self.FilterPanel.TypeVendorIcon:GetWidth(),self.FilterPanel.TypeVendorIcon:GetHeight());
	self.FilterPanel.TypeVendorIcon:SetStretchMode(0);
	self.FilterPanel.TypeVendorIcon:SetPosition(self.FilterPanel.TypeVendor:GetLeft()-20,self.FilterPanel.TypeVendor:GetTop());

	self.FilterPanel.TypeSkirmishCamp=Turbine.UI.Lotro.CheckBox();
	self.FilterPanel.TypeSkirmishCamp:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSkirmishCamp:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FilterPanel.TypeSkirmishCamp:SetForeColor(fontColor);
	self.FilterPanel.TypeSkirmishCamp:SetSize(self.FilterPanel.TypeMain:GetWidth(),18);
	self.FilterPanel.TypeSkirmishCamp:SetPosition(self.FilterPanel.TypeMain:GetLeft(),self.FilterPanel.TypeVendor:GetTop()+20);
	self.FilterPanel.TypeSkirmishCamp:SetText(Resource[language][154]);
	self.FilterPanel.TypeSkirmishCamp:SetChecked(filterTypeSkirmishCamp);
	self.FilterPanel.TypeSkirmishCampHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.FilterPanel.TypeSkirmishCampHS:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSkirmishCampHS:SetSize(self.FilterPanel.TypeSkirmishCamp:GetSize());
	self.FilterPanel.TypeSkirmishCampHS:SetPosition(self.FilterPanel.TypeSkirmishCamp:GetPosition());
	self.FilterPanel.TypeSkirmishCampHS.MouseClick=function()
		self.FilterPanel.TypeSkirmishCamp:SetChecked(not self.FilterPanel.TypeSkirmishCamp:IsChecked());
		self.NeedsRefresh=true;
		self:SetWantsUpdates(true);
	end
	self.FilterPanel.TypeSkirmishCampHS:SetZOrder(self.FilterPanel.TypeSkirmishCamp:GetZOrder()+1);
	self.FilterPanel.TypeSkirmishCampIcon=Turbine.UI.Control();
	self.FilterPanel.TypeSkirmishCampIcon:SetParent(self.FilterPanel.ScrollPanel);
	self.FilterPanel.TypeSkirmishCampIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	if iconInfo[42]~=nil and iconInfo[42][6]~=nil then
		self.FilterPanel.TypeSkirmishCampIcon:SetBackground(iconInfo[42][6]);
	end
	self.FilterPanel.TypeSkirmishCampIcon:SetStretchMode(2);
	self.FilterPanel.TypeSkirmishCampIcon:SetSize(self.FilterPanel.TypeSkirmishCampIcon:GetWidth(),self.FilterPanel.TypeSkirmishCampIcon:GetHeight());
	self.FilterPanel.TypeSkirmishCampIcon:SetStretchMode(0);
	self.FilterPanel.TypeSkirmishCampIcon:SetPosition(self.FilterPanel.TypeSkirmishCamp:GetLeft()-20,self.FilterPanel.TypeSkirmishCamp:GetTop());

	self.FilterPanel.TypeScholarNodeTier:SetZOrder(self.FilterPanel.TypeSkirmishCampIcon:GetZOrder()+1);
	self.FilterPanel.TypeWoodNodeTier:SetZOrder(self.FilterPanel.TypeScholarNodeTier:GetZOrder()+1);
	self.FilterPanel.TypeOreNodeTier:SetZOrder(self.FilterPanel.TypeWoodNodeTier:GetZOrder()+1);

	self.Map.Ping=Turbine.UI.Control();
	self.Map.Ping:SetParent(self.Map);
	self.Map.Ping.State=0;
	self.Map.Ping:SetVisible(false);
	self.Map.Ping:SetSize(23,23);
	self.Map.Ping:SetPosition(512,512);
	self.Map.Ping:SetWantsUpdates(false);
	self.Map.Ping.Counter=1;
	self.Map.Ping.MaxCounter=2;
	self.Map.Ping:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping1.tga");
	self.Map.Ping.MouseClick=function(sender,args)
		mapWindow.Map.Ping.State=0; -- it will auto hide itself on next tick
	end
	self.Map.Ping.Update=function(sender)
		if self.Map.Ping.State==0 then
			self.Map.Ping:SetWantsUpdates(false);
			self.Map.Ping:SetVisible(false);
			self.Map.Ping.Counter=0;
			self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping1.tga");
		elseif self.Map.Ping.State==1 then
			self.Map.Ping.Counter=self.Map.Ping.Counter+1;
			if self.Map.Ping.Counter>self.Map.Ping.MaxCounter then
				self.Map.Ping.Counter=0;
				self.Map.Ping.State=2;
				self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping2.tga");
			end
		elseif self.Map.Ping.State==2 then
			self.Map.Ping.Counter=self.Map.Ping.Counter+1;
			if self.Map.Ping.Counter>self.Map.Ping.MaxCounter then
				self.Map.Ping.Counter=0;
				self.Map.Ping.State=3;
				self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping3.tga");
			end
		elseif self.Map.Ping.State==3 then
			self.Map.Ping.Counter=self.Map.Ping.Counter+1;
			if self.Map.Ping.Counter>self.Map.Ping.MaxCounter then
				self.Map.Ping.Counter=0;
				self.Map.Ping.State=4;
				self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping4.tga");
			end
		elseif self.Map.Ping.State==4 then
			self.Map.Ping.Counter=self.Map.Ping.Counter+1;
			if self.Map.Ping.Counter>self.Map.Ping.MaxCounter then
				self.Map.Ping.Counter=0;
				self.Map.Ping.State=5;
				self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping5.tga");
			end
		elseif self.Map.Ping.State==5 then
			self.Map.Ping.Counter=self.Map.Ping.Counter+1;
			if self.Map.Ping.Counter>self.Map.Ping.MaxCounter then
				self.Map.Ping.Counter=0;
				self.Map.Ping.State=6;
				self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping6.tga");
			end
		elseif self.Map.Ping.State==6 then
			self.Map.Ping.Counter=self.Map.Ping.Counter+1;
			if self.Map.Ping.Counter>self.Map.Ping.MaxCounter then
				self.Map.Ping.Counter=0;
				self.Map.Ping.State=7;
				self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping7.tga");
			end
		elseif self.Map.Ping.State==7 then
			self.Map.Ping.Counter=self.Map.Ping.Counter+1;
			if self.Map.Ping.Counter>self.Map.Ping.MaxCounter then
				self.Map.Ping.Counter=0;
				self.Map.Ping.State=3;
				self.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping3.tga");
			end
		end
	end

	self.Map.HoverInfo=Turbine.UI.ContextMenu();
	self.Map.HoverInfo:GetItems():Add(Turbine.UI.MenuItem("Name"));
	self.Map.HoverInfo:GetItems():Get(1):SetEnabled(false);
	self.Map.HoverInfo:GetItems():Add(Turbine.UI.MenuItem("Coord"));
	self.Map.HoverInfo:GetItems():Get(2):SetEnabled(false);
	self.Map.HoverInfo:GetItems():Add(Turbine.UI.MenuItem("Edit"));
	self.Map.HoverInfo:GetItems():Get(3):SetEnabled(true);
	self.Map.HoverInfo:GetItems():Get(3).Click=function()
		annotWindow:SetVisible(true);
	end
	if debug then
		self.Map.HoverInfo:GetItems():Add(Turbine.UI.MenuItem("X:Y"));
		self.Map.HoverInfo:GetItems():Get(4):SetEnabled(false);
	end
	self:SetText(Resource[language][2]);

	self.SetPluginUnloading = function(value)
		self.PluginUnloading=value;
	end
	self.VisibleChanged=function()
		if (not self.PluginUnloading) then
			if not self:IsVisible() then
				minWindow:SetVisible(true);
				quickWindow:SetVisible(quickWindow.Displayed);
				if optWindow~=nil then optWindow:SetVisible(false) end;
				if annotWindow~=nil then annotWindow:SetVisible(false) end;
				if mapWindow.PopUp~=nil then
					mapWindow.PopUp:SetVisible(false);
					mapWindow.PopUp=nil; -- dismiss the dialog
				end
			else
				-- refresh anything that needs refreshing when map is visible
				RefreshMap();
			end
		end
	end

	self.AddAnnotationMenu=Turbine.UI.ContextMenu();
	if self.CurrentMapID~=2 then
		self.AddAnnotationMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][82]));
		self.AddAnnotationMenu:GetItems():Get(1).Click=function()
			annotWindow.AnnotationList:SetSelectedIndex(1);
			annotWindow:EditAnnotation(0);
			annotWindow.TypeList:SetSelectedIndex(1);
			annotWindow.NameText:SetText("");
			annotWindow.DescriptionText:SetText("");
			annotWindow:SetVisible(true);
		end
		self.AddAnnotationMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][148]));
		self.AddAnnotationMenu:GetItems():Get(2).Click=function()
			RefreshMap(mapInfo[mapWindow.CurrentMapID][10]);
		end
	end

	self.MovingIcon=Turbine.UI.Control();
	self.MovingIcon:SetParent(self);
	self.MovingIcon:SetSize(32,32);
	self.MovingIcon:SetStretchMode(1); -- allows it to display past the parent's bounds
	self.MovingIcon:SetBackground(0x410081c0)
	-- for some reason, when StretchMode=1, setting the control's position or size AFTER loading the resource background makes it appear... WEIRD
	self.MovingIcon:SetPosition(self:GetWidth()/2-15,self:GetHeight()-21);
	self.MovingIcon:SetVisible(false);

	self.KeyDown=function(sender, args)
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			mapWindow:SetVisible(false);
			minWindow:SetVisible(true);
			quickWindow:SetVisible(quickWindow.Displayed);
			if defAnnWindow~=nil then
				defAnnWindow:SetVisible(false);
			end
		end
		if ( args.Action == 268435635 ) then -- toggle HUD
			mapWindow:SetVisible( false );
			minWindow:SetVisible( false ); -- this is harmless if the "ShowIconWhenMinimized" option is turned off
			quickWindow:SetVisible(false);
			-- if turbine ever exposes the UI state, we can force the minimized icon not to display when the HUD is off
			if defAnnWindow~=nil then
				defAnnWindow:SetVisible(false);
			end
		end
	end

	self.SetHeight=function(sender,height)
		if height<297 then height=297 end;
		Turbine.UI.Window.SetHeight(self,height);
		-- now move/resize all the controls
		self.MovingIcon:SetTop(height-21);
		self.Map:SetSize(self:GetWidth(),height); -- when using stretchmode=1, you HAVE to use setSize or the other parameter goes back to "actual" value
		self.SearchPanel:SetHeight(self:GetHeight()-50);
		self.FilterPanel:SetHeight(self:GetHeight()-50);
		self.FilterPanel.ViewPane:SetHeight(self.FilterPanel:GetHeight()-self.FilterPanel.Separator1:GetTop()-3);
		self.FilterPanel.VScroll:SetMaximum(self.FilterPanel.ScrollPanel:GetHeight()-self.FilterPanel.ViewPane:GetHeight());
		self.FilterPanel.VScroll:SetHeight(self.FilterPanel.ViewPane:GetHeight());
		self.FilterPanel.VScroll:SetVisible(self.FilterPanel.ViewPane:GetHeight()<self.FilterPanel.ScrollPanel:GetHeight());

		self.Map.IconList:SetHeight(self.SearchPanel:GetHeight()-46);
		self.Map.IconList.VScroll:SetHeight(self.Map.IconList:GetHeight());
	end

	self.SetSize=function(sender, width, height)
		if debug then
			Turbine.Shell.WriteLine("setting size ("..tostring(width)..","..tostring(height)..")");
		end
		local minWidth=self.MapSelect:GetLeft()+self.MapSelect:GetWidth()+24;
		if width<minWidth then width=minWidth end;
		Turbine.UI.Window.SetSize(self,width,height);
		self.CloseButton:SetLeft(width-20);
		if self.Map ~=nil then
			self.Map:SetSize(width,height);
		end
	end

	self.SetWidth=function(sender,width)
		local minWidth=self.MapSelect:GetLeft()+self.MapSelect:GetWidth()+24;
		if width<minWidth then width=minWidth end;
		Turbine.UI.Window.SetWidth(self,width);
		self.MovingIcon:SetLeft(width-21);
		self.Map:SetSize(width, self:GetHeight());

		self.CloseButton:SetLeft(width-20);
		self.SearchPanel:SetLeft(self:GetWidth()-400);
	end

	self.MouseDown=function(sender,args)
		if (args.Y>self:GetHeight()-15) and (args.X>self:GetWidth()-15) then
			self.MoveX=args.X;
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetBackground(0x41007e20)
			self.MovingIcon:SetVisible(true);
		elseif (args.Y>self:GetHeight()-12) then
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-22);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetBackground(0x410081c0)
			self.MovingIcon:SetVisible(true);
		elseif (args.X>self:GetWidth()-12) then
			self.MoveX=args.X;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-22);
			self.MovingIcon:SetBackground(0x410081bf)
			self.MovingIcon:SetVisible(true);
		elseif (args.Y<8) then
			self.MoveX=args.X;
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetSize(32,32);
			self.MovingIcon:SetBackground(0x410000dd)
			self.MovingIcon:SetVisible(true);
		else
			self.MoveX=-1;
			self.MoveY=-1;
		end
		if self.PopUp~=nil then
			self.PopUp:SetVisible(false);
			self.PopUp=nil; -- dismiss the dialog
		end
	end

	self.MouseMove=function(sender,args)
		if (self.MoveY>-1 and self.MoveY<8) then
			if (args.X~=self.MoveX or args.Y~= self.MoveY) then
				self.Moving=true;
				local newLeft=self:GetLeft()-(self.MoveX-args.X)
				local newTop=self:GetTop()-(self.MoveY-args.Y)
				if newLeft<0 then newLeft=0 end;
				if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
				if newTop<0 then newTop=0 end;
				if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
				self:SetPosition(newLeft,newTop);
			end
		else		
			if (self.MoveY>-1) then
				if args.Y~= self.MoveY then
					self.Resizing=true;
					local newHeight=self:GetHeight()-(self.MoveY-args.Y);
					if newHeight<215 then newHeight=215 end;
					if newHeight>(Turbine.UI.Display.GetHeight()-self:GetTop()) then newHeight=Turbine.UI.Display.GetHeight()-self:GetTop() end;
					local newX=args.X-22;
					if newX<-13 then newX=-13 end
					if newX>(self:GetWidth()-18) then newX=self:GetWidth()-18 end
					self.MovingIcon:SetLeft(newX);
					self:SetHeight(newHeight);
					self.MoveY=args.Y;
				end
			end
			if (self.MoveX>-1) then
				if args.X~= self.MoveX then
					self.Resizing=true;
					local newWidth=self:GetWidth()-(self.MoveX-args.X);
					if newWidth<414 then newWidth=414 end;
					if newWidth>(Turbine.UI.Display.GetWidth()-self:GetLeft()) then newWidth=Turbine.UI.Display.GetWidth()-self:GetLeft() end;
					local newY=args.Y-22;
					if newY<-13 then newY=-13 end
					if newY>(self:GetHeight()-18) then newY=self:GetHeight()-18 end
					self.MovingIcon:SetTop(newY);
					self:SetWidth(newWidth);
					self.MoveX=args.X;
				end
			end
		end
		if not self.Moving and not self.Resizing then
			-- update location display
			if mapWindow.CurrentMapID==nil then
				if debug then
					Turbine.Shell.WriteLine("CurrentMapID is NULL in mapWindow.MouseMove()!");
				end
			else
				if mapInfo[mapWindow.CurrentMapID]==nil then
					if debug then
						Turbine.Shell.WriteLine("CurrentMapID="..tostring(mapWindow.CurrentMapID).." but mapInfo[mapWindow.CurrentMapID] is NULL in .MouseMove()!");
					end
				else
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						--looks like we need to scale here
						local XScale=mapInfo[mapWindow.CurrentMapID][4]/self:GetWidth();
						local YScale=mapInfo[mapWindow.CurrentMapID][5]/self:GetHeight();
						local EW;
						local NS;

						if debug then
							EW=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*100)/100;
							NS=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*100)/100;
						else
							EW=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*10)/10;
							NS=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*10)/10;
						end
						if EW<0 then
							self.EWCoord:SetText(tostring(0-EW)..Resource[language][153]);
						else
							self.EWCoord:SetText(tostring(EW)..Resource[language][152]);
						end
						if NS<0 then
							self.NSCoord:SetText(tostring(0-NS)..Resource[language][151]);
						else
							self.NSCoord:SetText(tostring(NS)..Resource[language][150]);
						end
					end
				end
			end
		end
	end

	self.MouseUp=function(sender,args)
		self.MovingIcon:SetVisible(false);
		self.MoveX=-1;
		self.MoveY=-1;
		self.Moving=false;
		self.Resizing=false;
	end

	self.MouseClick=function(sender,args)
		self.SearchPanel:SetVisible(false);
		self.FilterPanel:SetVisible(false);
		self.Map.IconSearch:SetWantsUpdates(false);
		if not self.Moving and not self.Resizing and args.Button==2 then
			-- user right clicked on map, popup the "Add Annotation" option
			local XScale=mapInfo[mapWindow.CurrentMapID][4]/self:GetWidth();
			local YScale=mapInfo[mapWindow.CurrentMapID][5]/self:GetHeight();
			local NSCoord=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*10)/10;
			local EWCoord=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*10)/10;
			if EWCoord<0 then
				annotWindow.EWCoordText:SetText(tostring(0-EWCoord));
				annotWindow.EWButtons:SetSelectedChoice(2)
			else
				annotWindow.EWCoordText:SetText(tostring(EWCoord));
				annotWindow.EWButtons:SetSelectedChoice(1)
			end
			if NSCoord<0 then
				annotWindow.NSCoordText:SetText(tostring(0-NSCoord));
				annotWindow.NSButtons:SetSelectedChoice(2)
			else
				annotWindow.NSCoordText:SetText(tostring(NSCoord));
				annotWindow.NSButtons:SetSelectedChoice(1)
			end
			self.AddAnnotationMenu:ShowMenu();
		end
	end

-- set ZOrder so that the drop downs can cover other items, etc
	self.Map:SetZOrder(1);
	self.ControlPanel:SetZOrder(2);
	self.ControlPanel.OptionsButton:SetZOrder(5);
	self.ControlPanel.AnnotationsButton:SetZOrder(7);
	self.SearchButton:SetZOrder(8);
	if self.LocationButton ~=nil then
		self.LocationContainer:SetZOrder(9);
		self.LocationButton:SetZOrder(10);
	end
	self.FilterButton:SetZOrder(12);
	self.MovingIcon:SetZOrder(15);
	self.NSCoord:SetZOrder(17);
	self.EWCoord:SetZOrder(20);
	self.MapSelect:SetZOrder(23);
	self.CloseButton:SetZOrder(23);
	self.SearchPanel:SetZOrder(self.Map:GetZOrder()+1);
	self.FilterPanel:SetZOrder(self.Map:GetZOrder()+1);
	self.FilterPanel.VScroll:SetZOrder(self.Map:GetZOrder()+1);

	self:SetWantsKeyEvents(true);
	self:SetWantsUpdates(true)

	self.RemoveShellCommands=function(sender,args)
		Turbine.Shell.RemoveCommand(self.shellCmd)
	end
	self.shellCmd=Turbine.ShellCommand();
	local numberOfCommandsRegistered = Turbine.Shell.AddCommand("MoorMap",self.shellCmd);

	self.shellCmd.Execute = function(sender, cmd, args)
		if (string.lower(cmd) == "moormap") then
			local pos1=string.find(args," ",0,true);
			local command;
			if pos1~=nil and pos1>0 then
				command=string.lower(string.sub(args,1,pos1-1));
			else
				command=string.lower(args);
			end
			if (command=="show") then
				minWindow:SetVisible(false);
				quickWindow:SetVisible(quickWindow.Displayed);
				self:SetVisible(true);
			elseif (command=="hide") then
				mapWindow:SetVisible(false);
				minWindow:SetVisible(true);
				quickWindow:SetVisible(quickWindow.Displayed);
			elseif (command=="toggle") then
				mapWindow:SetVisible(not mapWindow:IsVisible());
				minWindow:SetVisible(not mapWindow:IsVisible());
				quickWindow:SetVisible(quickWindow.Displayed);
			elseif (command=="adm") then
				if defAnnWindow==nil then
					import "GaranStuff.MoorMap.DefaultAnnotationMaker";
					defAnnWindow=DefaultAnnotationsMaker();
				end
				defAnnWindow:SetVisible(true);
			elseif pos1~=nil and pos1>0 and command=="target" and defAnnWindow~=nil then
				-- args are"region: area: NSCoord, EWCoord:Target"
				-- where "region: area: NSCoord, EWCoord" is generated by ;loc
				-- -- region Eregion=region1, Rhovanion=region2
				-- "Target" any non blank value other than ";target" is valid
				-- split up the args following "target"
				local argArray=string.split(string.sub(args,pos1+1),":");
				local region;
				local NSCoord;
				local EWCoord;
				local iconType=5;
				local target=";target";
				local tier=0;
				if argArray[1]~=nil then
					if string.lower(argArray[1])=="eriador" then
						region=1;
					elseif string.lower(argArray[1])=="rhovanion" then
						region=2;
					end
				end
				if region==nil then
					Turbine.Shell.WriteLine(Resource[1][165].." \""..argArray[1].."\". "..Resource[1][164]);
				else
					if argArray[3]~=nil then
						NSCoord=string.lower(string.trim(string.gsub(argArray[3], "^(.-),(.*)","%1")));
						EWCoord=string.lower(string.trim(string.gsub(argArray[3], "(.*),(.-)$", "%2")));
						if argArray[4]~=nil then
							target=string.trim(argArray[4]);
						end
						-- if target~=nil, look it up in nodeTier[#nodeTier+1] to see if we get a match on a crafting node
						if target~=nil then
							local tmpIndex;
							for tmpIndex=1,#nodeTier do
								if nodeTier[tmpIndex][1]==target then
									iconType=nodeTier[tmpIndex][2];
									tier=nodeTier[tmpIndex][3];
									break;
								end
							end
						end

						if string.sub(NSCoord,-1)=="n" then
							NSCoord=string.sub(NSCoord,1,string.len(NSCoord)-1)
						elseif string.sub(NSCoord,-1)=="s" then
							NSCoord="-"..string.sub(NSCoord,1,string.len(NSCoord)-1)
						else
							NSCoord=nil;
						end
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end

						if NSCoord~=nil and EWCoord~=nil then
							if euroFormat then -- only allow this routine to run on EN clients
								NSCoord=nil
								EWCoord=nil
							else
								NSCoord=tonumber((string.gsub(NSCoord,",",".")))
								EWCoord=tonumber((string.gsub(EWCoord,",",".")))
							end
						end
					end

					if NSCoord==nil or EWCoord==nil then
						Turbine.Shell.WriteLine(Resource[1][167].." \""..argArray[3].."\". "..Resource[1][164]);
					else
						if iconType==nil then
							Turbine.Shell.WriteLine(Resource[1][168].." \""..argArray[4].."\". "..Resource[1][164]);
						else
							if target==";target" then
								Turbine.Shell.WriteLine(Resource[1][169]..Resource[1][164]);
							else
								-- now send all of the data to the DefaultAnnotationMaker dialog
								defAnnWindow:SetTargetInfo(NSCoord,EWCoord,iconType,tier,target);
							end
						end
					end

				end
			elseif pos1~=nil and pos1>0 and command=="setloc" then
				Turbine.Shell.WriteLine("Setting location:"..args)
				-- try to find the right map and then ping the location

			elseif pos1~=nil and pos1>0 and command=="add" then
				-- args are"region: area: NSCoord, EWCoord:IconType:Language:Target"
				-- where "region: area: NSCoord, EWCoord" is generated by ;loc
				-- -- region Eregion=region1, Rhovanion=region2
				-- "IconType" is one of the predefined icon values, 5=POI, 11=NPC, 43=Ore Node, 44=Wood Node, 45=Scholar Node : null default=5
				-- "Language" is one of the predefined lanugauge values, EN=English, FR=French, DE=German : null default=EN
				-- "Target" any non blank value other than ";target" is valid
				-- split up the args following "add"
				local argArray=string.split(string.sub(args,pos1+1),":");
				local region;
				local NSCoord;
				local EWCoord;
				local iconType=5;
				local lang="EN";
				local target=";target";
				local tier=0;
				if argArray[1]~=nil then
					if string.lower(argArray[1])=="eriador" then
						region=1;
					elseif string.lower(argArray[1])=="rhovanion" then
						region=2;
					end
				end
				if region==nil then
					Turbine.Shell.WriteLine(Resource[language][165].." \""..argArray[1].."\". "..Resource[language][164]);
				else
					if argArray[3]~=nil then
						NSCoord=string.lower(string.trim(string.gsub(argArray[3], "^(.-),(.*)","%1")));
						EWCoord=string.lower(string.trim(string.gsub(argArray[3], "(.*),(.-)$", "%2")));
						if argArray[4]~=nil and argArray[4]~="" then
							iconType=tonumber(argArray[4]);
						end
						if argArray[5]~=nil and argArray[5]~="" then
							lang=string.trim(argArray[5]);
						end
						if argArray[6]~=nil then
							target=string.trim(argArray[6]);
						end
						-- if target~=nil, look it up in nodeTier[#nodeTier+1] to see if we get a match on a crafting node
						if target~=nil then
							local tmpIndex;
							for tmpIndex=1,#nodeTier do
								if nodeTier[tmpIndex][1]==target and nodeTier[tmpIndex][4]==0 then
									iconType=nodeTier[tmpIndex][2];
									tier=nodeTier[tmpIndex][3];
									break;
								end
							end
						end

						if lang=="EN" then
							if string.sub(NSCoord,-1)=="n" then
								NSCoord=string.sub(NSCoord,1,string.len(NSCoord)-1)
							elseif string.sub(NSCoord,-1)=="s" then
								NSCoord="-"..string.sub(NSCoord,1,string.len(NSCoord)-1)
							else
								NSCoord=nil;
							end
							if string.sub(EWCoord,-1)=="e" then
								EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
							elseif string.sub(EWCoord,-1)=="w" then
								EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
							else
								EWCoord=nil;
							end
						elseif lang=="FR" then
							if string.sub(NSCoord,-1)=="n" then
								NSCoord=string.sub(NSCoord,1,string.len(NSCoord)-1)
							elseif string.sub(NSCoord,-1)=="s" then
								NSCoord="-"..string.sub(NSCoord,1,string.len(NSCoord)-1)
							else
								NSCoord=nil;
							end
							if string.sub(EWCoord,-1)=="e" then
								EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
							elseif string.sub(EWCoord,-1)=="o" then
								EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
							else
								EWCoord=nil;
							end
						elseif lang=="DE" then
							if string.sub(NSCoord,-1)=="n" then
								NSCoord=string.sub(NSCoord,1,string.len(NSCoord)-1)
							elseif string.sub(NSCoord,-1)=="s" then
								NSCoord="-"..string.sub(NSCoord,1,string.len(NSCoord)-1)
							else
								NSCoord=nil;
							end
							if string.sub(EWCoord,-1)=="o" then
								EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
							elseif string.sub(EWCoord,-1)=="w" then
								EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
							else
								EWCoord=nil;
							end
						else
							NSCoord=nil;
							EWCoord=nil;
						end
						if NSCoord~=nil and EWCoord~=nil then
							if euroFormat then
								NSCoord=tonumber((string.gsub(NSCoord,"%.",",")))
								EWCoord=tonumber((string.gsub(EWCoord,"%.",",")))
							else
								NSCoord=tonumber((string.gsub(NSCoord,",",".")))
								EWCoord=tonumber((string.gsub(EWCoord,",",".")))
							end
						end
					end
					if lang~="EN" and lang~="FR" and lang~="DE" then
						Turbine.Shell.WriteLine(Resource[language][166].." \""..argArray[5].."\". "..Resource[language][164]);
					else
						if NSCoord==nil or EWCoord==nil then
							Turbine.Shell.WriteLine(Resource[language][167].." \""..argArray[3].."\". "..Resource[language][164]);
						else
							if iconType==nil then
								Turbine.Shell.WriteLine(Resource[language][168].." \""..argArray[4].."\". "..Resource[language][164]);
							else
								if target==";target" then
									Turbine.Shell.WriteLine(Resource[language][169]..Resource[language][164]);
								else
									-- ok. we have proof of concept. now we just need to resolve the correct map and then follow the same routine as the "ping" function below without "ExternalPing=true"
									if debug then
										Turbine.Shell.WriteLine("add annotation:"..target.." ("..tostring(iconType)..") at:");
										Turbine.Shell.WriteLine("region:"..region.." NS:"..NSCoord.." EW:"..EWCoord);
										Turbine.Shell.WriteLine("tier:"..tostring(tier));
									end
									local mapList=ResolveMap(region,NSCoord,EWCoord);
									if mapList==nil or #mapList==0 then
										Turbine.Shell.WriteLine(Resource[language][170]..Resource[language][164]);
									else
										local tmpIndex;
										local dupIndex;
										local dupFound;
										NSCoord=tonumber(NSCoord);
										EWCoord=tonumber(EWCoord);
										for tmpIndex=1,#mapList do
										-- check for preexisting duplicate at same map, same name, same coordinates
											dupFound=false;
											for dupIndex=1,#annotations do
												if annotations[dupIndex][1]==mapList[tmpIndex] and annotations[dupIndex][2]==NSCoord and annotations[dupIndex][3]==EWCoord and annotations[dupIndex][7]==target..": "..target then
													dupFound=true;
													break;
												end
											end
											if dupFound then
												Turbine.Shell.WriteLine(target..Resource[language][171]..tostring(Resource[language][mapInfo[mapList[tmpIndex]][2]])..".");
											else
												annotations[#annotations+1]={mapList[tmpIndex],NSCoord,EWCoord,iconType,0,nil,target..": "..target,tier,0,0,0};
												Turbine.Shell.WriteLine(target..Resource[language][172]..tostring(Resource[language][mapInfo[mapList[tmpIndex]][2]]));
											end
										end
										annotWindow.LoadAnnotationList(); -- refresh the maintenance window in case we modified an annotation on the current map
									end
								end
							end
						end
					end
				end
			elseif pos1~=nil and pos1>0 and command=="ping" then
				-- split up the args following "ping"
				local argArray=string.split(string.sub(args,pos1+1),":");
				if euroFormat then
					if argArray[2]~=nil then
						argArray[2]=tonumber((string.gsub(argArray[2],"%.",",")));
					end
					if argArray[3]~=nil then
						argArray[3]=tonumber((string.gsub(argArray[3],"%.",",")));
					end
				else
					if argArray[2]~=nil then
						argArray[2]=tonumber((string.gsub(argArray[2],",",".")));
					end
					if argArray[3]~=nil then
						argArray[3]=tonumber((string.gsub(argArray[3],",",".")));
					end
				end
				if tonumber(argArray[1])==nil then
					Turbine.Shell.WriteLine(Resource[language][174]..tostring(argArray[1]).."). "..Resource[language][173]);
				elseif tonumber(argArray[2])==nil then
					Turbine.Shell.WriteLine(Resource[language][175]..tostring(argArray[2]).."). "..Resource[language][173]);
				elseif tonumber(argArray[3])==nil then
					Turbine.Shell.WriteLine(Resource[language][176]..tostring(argArray[3]).."). "..Resource[language][173]);
				elseif argArray[4]==nil then
					Turbine.Shell.WriteLine(Resource[language][177]..Resource[language][173]);
				elseif argArray[5]==nil then
					Turbine.Shell.WriteLine(Resource[language][178]..Resource[language][173]);
				else
					argArray[1]=math.floor(tonumber(argArray[1]));
					argArray[2]=tonumber(argArray[2]);
					argArray[3]=tonumber(argArray[3]);
					if argArray[1]>0 and argArray[1]<=#mapInfo then
						-- calculate x,y coordinates and verify they fall on the target map
						local X=math.floor(argArray[3]*mapInfo[argArray[1]][6]+mapInfo[argArray[1]][7]);
						local Y=math.floor(argArray[2]*mapInfo[argArray[1]][8]+mapInfo[argArray[1]][9]);
						if X<0 or X>mapInfo[argArray[1]][4] then
							Turbine.Shell.WriteLine(Resource[language][180]..tostring(argArray[3]).."). "..Resource[language][173]);
						elseif Y<0 or Y>mapInfo[argArray[1]][5] then
							Turbine.Shell.WriteLine(Resource[language][181]..tostring(argArray[2]).."). "..Resource[language][173]);
						else
							if argArray[1]==mapWindow.CurrentMapID then
								AddPing(argArray[2],argArray[3],argArray[4],argArray[5]);
							else

								self.PingNS=argArray[2];
								self.PingEW=argArray[3];
								self.PingName=argArray[4];
								self.PingDesc=argArray[5];
								self.ExternalPing=true;
								self.PreserveMapID=true;
								RefreshMap(argArray[1]);
							end
						end
					else
						-- invalid map specified
						Turbine.Shell.WriteLine(Resource[language][179]..Resource[language][173]);
					end
				end
			else
				Turbine.Shell.WriteLine("usage:");
				Turbine.Shell.WriteLine("  /MoorMap show");
				Turbine.Shell.WriteLine("       Displays the MoorMap map.");
				Turbine.Shell.WriteLine("  /MoorMap hide");
				Turbine.Shell.WriteLine("       Hides the MoorMap map.");
				Turbine.Shell.WriteLine("  /MoorMap toggle");
				Turbine.Shell.WriteLine("       Toggles the MoorMap map (shows it if it was hidden, hides it if it was showing).");
				Turbine.Shell.WriteLine("  /MoorMap ping MapID:NSCoord:EWCoord:Name:Description");
				Turbine.Shell.WriteLine("       Locates the named annotation on the indicated map and if it doesn't exist adds it then opens that map and puts a flashing Ping at the location.");
				Turbine.Shell.WriteLine("       This command enables external applications to add annotations and indicate them on the map. For more details on how to implement this, please");
				Turbine.Shell.WriteLine("       view the Readme.txt file that was in the original zip file and should now be located in your Plugins\GaranStuff\MoorMap folder.");
			end
		end
	end
	self.shellCmd.GetHelp = function(sender, cmd)
		return("usage:\n  /MoorMap show\n       Displays the MoorMap map.\n  /MoorMap hide\n       Hides the MoorMap map.\n  /MoorMap toggle\n       Toggles the MoorMap map (shows it if it was hidden, hides it if it was showing).");
	end

	self.shellCmd.GetShortHelp = function(sender, cmd)
		return("MoorMap - usage: /MoorMap show | hide | toggle");
	end
	self.Closing=function()
	end

	self.GetShowIconWhenMinimized=function()
		return self.ShowIconWhenMinimized;
	end
	self.SetShowIconWhenMinimized=function(sender,value)
		self.ShowIconWhenMinimized=value;
		if value then
			minWindow:SetSize(32,32);
		else
			minWindow:SetSize(0,0);
		end
	end

	self.SetTrimColor=function()
	end
	self.SetBackColor=function()
		self.NSCoord:SetBackColor(backColor);
		self.EWCoord:SetBackColor(backColor);
	end
	self.SetListTextColor=function()
	end
	self.SetFontColor=function()
		self.NSCoord:SetForeColor(fontColor);
		self.EWCoord:SetForeColor(fontColor);
	end
	self.SetHeadingsColor=function()
	end
	self.SetLanguage=function()
		if mapStrings[language]==nil or type(mapStrings[language])~="table" then
			mapStrings[language]={};
		end
		self:SetText(Resource[language][2]);
		self.AddAnnotationMenu:GetItems():Get(1):SetText(Resource[language][82]);
		if language==2 then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5:FR:;cible"))
		elseif language==3 then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;pos:5:DE:;ziel"))
		else
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5::;target"))
		end
		quickWindow.Quickslot:SetVisible(true);

		if debug and self.LocationQuickSlot~=nil then
			if language==2 then
				self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
			elseif language==3 then
				self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;pos"))
			else
				self.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
			end
			self.LocationQuickSlot:SetVisible(true);
		end

		self.FilterPanel.Title:SetText(Resource[language][66]);
		self.FilterPanel.AllegianceCaption:SetText(Resource[language][67]..":");
		self.FilterPanel.AllegianceCreep:SetText(Resource[language][68]);
		self.FilterPanel.AllegianceFreep:SetText(Resource[language][69]);
		self.FilterPanel.AllegianceDelving:SetText(Resource[language][70]);
		self.FilterPanel.TypeCaption:SetText(Resource[language][74]..":");
		self.FilterPanel.TypeMain:SetText(Resource[language][143]);
		self.FilterPanel.TypeSecondary:SetText(Resource[language][144]);
		self.FilterPanel.TypeBase:SetText(Resource[language][145]);
		self.FilterPanel.TypeOutpost:SetText(Resource[language][146]);
		self.FilterPanel.TypePOI:SetText(Resource[language][147]);
		self.FilterPanel.TypeFort:SetText(Resource[language][148]);
		self.FilterPanel.TypeRez:SetText(Resource[language][149]);
		self.FilterPanel.TypeMap:SetText(Resource[language][150]);
		self.FilterPanel.TypeNPC:SetText(Resource[language][151]);

		self.Map.SearchFilterCaption:SetText(Resource[language][65]..":");
		self.Map.IconCreepCB:SetText(Resource[language][68]);
		self.Map.IconFreepCB:SetText(Resource[language][69]);
		self.Map.IconDelvingCB:SetText(Resource[language][70]);

		self.FilterPanel.TypeOreNodeTier.ListData:GetItem(1):SetText(Resource[language][158]);
		self.FilterPanel.TypeOreNodeTier.ListData:GetItem(2):SetText(Resource[language][159].." 1");
		self.FilterPanel.TypeOreNodeTier.ListData:GetItem(3):SetText(Resource[language][159].." 2");
		self.FilterPanel.TypeOreNodeTier.ListData:GetItem(4):SetText(Resource[language][159].." 3");
		self.FilterPanel.TypeOreNodeTier.ListData:GetItem(5):SetText(Resource[language][159].." 4");
		self.FilterPanel.TypeOreNodeTier.ListData:GetItem(6):SetText(Resource[language][159].." 5");
		self.FilterPanel.TypeOreNodeTier.ListData:GetItem(7):SetText(Resource[language][159].." 6");
		self.FilterPanel.TypeWoodNodeTier.ListData:GetItem(1):SetText(Resource[language][158]);
		self.FilterPanel.TypeWoodNodeTier.ListData:GetItem(2):SetText(Resource[language][159].." 1");
		self.FilterPanel.TypeWoodNodeTier.ListData:GetItem(3):SetText(Resource[language][159].." 2");
		self.FilterPanel.TypeWoodNodeTier.ListData:GetItem(4):SetText(Resource[language][159].." 3");
		self.FilterPanel.TypeWoodNodeTier.ListData:GetItem(5):SetText(Resource[language][159].." 4");
		self.FilterPanel.TypeWoodNodeTier.ListData:GetItem(6):SetText(Resource[language][159].." 5");
		self.FilterPanel.TypeWoodNodeTier.ListData:GetItem(7):SetText(Resource[language][159].." 6");
		self.FilterPanel.TypeScholarNodeTier.ListData:GetItem(1):SetText(Resource[language][158]);
		self.FilterPanel.TypeScholarNodeTier.ListData:GetItem(2):SetText(Resource[language][159].." 1");
		self.FilterPanel.TypeScholarNodeTier.ListData:GetItem(3):SetText(Resource[language][159].." 2");
		self.FilterPanel.TypeScholarNodeTier.ListData:GetItem(4):SetText(Resource[language][159].." 3");
		self.FilterPanel.TypeScholarNodeTier.ListData:GetItem(5):SetText(Resource[language][159].." 4");
		self.FilterPanel.TypeScholarNodeTier.ListData:GetItem(6):SetText(Resource[language][159].." 5");
		self.FilterPanel.TypeScholarNodeTier.ListData:GetItem(7):SetText(Resource[language][159].." 6");

		RefreshMap();
	end

	self.Map:SetSize(mapInfo[self.CurrentMapID][4],mapInfo[self.CurrentMapID][5]);
	self.Map:SetBackground(mapInfo[self.CurrentMapID][3]);
	self.Map:SetStretchMode(1);
	self.Map:SetSize(self:GetSize());
	self.CloseButton:SetLeft(self:GetWidth()-20);
	self.Map.IconList:SetHeight(self.SearchPanel:GetHeight()-45);
	self.Map.IconList.VScroll:SetHeight(self.Map.IconList:GetHeight());
	self.Map.IconSearch:SetWantsUpdates(false);
end

function AddPing(EWCoord,NSCoord,Name,Description)
	local tmpAnnotIndex;
	local tmpIndex;
	local tmpName=string.lower(tostring(Name));
	local tmpAnnotName;
	local pos;
	local found=false;
	for tmpIndex=1,#annotations do
		if annotations[tmpIndex][1]==mapWindow.CurrentMapID then
			if annotations[tmpIndex][6]~=nil then
				tmpAnnotName=mapStrings[language][annotations[tmpIndex][6]];
			else
				tmpAnnotName=annotations[tmpIndex][7];
			end
			if tmpAnnotName~=nil then
				pos=string.find(tmpAnnotName,":",1,true);
				if pos~=nil then
					tmpAnnotName=string.lower(string.sub(tmpAnnotName,1,pos-1));
				else
					tmpAnnotName=string.lower(tmpAnnotName);
				end
				if tmpName==tmpAnnotName then
					if math.abs(EWCoord-annotations[tmpIndex][2])<1 and math.abs(NSCoord-annotations[tmpIndex][3])<1 then
						-- same name and same basic area, treat as same annotation
						found=true;
						tmpAnnotIndex=tmpIndex;
						break;
					end
				end
			end
		end
	end
	if not found then
		-- need to insert criteria as a new annotation
		tmpAnnotIndex=#annotations+1
		annotations[tmpAnnotIndex]={mapWindow.CurrentMapID,EWCoord,NSCoord,5,1,nil,Name..": "..Description,0,0,0,0}
		RefreshMap();
		annotWindow.LoadAnnotationList();
	end
	if not mapWindow:IsVisible() then
		mapWindow:SetVisible(true);
		minWindow:SetVisible(false);
		quickWindow:SetVisible(quickWindow.Displayed);
	end
	-- and activate a "ping" for it
	mapWindow.Map.Ping:SetZOrder(101+#mapWindow.Map.Icons);
	mapWindow.Map.Ping:SetPosition(math.floor((annotations[tmpAnnotIndex][3]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-11.5),math.floor((annotations[tmpAnnotIndex][2]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-11.5));
	mapWindow.Map.Ping.State=1;
	mapWindow.Map.Ping:SetVisible(true);
	mapWindow.Map.Ping:SetWantsUpdates(true);
end
function RefreshMap(MapID)
	local tmpIndex;
	if MapID==nil then MapID=mapWindow.CurrentMapID end
	if debug then Turbine.Shell.WriteLine("mapWindow.CurrentMapID="..tostring(mapWindow.CurrentMapID)) end
	if MapID~=mapWindow.CurrentMapID then
		-- if we ever start supporting other maps, THIS is where we would load the background and annotations for a new map
		if MapID~=0 then
			-- we use MapID=0 to force a reload of the annotations
			mapWindow.CurrentMapID=MapID;
		end
		mapWindow.PreserveMapID=true;
		-- load the plugin that will unload and reload this plugin (we can only read the annotation files without a 15 second delay while we are "loading")
		Turbine.PluginManager.LoadPlugin("MoorMapLoader");
	else

		-- clear out the existing search list
		while mapWindow.Map.IconList:GetItemCount()>0 do
			-- clear the event handler
			mapWindow.Map.IconList:GetItem(1).MouseClick=nil;
			mapWindow.Map.IconList:RemoveItemAt(1);
		end
		LoadMapsIns(); -- we load these first so that we can check them for annotations of type=8

		local XScale=mapWindow:GetWidth()/mapInfo[mapWindow.CurrentMapID][4];
		local YScale=mapWindow:GetHeight()/mapInfo[mapWindow.CurrentMapID][5];

		XScale=1; -- turns out, the parent in Stretchmode=1 automatically takes care of it's children :)
		YScale=1; -- I'm leaving the scaling variables in just in case I ever decide to display icons using the plugin window instead of the map control as parent

		local HFactor=mapInfo[mapWindow.CurrentMapID][6];
		local HOffset=mapInfo[mapWindow.CurrentMapID][7];
		local VFactor=mapInfo[mapWindow.CurrentMapID][8];
		local VOffset=mapInfo[mapWindow.CurrentMapID][9];
		local tmpIconIndex=0;
		local tmpDescription;
		local tmpShortDescription;
		local pos1;
		local tmpList={};
		local tmpVisible;

		for tmpIndex=1,#annotations do
			if annotations[tmpIndex][1]==mapWindow.CurrentMapID then
				tmpIconIndex=tmpIconIndex+1;
				-- check if we need a new control
				if tmpIconIndex>#mapWindow.Map.Icons then
					mapWindow.Map.Icons[tmpIconIndex]=Turbine.UI.Control();
					mapWindow.Map.Icons[tmpIconIndex]:SetParent(mapWindow.Map)
					mapWindow.Map.Icons[tmpIconIndex]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
				end
				mapWindow.Map.Icons[tmpIconIndex]:SetBackColor(Turbine.UI.Color(0,0,0,0));
				mapWindow.Map.Icons[tmpIconIndex]:SetBackColorBlendMode(8);
				mapWindow.Map.Icons[tmpIconIndex]:SetZOrder(100);

				mapWindow.Map.Icons[tmpIconIndex]:SetSize(iconInfo[annotations[tmpIndex][4]][2],iconInfo[annotations[tmpIndex][4]][3]);
				mapWindow.Map.Icons[tmpIconIndex]:SetBackground(iconInfo[annotations[tmpIndex][4]][4]);

				mapWindow.Map.Icons[tmpIconIndex]:SetPosition(math.floor((annotations[tmpIndex][3]*HFactor+HOffset)*XScale)-iconInfo[annotations[tmpIndex][4]][2]/2,math.floor((annotations[tmpIndex][2]*VFactor+VOffset)*YScale)-iconInfo[annotations[tmpIndex][4]][3]/2);

				-- need to test filters
				tmpVisible=true;
				if annotations[tmpIndex][5]==2 then
					if not mapWindow.FilterPanel.AllegianceCreep:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][5]==3 then
					if not mapWindow.FilterPanel.AllegianceFreep:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][5]==4 then
					if not mapWindow.FilterPanel.AllegianceDelving:IsChecked() then tmpVisible=false end
				end

				if annotations[tmpIndex][4]==1 then
					if not mapWindow.FilterPanel.TypeMain:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==2 then
					if not mapWindow.FilterPanel.TypeSecondary:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==3 then
					if not mapWindow.FilterPanel.TypeBase:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==4 then
					if not mapWindow.FilterPanel.TypeOutpost:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==5 then
					if not mapWindow.FilterPanel.TypePOI:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==6 then
					if not mapWindow.FilterPanel.TypeFort:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==7 then
					if not mapWindow.FilterPanel.TypeRez:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==8 or annotations[tmpIndex][4]==9 or annotations[tmpIndex][4]==10 or annotations[tmpIndex][4]==12 then
					if not mapWindow.FilterPanel.TypeMap:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==11 then
					if not mapWindow.FilterPanel.TypeNPC:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==46 then
					if not mapWindow.FilterPanel.TypeCook:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==48 then
					if not mapWindow.FilterPanel.TypeScholarIngredient:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==14 then
					if not mapWindow.FilterPanel.TypeAuctioneer:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==15 then
					if not mapWindow.FilterPanel.TypeBarber:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==16 then
					if not mapWindow.FilterPanel.TypeBard:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==17 then
					if not mapWindow.FilterPanel.TypeCampSite:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==18 then
					if not mapWindow.FilterPanel.TypeCraftSite:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==20 then
					if not mapWindow.FilterPanel.TypeCraftVendor:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==49 then
					if not mapWindow.FilterPanel.TypeDungeon:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==21 then
					if not mapWindow.FilterPanel.TypeFactionRep:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==25 then
					if not mapWindow.FilterPanel.TypeItemMaster:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==26 then
					if not mapWindow.FilterPanel.TypeMailbox:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==27 then
					if not mapWindow.FilterPanel.TypeMilestone:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==47 then
					if not mapWindow.FilterPanel.TypeMusteringHorn:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==32 then
					if not mapWindow.FilterPanel.TypeReflectingPool:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==33 then
					if not mapWindow.FilterPanel.TypeSettlement:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==34 then
					if not mapWindow.FilterPanel.TypeStableMaster:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==35 then
					if not mapWindow.FilterPanel.TypeTownCrier:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==37 then
					if not mapWindow.FilterPanel.TypeTrader:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==38 then
					if not mapWindow.FilterPanel.TypeTrainer:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==39 then
					if not mapWindow.FilterPanel.TypeVaultKeeper:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==40 then
					if not mapWindow.FilterPanel.TypeVendor:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==42 then
					if not mapWindow.FilterPanel.TypeSkirmishCamp:IsChecked() then tmpVisible=false end
--*** this is where the Tier test needs to be annotations[tmpIndex][8]
				elseif annotations[tmpIndex][4]==43 then
					if not (mapWindow.FilterPanel.TypeOreNode:IsChecked() and (mapWindow.FilterPanel.TypeOreNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeOreNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				elseif annotations[tmpIndex][4]==44 then
					if not (mapWindow.FilterPanel.TypeWoodNode:IsChecked() and (mapWindow.FilterPanel.TypeWoodNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeWoodNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				elseif annotations[tmpIndex][4]==45 then
					if not (mapWindow.FilterPanel.TypeScholarNode:IsChecked() and (mapWindow.FilterPanel.TypeScholarNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeScholarNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				end
				mapWindow.Map.Icons[tmpIconIndex]:SetVisible(tmpVisible);

				mapWindow.Map.Icons[tmpIconIndex].AnnotationIndex=tmpIndex;
				mapWindow.Map.Icons[tmpIconIndex].IconIndex=annotations[tmpIndex][4];
				tmpDescription=annotations[tmpIndex][7]; -- use custom text by default
				if tmpDescription==nil or tmpDescription=="" then
					if annotations[tmpIndex][6]~=nil then
						if mapStrings[language][annotations[tmpIndex][6]]~=nil then
							tmpDescription=mapStrings[language][annotations[tmpIndex][6]]; -- use translated text if found
						elseif Resource[1][annotations[tmpIndex][6]]~=nil then
							tmpDescription=Resource[1][annotations[tmpIndex][6]]; -- fall back to english if translated text not found
						end
					end
				end
				tmpShortDescription="";
				pos1=string.find (tmpDescription,":",0,true);
				if (pos1~=nil)then
					tmpShortDescription=string.sub(tmpDescription,1,pos1-1);
					tmpDescription=string.sub(tmpDescription,pos1+1);
				end
				mapWindow.Map.Icons[tmpIconIndex].Description=tmpDescription;
				mapWindow.Map.Icons[tmpIconIndex].ShortDescription=tmpShortDescription;
				tmpList[#tmpList+1]={tmpIndex,tmpShortDescription,1};
				if annotations[tmpIndex][2]<0 then
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=tostring(0-math.floor(annotations[tmpIndex][2]*10)/10).."S, ";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2].."("..tostring(0-math.floor(annotations[tmpIndex][2]*10)/10).."S, ";
					end
				else
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=tostring(math.floor(annotations[tmpIndex][2]*10)/10).."N, ";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2].."("..tostring(math.floor(annotations[tmpIndex][2]*10)/10).."N, ";
					end
				end
				if annotations[tmpIndex][3]<0 then
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=mapWindow.Map.Icons[tmpIconIndex].MapCoord..tostring(0-math.floor(annotations[tmpIndex][3]*10)/10).."W";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2]..tostring(0-math.floor(annotations[tmpIndex][3]*10)/10).."W)";
					end
				else
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=mapWindow.Map.Icons[tmpIconIndex].MapCoord..tostring(math.floor(annotations[tmpIndex][3]*10)/10).."E";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2]..tostring(math.floor(annotations[tmpIndex][3]*10)/10).."E)";
					end
				end
				mapWindow.Map.Icons[tmpIconIndex].XYCoord=tostring(math.floor((annotations[tmpIndex][3]*HFactor+HOffset)*XScale))..", "..tostring(math.floor((annotations[tmpIndex][2]*VFactor+VOffset)*YScale));
				if annotations[tmpIndex][4]==8 or annotations[tmpIndex][4]==9 or annotations[tmpIndex][4]==10 or annotations[tmpIndex][4]==12 then
					tmpList[#tmpList][3]=2;
					-- check whether there is a MapPoint set for this point (character must have the map in their inventory)
					local mapFound=false;
					local tmpMPIndex;
					for tmpMPIndex=1,#mapWindow.Map.MapPoints.Item do
						if mapWindow.Map.MapPoints.Item[tmpMPIndex].V==annotations[tmpIndex][2] and mapWindow.Map.MapPoints.Item[tmpMPIndex].H==annotations[tmpIndex][3] then
							mapFound=true;
							break;
						end
					end
					if mapFound then
						mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(false)
						mapWindow.Map.Icons[tmpIconIndex].MouseEnter=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=nil;

					else
						-- do we want to use the "unearned" icon?
						mapWindow.Map.Icons[tmpIconIndex].IconIndex=13;
						mapWindow.Map.Icons[tmpIconIndex]:SetBackground(iconInfo[13][4]);

						mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
						mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
							sender:SetBackground(iconInfo[sender.IconIndex][5]);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							sender:SetBackground(iconInfo[sender.IconIndex][4]);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							mapWindow.Map.HoverInfo:GetItems():Get(1):SetText(sender.ShortDescription);
							mapWindow.Map.HoverInfo:GetItems():Get(1).MouseClick=nil;
							mapWindow.Map.HoverInfo:GetItems():Get(1):SetEnabled(false);
							if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
								mapWindow.Map.HoverInfo:GetItems():Get(2):SetText(sender.MapCoord);
							else
								mapWindow.Map.HoverInfo:GetItems():Get(2):SetText("");
							end
							mapWindow.Map.HoverInfo:GetItems():Get(3):SetText("");
							mapWindow.Map.HoverInfo:GetItems():Get(3):SetEnabled(false);
							if debug then
								mapWindow.Map.HoverInfo:GetItems():Get(4):SetText(sender.XYCoord);
							end
							mapWindow.Map.HoverInfo:ShowMenu();
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil; -- dismiss the dialog
							end
							mapWindow.PopUp=PopUpDialog(sender.ShortDescription,sender.Description,4,"OK")
						end
					end


				elseif annotations[tmpIndex][4]==41 then
					tmpList[#tmpList][3]=2; -- map connector

					-- do we want to use the "unearned" icon?
					mapWindow.Map.Icons[tmpIconIndex].MapID=annotations[tmpIndex][8];
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][5]);
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][4]);
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
						-- not really sure I like this functionality
						--[[
						mapWindow.Map.HoverInfo:GetItems():Get(1):SetText(sender.ShortDescription);
						mapWindow.Map.HoverInfo:GetItems():Get(1).MapID=sender.MapID;
						mapWindow.Map.HoverInfo:GetItems():Get(1).Click=function(target)
							RefreshMap(target.MapID);
						end
						mapWindow.Map.HoverInfo:GetItems():Get(1):SetEnabled(true);
						mapWindow.Map.HoverInfo:GetItems():Get(2):SetText("");
						mapWindow.Map.HoverInfo:GetItems():Get(3):SetText("");
						mapWindow.Map.HoverInfo:GetItems():Get(3):SetEnabled(false);
						if debug then
							mapWindow.Map.HoverInfo:GetItems():Get(4):SetText("");
						end
						mapWindow.Map.HoverInfo:ShowMenu();
						]]--
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
						-- switch to the indicated map
						RefreshMap(sender.MapID);
					end
				elseif annotations[tmpIndex][4]==49 then
					tmpList[#tmpList][3]=2; -- interior location

					mapWindow.Map.Icons[tmpIconIndex].MapID=annotations[tmpIndex][8];
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][5]);
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][4]);
					end
					if mapWindow.Map.Icons[tmpIconIndex].MapID~=nil and mapWindow.Map.Icons[tmpIconIndex].MapID>0 then
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							-- not really sure I like this functionality
							--
							mapWindow.Map.HoverInfo:GetItems():Get(1):SetText(sender.ShortDescription);
							mapWindow.Map.HoverInfo:GetItems():Get(1).MapID=sender.MapID;
							mapWindow.Map.HoverInfo:GetItems():Get(1).Click=function(target)
								RefreshMap(target.MapID);
							end
							mapWindow.Map.HoverInfo:GetItems():Get(1):SetEnabled(true);
							mapWindow.Map.HoverInfo:GetItems():Get(2):SetText("");
							mapWindow.Map.HoverInfo:GetItems():Get(3):SetText("");
							mapWindow.Map.HoverInfo:GetItems():Get(3):SetEnabled(false);
							if debug then
								mapWindow.Map.HoverInfo:GetItems():Get(4):SetText("");
							end
							mapWindow.Map.HoverInfo:ShowMenu();
							--
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							-- switch to the indicated map
							RefreshMap(sender.MapID);
						end
					else
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							mapWindow.Map.HoverInfo:GetItems():Get(1):SetText(sender.ShortDescription);
							mapWindow.Map.HoverInfo:GetItems():Get(1).ShortDescription=sender.ShortDescription;
							mapWindow.Map.HoverInfo:GetItems():Get(1).Description=sender.Description;
							mapWindow.Map.HoverInfo:GetItems():Get(1).Click=function(target)
								if mapWindow.PopUp~=nil then
									mapWindow.PopUp:SetVisible(false);
									mapWindow.PopUp=nil;
								end
								mapWindow.PopUp=PopUpDialog(target.ShortDescription,target.Description,4,"OK")
							end
							mapWindow.Map.HoverInfo:GetItems():Get(1):SetEnabled(true);
							if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
								mapWindow.Map.HoverInfo:GetItems():Get(2):SetText(sender.MapCoord);
							else
								mapWindow.Map.HoverInfo:GetItems():Get(2):SetText("");
							end
							if debug then
								mapWindow.Map.HoverInfo:GetItems():Get(4):SetText(sender.XYCoord);
							end
							annotWindow:SelectAnnotation(sender.AnnotationIndex);
							if annotations[sender.AnnotationIndex][6]==nil then
								mapWindow.Map.HoverInfo:GetItems():Get(3):SetText(Resource[language][83]);
								mapWindow.Map.HoverInfo:GetItems():Get(3):SetEnabled(true);
							else
								-- we no longer allow editing default annotations (creates conflicts with updates)
								mapWindow.Map.HoverInfo:GetItems():Get(3):SetText("");
								mapWindow.Map.HoverInfo:GetItems():Get(3):SetEnabled(false);
							end
							mapWindow.Map.HoverInfo:ShowMenu();
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil; -- dismiss the dialog
							end
							mapWindow.PopUp=PopUpDialog(sender.ShortDescription,sender.Description,4,"OK")
						end
					end
				else
					if annotations[tmpIndex][4]==11 or annotations[tmpIndex][4]==14 or annotations[tmpIndex][4]==15 or annotations[tmpIndex][4]==16 or annotations[tmpIndex][4]==20 or annotations[tmpIndex][4]==21 or annotations[tmpIndex][4]==25 or annotations[tmpIndex][4]==34 or annotations[tmpIndex][4]==35 or annotations[tmpIndex][4]==37 or annotations[tmpIndex][4]==38 or annotations[tmpIndex][4]==39 or annotations[tmpIndex][4]==40 then
						tmpList[#tmpList][3]=3; -- npc
					end
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][5]);
					end
					if annotations[tmpIndex][4]==11 then
						-- can't use the backcolor mechanism because there is no way to reset the back color to undefined state for reuse
						-- color npc icons based on allegiance
						if annotations[tmpIndex][5]==2 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC_red.tga"
						elseif annotations[tmpIndex][5]==3 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC_blue.tga"
						elseif annotations[tmpIndex][5]==1 then -- netral
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC_yellow.tga"
						elseif annotations[tmpIndex][5]==4 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC_violet.tga"
						else
							mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
								sender:SetBackground(iconInfo[sender.IconIndex][4]);
							end
						end
						mapWindow.Map.Icons[tmpIconIndex]:SetBackground(mapWindow.Map.Icons[tmpIconIndex].Icon);
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							sender:SetBackground(sender.Icon);
						end

					else
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							sender:SetBackground(iconInfo[sender.IconIndex][4]);
						end
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
						mapWindow.Map.HoverInfo:GetItems():Get(1):SetText(sender.ShortDescription);
						mapWindow.Map.HoverInfo:GetItems():Get(1).ShortDescription=sender.ShortDescription;
						mapWindow.Map.HoverInfo:GetItems():Get(1).Description=sender.Description;
						mapWindow.Map.HoverInfo:GetItems():Get(1).Click=function(target)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil;
							end
							mapWindow.PopUp=PopUpDialog(target.ShortDescription,target.Description,4,"OK")
						end
						mapWindow.Map.HoverInfo:GetItems():Get(1):SetEnabled(true);
						if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
							mapWindow.Map.HoverInfo:GetItems():Get(2):SetText(sender.MapCoord);
						else
							mapWindow.Map.HoverInfo:GetItems():Get(2):SetText("");
						end
						if debug then
							mapWindow.Map.HoverInfo:GetItems():Get(4):SetText(sender.XYCoord);
						end
						annotWindow:SelectAnnotation(sender.AnnotationIndex);
						if annotations[sender.AnnotationIndex][6]==nil then
							mapWindow.Map.HoverInfo:GetItems():Get(3):SetText(Resource[language][83]);
							mapWindow.Map.HoverInfo:GetItems():Get(3):SetEnabled(true);
						else
							-- we no longer allow editing default annotations (creates conflicts with updates)
							mapWindow.Map.HoverInfo:GetItems():Get(3):SetText("");
							mapWindow.Map.HoverInfo:GetItems():Get(3):SetEnabled(false);
						end
						mapWindow.Map.HoverInfo:ShowMenu();
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
						if mapWindow.PopUp~=nil then
							mapWindow.PopUp:SetVisible(false);
							mapWindow.PopUp=nil; -- dismiss the dialog
						end
						mapWindow.PopUp=PopUpDialog(sender.ShortDescription,sender.Description,4,"OK")
					end
				end
			end
		end	
		local tmpLabel;
		mapWindow.MapSelect:SetZOrder(101+tmpIconIndex);
		-- sort list by col3 (type 1-3), then col2 (name)
		table.sort(tmpList,function(arg1,arg2) if arg1[3]<arg2[3] then return(true) else if arg1[3]==arg2[3] and arg1[2]<arg2[2] then return(true) end end end);
		local tmpType=0;
		for tmpIndex=1,#tmpList do
			if tmpList[tmpIndex][3]~=tmpType then
				-- insert headers
				tmpType=tmpList[tmpIndex][3];
				tmpLabel=Turbine.UI.Label()
				tmpLabel:SetSize(mapWindow.Map.IconList:GetWidth()-12,20);
				tmpLabel:SetBackColor(Turbine.UI.Color(.1,.1,.05));
				tmpLabel:SetForeColor(headingsColor);
				tmpLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
				tmpLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16);
				tmpLabel:SetMultiline(false);
				tmpLabel.AnnotationIndex=0;
				tmpLabel.NormalHeight=20;
				tmpLabel:SetText(Resource[language][73]);
				if tmpType==1 then
					tmpLabel:SetText(Resource[language][86])
				elseif tmpType==2 then
					tmpLabel:SetText(Resource[language][119])
				elseif tmpType==3 then
					tmpLabel:SetText(Resource[language][116])
				end
				mapWindow.Map.IconList:AddItem(tmpLabel);
			end
			tmpLabel=Turbine.UI.Label()
			tmpLabel:SetSize(mapWindow.Map.IconList:GetWidth()-12,18);
			tmpLabel:SetBackColor(mapWindow.Map.IconList:GetBackColor());
			tmpLabel:SetForeColor(listTextColor);
			tmpLabel:SetMultiline(false);
			tmpLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
			tmpLabel:SetFont(fontFace);
			tmpLabel.NormalHeight=18;
			tmpLabel:SetText(tmpList[tmpIndex][2])
			tmpLabel.AnnotationIndex=tmpList[tmpIndex][1];
			if annotations[tmpLabel.AnnotationIndex][5]==2 then
				tmpLabel:SetForeColor(Turbine.UI.Color(1,0,0));
			elseif annotations[tmpLabel.AnnotationIndex][5]==3 then
				tmpLabel:SetForeColor(Turbine.UI.Color(.35,.35,1));
			elseif annotations[tmpLabel.AnnotationIndex][5]==4 then
				tmpLabel:SetForeColor(Turbine.UI.Color(.5,.35,.7));
			end
			local tmpDescription=annotations[tmpList[tmpIndex][1]][7]; -- use custom text by default
			if tmpDescription==nil or tmpDescription=="" then
				if annotations[tmpList[tmpIndex][1]][6]~=nil then
					if mapStrings[language][annotations[tmpList[tmpIndex][1]][6]]~=nil then
						tmpDescription=mapStrings[language][annotations[tmpList[tmpIndex][1]][6]]; -- use translated text if found
					elseif Resource[1][annotations[tmpList[tmpIndex][1]][6]]~=nil then
						tmpDescription=Resource[1][annotations[tmpList[tmpIndex][1]][6]]; -- fall back to english if translated text not found
					end
				end
			end
			local tmpShortDescription="";
			local pos1=string.find (tmpDescription,":",1,true);
			if (pos1~=nil)then
				tmpShortDescription=string.sub(tmpDescription,1,pos1-1);
				tmpDescription=string.sub(tmpDescription,pos1+1);
			end
			tmpLabel.Description=tmpDescription;
			tmpLabel.ShortDescription=tmpShortDescription;
			tmpLabel.MouseClick=function(sender,args)
				if args.Button==1 then
					mapWindow.SearchPanel:SetVisible(false);
					mapWindow.Map.IconSearch:SetWantsUpdates(false);
					mapWindow.Map.Ping:SetZOrder(101+#mapWindow.Map.Icons);
					mapWindow.Map.Ping:SetPosition(math.floor((annotations[sender.AnnotationIndex][3]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-11.5),math.floor((annotations[sender.AnnotationIndex][2]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-11.5));
					mapWindow.Map.Ping.State=1;
					mapWindow.Map.Ping:SetVisible(true);
					mapWindow.Map.Ping:SetWantsUpdates(true);
				else
					if mapWindow.PopUp~=nil then
						mapWindow.PopUp:SetVisible(false);
						mapWindow.PopUp=nil;
					end
					mapWindow.PopUp=PopUpDialog(sender.ShortDescription,sender.Description,4,"OK")
				end
			end
			mapWindow.Map.IconList:AddItem(tmpLabel);
		end

		-- for a refresh of the list
		mapWindow.Map.IconSearch.OldAllegianceDelving=not mapWindow.Map.IconDelvingCB:IsChecked();
		mapWindow.Map.IconSearch.Update();

		while #mapWindow.Map.Icons>tmpIconIndex do
			-- dispose of any unused controls that we already created
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseEnter=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseLeave=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseHover=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseClick=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons]:SetVisible(false);-- need to invalidated the area where this control was draw to force a refresh
			table.remove(mapWindow.Map.Icons,#mapWindow.Map.Icons);
		end
	end
end

-- we have to use ItemControls so that we can programatically fill them if the corresponding map is found in the character's inventory
-- definately have to get French and German translations for the map names :(
-- use the "Good" grams map if found, if not, then use the default grams map if found
AddMapPoint=function(mapItem, V, H)
-- I temporarily use 4 controls to cover each map point in a 12x16 area because the mouse events for ItemControls only fire on their borders. As soon as he mouse events are fixed, I will eliminate the excess controls.
	local HFactor=mapInfo[mapWindow.CurrentMapID][6];
	local HOffset=mapInfo[mapWindow.CurrentMapID][7];
	local VFactor=mapInfo[mapWindow.CurrentMapID][8];
	local VOffset=mapInfo[mapWindow.CurrentMapID][9];

	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints+1]=Turbine.UI.Control();
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetPosition(math.floor(H*HFactor+HOffset)-9,math.floor(V*VFactor+VOffset)-9);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetSize(18,18);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]=Turbine.UI.Lotro.ItemControl();
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].V=V;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].H=H;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetPosition(-34,-34);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetSize(64,64);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetItem(mapItem);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetVisible(true);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseDown=function(sender, args)
		if args.Button==2 then
			mapWindow:SetVisible(false);
		end
	end
end
LoadMapsIns=function()
	if mapWindow.CurrentMapID==1 then
		-- search through bags looking for matches to the map names
		local tmpBackpack=localPlayer:GetBackpack();
		local tmpBPIndex;
		local tmpItem;
		local tmpCrudeGrams;
		local tmpCrudeGV;
		local addCrudeGrams=true;
		local addCrudeGV=true;
		for tmpBPIndex=1,tmpBackpack:GetSize() do
			tmpItem=tmpBackpack:GetItem(tmpBPIndex);
			if tmpItem~=nil then
				if tmpItem:GetName()==Resource[language][87] then
					tmpCrudeGrams=tmpItem;
				elseif tmpItem:GetName()==Resource[language][88] then
					addCrudeGrams=false;
					AddMapPoint(tmpItem,-12.3,-20.9);
				elseif tmpItem:GetName()==Resource[language][89] then
					AddMapPoint(tmpItem,-16.1,-20.9);
				elseif tmpItem:GetName()==Resource[language][90] then
					AddMapPoint(tmpItem,-17.1,-18.6);
				elseif tmpItem:GetName()==Resource[language][91] then
					AddMapPoint(tmpItem,-14.6,-15.8);
				elseif tmpItem:GetName()==Resource[language][92] then
					AddMapPoint(tmpItem,-13.4,-12.8);
				elseif tmpItem:GetName()==Resource[language][93] then
					AddMapPoint(tmpItem,-18.3,-18.6);
				elseif tmpItem:GetName()==Resource[language][94] then
					AddMapPoint(tmpItem,-14.2,-21.0);
				elseif tmpItem:GetName()==Resource[language][95] then
					AddMapPoint(tmpItem,-16.0,-17.0);
				elseif tmpItem:GetName()==Resource[language][96] then
					AddMapPoint(tmpItem,-17.8,-15.3);
				elseif tmpItem:GetName()==Resource[language][97] then
					AddMapPoint(tmpItem,-14.7,-14.5);
				elseif tmpItem:GetName()==Resource[language][98] then
					AddMapPoint(tmpItem,-18.9,-17.9);
				elseif tmpItem:GetName()==Resource[language][99] then
					AddMapPoint(tmpItem,-14.5,-19.1);
				elseif tmpItem:GetName()==Resource[language][100] then
					AddMapPoint(tmpItem,-17.9,-18.1);
				elseif tmpItem:GetName()==Resource[language][101] then
					AddMapPoint(tmpItem,-15.7,-14.2);
				elseif tmpItem:GetName()==Resource[language][102] then
					AddMapPoint(tmpItem,-11.5,-19.1);
				elseif tmpItem:GetName()==Resource[language][103] then
					AddMapPoint(tmpItem,-20.3,-16.8);
				elseif tmpItem:GetName()==Resource[language][104] then
					tmpCrudeGV=tmpItem;
				elseif tmpItem:GetName()==Resource[language][105] then
					addCrudeGV=false;
					AddMapPoint(tmpItem,-20.9,-13.4);
				end
			end
		end
		if addCrudeGrams and tmpCrudeGrams~=nil then
			AddMapPoint(tmpCrudeGrams,-12.3,-20.9);
		end
		if addCrudeGV and tmpCrudeGV~=nil then
			AddMapPoint(tmpCrudeGV,-20.9,-13.4);
		end
	else
	-- remove the map points
		while #mapWindow.Map.MapPoints>0 do
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseClick=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseHover=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseEnter=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseLeave=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseDown=nil;
			table.remove(mapWindow.Map.MapPoints.Item,#mapWindow.Map.MapPoints);
			table.remove(mapWindow.Map.MapPoints,#mapWindow.Map.MapPoints);

		end
	end
end

function MMWindow:SetLoadMinimized(value)
	if value==nil then value=false end;
	self.LoadMinimized=(value==true);
end
function MMWindow:GetLoadMinimized()
	return (self.LoadMinimized);
end

function MMWindow:SetEnabled(state)
	self.ControlPanel.OptionsButton:SetMouseVisible(state);
	self.ControlPanel.AnnotationsButton:SetMouseVisible(state);
end

function MMWindow:SetVisible(value)
	Turbine.UI.Lotro.Window.SetVisible( self, value );
end

function MMWindow:Update( sender, args )
	local tmpIndex;
	if loadingDefaults==1 then
		-- track the status of the Defaults plug
		for tmpIndex=1,#Turbine.PluginManager:GetLoadedPlugins() do
			if Turbine.PluginManager:GetLoadedPlugins()[tmpIndex].Name=="MoorMapDefaults" then
				loadingDefaults=2;
				break;
			end
		end
	elseif loadingDefaults==2 then
		local found=false;
		for tmpIndex=1,#Turbine.PluginManager:GetLoadedPlugins() do
			if Turbine.PluginManager:GetLoadedPlugins()[tmpIndex].Name=="MoorMapDefaults" then
				found=true;
				break;
			end
		end
		if not found then
			self:SetWantsUpdates(false);
			loadingDefaults=0;
			Turbine.PluginManager.UnloadScriptState("MoorMapTerminator");
			-- at this point, we know that the default data has been written to disk, so it is safe to refresh the map
			-- reload the map list incase new maps were loaded
			mapWindow.MapSelect:ClearList();
			CreateMapList();
			RefreshMap(0); -- this will reload the current map, but force a reload of the annotations
			annotWindow:LoadAnnotationList();
		end
	else
		if (Plugins["MoorMap"] ~= nil) and (not self.Loaded) then
			self.Loaded=true;
			Turbine.PluginManager.UnloadScriptState("MoorMapLoader");
			if not self.Refreshing then
				Turbine.Shell.WriteLine("MoorMap "..Plugins["MoorMap"]:GetVersion()..Resource[language][13]);
			end
			Plugins["MoorMap"].Unload = function(self,sender,args)
				UnloadPlugin();
			end
			-- check for defaults
			if type(mapInfo)~="table" or #mapInfo==0 then
--				-- if this fails, then load the defaults from defaults.lua
--				loadingDefaults=1;
--				Turbine.PluginManager.LoadPlugin("MoorMapDefaults");
			end
			if loadingDefaults==3 then
				self.CurrentMapID=nil;
				loadingDefaults=1;
			end
		elseif self.ExternalPing then
			self.ExternalPing=false;
			AddPing(self.PingNS,self.PingEW,self.PingName,self.PingDesc);
		else
			-- we've satisfied all update needs, turn off the updates
			self:SetWantsUpdates(false);
			if self.NeedsRefresh then
				self.NeedsRefresh=false;
				RefreshMap();
			end
		end
	end
end

CreateMapList=function()
	local tmpIndex;
	-- first, sort mapInfo alphabetically (use the current language)
	table.sort(mapInfo,function(arg1,arg2) if Resource[language][arg1[2]]<Resource[language][arg2[2]] then return(true) end end);
	-- then call AddMapListChildren(0,0)
	AddMapListChildren(0,0);
	-- resort mapInfo by first element (index)
	table.sort(mapInfo,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end);
	if mapWindow.CurrentMapID~=nil then
		for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
			if mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue==mapWindow.CurrentMapID then
				mapWindow.MapSelect:SetSelectedIndex(tmpIndex);
				break;
			end
		end
	else
		mapWindow.MapSelect:SetSelectedIndex(1); -- what's the default map?!?
	end
	-- now, set the list element default height based on the map type
	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue][11]==3 then
			mapWindow.MapSelect.ListData:GetItem(tmpIndex):SetForeColor(Turbine.UI.Color(.7,.7,0));
			mapWindow.MapSelect.ListData:GetItem(tmpIndex):SetHeight(0);
		end		
	end

	-- this isn't perfect, but it allows the "interior" maps to show up only after the parent has been moused over, keeping the map list limitted.
	-- the biggest issue is it causes the map list to "jump" under the cursor when child maps above the currently hovered over map get hidden. it would be better if I could get the list to scroll the correct number of entries to keep the current entry under the mouse
	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		mapWindow.MapSelect.ListData:GetItem(tmpIndex).MouseHover = function(sender)
			local tmpIndex2
			for tmpIndex2=1,mapWindow.MapSelect.ListData:GetItemCount() do
				if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex2).DataValue][10]==sender.DataValue then
					mapWindow.MapSelect.ListData:GetItem(tmpIndex2):SetHeight(20);
				else
					if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex2).DataValue][11]==3 then
						mapWindow.MapSelect.ListData:GetItem(tmpIndex2):SetHeight(0);
					end		
				end		
			end
		end		
	end
end
AddMapListChildren=function(parent,indent)
	local tmpIndex;
	for tmpIndex=1,#mapInfo do
		if mapInfo[tmpIndex][10]==parent then
			mapWindow.MapSelect:AddItem(string.rep(" ", indent*4)..Resource[language][mapInfo[tmpIndex][2]],mapInfo[tmpIndex][1]);
			AddMapListChildren(mapInfo[tmpIndex][1],indent+1);
		end
	end
end
ResolveMap=function(region,NS,EW)
-- this function returns a table with all of the map IDs that match the region and coordinates
	local tmpMap={};
	local tmpIndex;
	region=tonumber(region);
	NS=tonumber(NS);
	EW=tonumber(EW);
	for tmpIndex=1,#mapInfo do
		if mapInfo[tmpIndex][12]==region then -- same region
			if debug then
				Turbine.Shell.WriteLine("tmpIndex="..tonumber(tmpIndex)..", NS="..tostring(NS)..", EW="..tostring(EW))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][13]="..tonumber(mapInfo[tmpIndex][13]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][15]="..tonumber(mapInfo[tmpIndex][15]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][14]="..tonumber(mapInfo[tmpIndex][14]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][16]="..tonumber(mapInfo[tmpIndex][16]))
			end
			if mapInfo[tmpIndex][13]>=NS and mapInfo[tmpIndex][15]<=NS and mapInfo[tmpIndex][14]<=EW and mapInfo[tmpIndex][16]>=EW then
				-- coordinates fall on this map
				tmpMap[#tmpMap+1]=tmpIndex;
			end
		end
	end
	return tmpMap;
end

LoadData();

mapWindow=MMWindow();
mapWindow:SetZOrder(mapWindow:GetZOrder()+1);
minWindow=MinimizedWindow();
if mapWindow:GetShowIconWhenMinimized() then
	minWindow:SetSize(32,32);
else
	minWindow:SetSize(0,0);
end

if priorDataVersion~=Plugins["MoorMap"]:GetVersion() then
	-- need to read the "default data" and merge with existing data
	loadingDefaults=3;
	mapWindow:SetWantsUpdates(true);
	Turbine.PluginManager.LoadPlugin("MoorMapDefaults");
else
	CreateMapList();
	RefreshMap();
end

if mapWindow.LoadMinimized and (not mapWindow.Refreshing) then
	minWindow:SetVisible(true);
else
	mapWindow:SetVisible(true);
end
quickWindow:SetVisible(quickWindow.Displayed);

optWindow=OptionsWindow();
annotWindow=AnnotationsWindow();

optWindow:SetZOrder(mapWindow:GetZOrder()+1);
annotWindow:SetZOrder(mapWindow:GetZOrder()+1);

if dataLoadError then
	-- warn the user and give them the opportunity to exit without saving
end

-- inventory tables have the following structure
-- -- [1] index in backpack
-- -- [2] item durability
-- -- [3] item quality
-- -- [4] item wearstate
-- -- [5] item Name (singular name, we don't have access to plurals yet)
-- -- [6] item quantity
-- -- [7] table of individual quantities (only valid for AllItemArray
-- -- [7][x][1] Character Index - index into characterListArray
-- -- [7][x][2] Quantity
-- -- [8] icon background resource id
-- -- [9] icon image resource id
-- -- [10] icon quality resource id (not currently used)
-- -- [11] icon shadow resource id (not currently used)
-- -- [12] icon underlay image resource id (not currently used)
-- -- [13] image category

--GaranStuff.MoorMap.Table.Dump(_G)
--testdialog=PopUpDialog("test1","just testing with a really long message to see how multiple lines are handled. let's see how it handles 3 lines. and now, the coup-de-gras, let's give it 4 lines :)",3,"abcdefghi","just testing","hmmmm")
--testdialog=PopUpDialog("test1","just testing",3,"abcdefghi","just testing","hmmmm")
--testdialog.Buttons[2].Click=function(sender)
--	Turbine.Shell.WriteLine("button 2 pressed");
--	sender:GetParent():SetVisible(false);
--end
